unit uAngle;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, ColorGrd, Buttons, shellAPI;

type
  TfmAngle = class(TForm)
    GroupBox1: TGroupBox;
    rb3Points: TRadioButton;
    rbSommet: TRadioButton;
    edNoms3Points: TEdit;
    lblNomsPoints: TLabel;
    lblExemple: TLabel;
    Label1: TLabel;
    edSommet: TEdit;
    lblAngleDebut: TLabel;
    lblAngleFin: TLabel;
    edAngleDebut: TEdit;
    edAngleFin: TEdit;
    lblDegre: TLabel;
    GroupBox2: TGroupBox;
    sbAngle1: TSpeedButton;
    sbAngle1Barre1: TSpeedButton;
    sbAngle1Barre2: TSpeedButton;
    sbAngle2: TSpeedButton;
    sbAngle2Barre1: TSpeedButton;
    sbAngle2Barre2: TSpeedButton;
    sbAngleDroit: TSpeedButton;
    rgEpaisseur: TRadioGroup;
    Panel3: TPanel;
    Panel2: TPanel;
    Panel1: TPanel;
    GroupBox3: TGroupBox;
    ColorGrid1: TColorGrid;
    GroupBox4: TGroupBox;
    rbAngleSimple: TRadioButton;
    rbAngleOrientePositif: TRadioButton;
    Label2: TLabel;
    edTaille: TEdit;
    udTaille: TUpDown;
    sbAngleSimple: TSpeedButton;
    sbAngleOrientePositif: TSpeedButton;
    btAnnuler: TButton;
    btOK: TButton;
    rbAngleOrienteNegatif: TRadioButton;
    sbAngleOrienteNegatif: TSpeedButton;
    Memo1: TMemo;
    Image1: TImage;
    Label3: TLabel;
    btnAide: TButton;
    procedure rbAngleSimpleClick(Sender: TObject);
    procedure rbAngleOrientePositifClick(Sender: TObject);
    procedure sbAngleSimpleClick(Sender: TObject);
    procedure sbAngleOrientePositifClick(Sender: TObject);
    procedure rbAngleOrienteNegatifClick(Sender: TObject);
    procedure sbAngleOrienteNegatifClick(Sender: TObject);
    procedure rb3PointsClick(Sender: TObject);
    procedure rbSommetClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnAideClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  fmAngle: TfmAngle;

implementation

uses uDessin;

{$R *.DFM}

procedure TfmAngle.rbAngleSimpleClick(Sender: TObject);
begin
   sbAngleSimple.Down:=rbAngleSimple.Checked;
end;

procedure TfmAngle.rbAngleOrientePositifClick(Sender: TObject);
begin
   sbAngleOrientePositif.Down:=rbAngleOrientePositif.Checked;
end;

procedure TfmAngle.sbAngleSimpleClick(Sender: TObject);
begin
   rbAngleSimple.Checked:=sbAngleSimple.Down;
end;

procedure TfmAngle.sbAngleOrientePositifClick(Sender: TObject);
begin
   rbAngleOrientePositif.Checked:=sbAngleOrientePositif.Down;
end;

procedure TfmAngle.rbAngleOrienteNegatifClick(Sender: TObject);
begin
   sbAngleOrienteNegatif.Down:=rbAngleOrienteNegatif.Checked;
end;

procedure TfmAngle.sbAngleOrienteNegatifClick(Sender: TObject);
begin
   rbAngleOrienteNegatif.Checked:=sbAngleOrienteNegatif.Down;
end;

procedure TfmAngle.rb3PointsClick(Sender: TObject);
begin
   Label1.Enabled:=false;
   lblAngleDebut.Enabled:=false;
   lblAngleFin.Enabled:=false;
   lblDegre.Enabled:=false;
   edSommet.Enabled:=false;
   edAngleDebut.Enabled:=false;
   edAngleFin.Enabled:=false;
   lblNomsPoints.Enabled:=true;
   lblExemple.Enabled:=true;
   edNoms3Points.Enabled:=true;
end;

procedure TfmAngle.rbSommetClick(Sender: TObject);
begin
   Label1.Enabled:=true;
   lblAngleDebut.Enabled:=true;
   lblAngleFin.Enabled:=true;
   lblDegre.Enabled:=true;
   edSommet.Enabled:=true;
   edAngleDebut.Enabled:=true;
   edAngleFin.Enabled:=true;
   lblNomsPoints.Enabled:=false;
   lblExemple.Enabled:=false;
   edNoms3Points.Enabled:=false;
end;

procedure TfmAngle.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    if key=vk_Escape then close;
end;

procedure TfmAngle.btnAideClick(Sender: TObject);
begin
   Aide(39);
end;

end.
