unit uApropos;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

type
  TfmApropos = class(TForm)
    Image1: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    procedure FormShow(Sender: TObject);
    procedure Label4Click(Sender: TObject);
    procedure Label1Click(Sender: TObject);
    procedure Label6Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

  function ApplicationVersion: String;

var
  fmApropos: TfmApropos;

implementation

{$R *.DFM}

uses ShellAPI;

function ApplicationVersion: String;
    var
      VerInfoSize, Dummy: DWord;
      VerInfo: Pointer;
      VerValueSize: DWord;
      VerValue: PVSFixedFileInfo;
    begin
      VerInfoSize:=GetFileVersionInfoSize(PChar(ParamStr(0)), Dummy);
      If VerInfoSize<>0 then
      begin
        GetMem(VerInfo, VerInfoSize);
        GetFileVersionInfo(PChar(ParamStr(0)), 0, VerInfoSize, VerInfo);
        VerQueryValue(VerInfo, '\', Pointer(VerValue), VerValueSize);
        with VerValue^ do
        begin
          Result:=''+IntTostr(dwFileVersionMS shr 16);
          Result:=Result+'.'+IntTostr(dwFileVersionMS and $FFFF);
          Result:=Result+'.'+IntTostr(dwFileVersionLS shr 16);
          Result:=Result+'.'+IntTostr(dwFileVersionLS and $FFFF);
        end;
        FreeMem(VerInfo, VerInfoSize);
      end
      else
        Result:='Version Inconnue';
    end;


procedure TfmApropos.FormShow(Sender: TObject);
begin
   Label1.caption:='Voir le site de Sine qua non';
//   Label2.caption:='Version 1.5 - 25 novembre 2002';
//   Label2.caption:='Version 1.5 - 27 janvier 2003';  //courbe point par point qui s'enregistre
//   Label2.caption:='Version 1.5 - 19 fvrier 2003';  //actualisation de TMin et TMax au changement de courbe paramtre
//   Label2.caption:='Version 1.5 - 19 mai 2003';   //noms des axes Ox et Oy
//26/05/2003 : correction du cadre autour du dessin qui, lorsque dcoch, faisait disparatre les traits !
//   Label2.Caption:='Version 1.5 - 6 juin 2003';   //papier millimtr
//5/06/2003 : correction bug : il tait possible de modifier les textes des mmos dans certaines fentres

// Label2.Caption:='Version 2.0 - 2 septembre 2003';   //VERSION 2 : statistiques  1 ou 2 variables
// Label2.Caption:='Version 2.0 - 10 septembre 2003';   //enregistrement des prfrences dans dossier "mes documents"
// Label2.Caption:='Version 2.0 - 11 septembre 2003';   //correction bug Fichier/Nouveau qui ne rafrachissait pas l'cran
//10/09/2003 : le fichier des prfrences est dsormais nomm preferences_sqn.txt et enregistr dans le dossier "mes documents"
// Label2.caption:='Version 2.0 - 17 septembre 2003';   //dplacement des textes avec le clavier (alt + flches)
// Label2.caption:='Version 2.0 - 27 septembre 2003';   //bug : l'paisseur des axes n'tait pas prise en compte
// Label2.caption:='Version 2.0 - 10 octobre 2003';   //bug : erreur dans l'enregistrement lorsque le dessin contient une courbe dessine point par point
// Label2.caption:='Version 2.0 - 29 octobre 2003';  //amlioration : vrification de la syntaxe juste aprs
                                                      //la saisie d'une fonction dans un bloc try except
//   Label2.caption:='Version 2.0 - 30 octobre 2003';  //utilisation d'un bloc try except pour le chargement des prfrences
//   Label2.caption:='Version 2.0 - 4 novembre 2003'  //bug : initialisation par dfaut pas faite au cas o le fichier prfrences n'existe pas
//   Label2.caption:='Version 2.0 - 7 novembre 2003';  //amlioration : visualisation ou non des paramtres statistiques (1 var)
//   Label2.caption:='Version 2.0 - 13 novembre 2003';   //amlioration : ajout des lois de probabilit Binomiale et Poisson
// Label2.caption:='Version 2.0 - 14 novembre 2003';     //corrections bugs lorsqu'on "efface tout" dans les donnes stats ou proba
// Label2.caption:='Version 2.1 - 17 novembre 2003';   //amlioration : ajout de la loi normale
// Label2.caption:='Version 2.1 - 27 novembre 2003';   //amlioration : ajout des suites numriques
// Label2.caption:='Version 2.1 - 2 dcembre 2003';   //bug : comportement du repre dans les statistiques  une variable
// Label2.caption:='Version 2.1 - 3 dcembre 2003';   //bug : les hauteurs des barres dans l'histogramme des sries statistiques
                                                      // une variable n'taient pas toujours tout  fait correcte
                                                      //Amlioration : possibilit d'afficher les effectifs
// Label2.caption:='Version 2.1 - 4 dcembre 2003';   //bug corrig lorsqu'on annule la commande "Ouvrir"
// Label2.caption:='Version 2.1 - 8 janvier 2004';   //bug corrig dans le dessin d'une demi droite (violation d'accs)
// Label2.caption:='Version 2.1 - 10 janvier 2004';   //bug corrig lorsqu'on essayait de choisir papier millimtr dans les prfrences
// Label2.caption:='Version 2.1 - 8 fvrier 2004';  //bug corrig : suppression de "\"  la fin du rpertoire "Mes documents" et de CheminDepart
                                                    //lorsque celui-ci est un disque (virtuel ou non)
// Label2.caption:='Version 2.1 - 17 fvrier 2004';  //amlioration : calcul d'une intgrale
// Label2.Caption:='Version 2.1 - 18 fvrier 2004';  //amlioration : botes  moustaches avec ou sans dciles
// Label2.Caption:='Version 2.1 - 5 mars 2004'; //amlioration : frquences cumules croissantes et/ou dcroissantes
// Label2.Caption:='Version 2.1 - 21 avril 2004'; //amlioration : la copie d'un dessin dans word se fait maintenant sous
                                                  //forme vectorielle (EMF) et non plus sou forme de bitmap (BMP)
// Label2.Caption:='Version 2.1 - 31 mai 2004'; //correction bug dans le calcul de p(X>=k) pour une loi de Poisson
                                                //correction bug : affichage des rsultats (lois binomiale et Poisson) en dehors de la zone permise
// Label2.Caption:='Version 2.1 - 6 juillet 2004';//nouvelles fonctionalits : botes  moustaches multiples
     //et ajout de menus contextuels (bouton droit de la souris) pour permettre de couper/copier/coller/imprimer
     //les donnes ou les calculs statistiques (une ou deux variables) et les valeurs d'une suite
// Label2.Caption:='Version 2.2 - 3 octobre 2004';//Nouvelles fonctionnalits : schma avec polygones
// Label2.Caption:='Version 2.2 - 27 octobre 2004'; //correction bug dans l'affichage sous word des "autres polygones"
// Label2.Caption:='Version 2.2 - 28 octobre 2004'; //amlioration : on peut prciser le nombre maximal de chiffres
                                                    //significatifs dans les graduations du repre avant de passer en notation scientifique
// Label2.caption:='Version 2.2 - 7 novembre 2004';//amlioration : on peut dfinir le diamtre des points (courbes pointilles)
// Label2.caption:='Version 2.2 - 3 dcembre 2004';//correction bug : dans certains cas de calculs statistiques  2 variables
                                                    //on avait une division par zro.
// Label2.caption:='Version 2.2 - 4 dcembre 2004';//correction bug : lorsqu'une courbe avait un point d'arrt, les noms des points particuliers
     //sur la courbe taient dessins sous forme de rectangles pleins
// Label2.caption:='Version 2.2 - 18 dcembre 2004';//ajout de raccourcis clavier Ctrl+N, Ctrl+S etc ... pour certaines commandes de menu
                                                    //il n'est plus possible de placer l'origine ed dehors du cadre
// Label2.caption:='Version 2.2 - 20 dcembre 2004';//correction bug "transtypage de classe incorrect" aprs la modif du 18//12
// Label2.caption:='Version 2.2 - 23 dcembre 2004';//amlioration : dsormais lorsqu'un "texte" ajout dans la figure est de la forme
    //A1 ou f0 (2 caractres dont le second est un chiffre), alors le second caractre est affich en indice
    //De mme, les mots "Cf", "Cg" et "Ch", frquemment utiliss pour nommer des courbes sont affichs d'une faon particulire :
    // -le premier caractre est crit dans la police, la taille et le style choisi par l'utilisateur
    // -le second caractre est crit en indice, Times New Roman, italique, en (taille-2)
// Label2.caption:='Version 2.2 - 25 dcembre 2004';//Correction bug : les textes crits verticalement (en particulier pour les lois
    //binomiale et de Poisson, taient affichs horizontalement dans le presse-papier (metafile)
// Label2.caption:='Version 2.2 - 28 dcembre 2004';//amlioration : les exposants fractionnaires dont le dnominateur
                 //est IMPAIR sont accepts (par exemple x^(1/3) ou x^(-2/3)), mme pour x ngatif...
// Label2.Caption:='Version 2.2 - 5 janvier 2005';//amlioration : il est maintenant possible de dfinir la police de caractres
                 //pour les noms des points dans les schemas. De plus, si le nom comporte 2 caractres le second caractre
                 //est inprim en indice (sauf s'il s'agit d'une 'prime')
// Label2.Caption:='Version 2.2 - 7 janvier 2005';//correction bug : lorsqu'on copiait un dessin dans un document Word,
                 //le bord droit et le bord bas du cadre n'taient pas dessins.
// Label2.Caption:='Version 2.2 - 29 janvier 2005';//correction bug :le nombre de chiffres significatifs pour les units
                 //sur les axes n'tait pas enregistr.
// Label2.Caption:='Version 2.2 - 24 mars 2005';//correction bug :les calculs sur la loi binomiale B(n,p) taient faux
                 //lorsque n tait trop grand (au-del de 30  35)
// Label2.caption:='Version 2.2 - 3 avril 2005';//correction bug sur les calculs statistiques  une variable : dans certains cas
                 //la variance tait ngative au lieu d'tre nulle (-2.5E-13 par exemple) ce qui provoquait une erreur sur l'cart type ...
// Label2.caption:='Version 2.2 - 4 avril 2005';//Correction du mme bug pour les statistiques  2 variables
// Label2.caption:='Version 2.2 - 20 avril 2005';//ajout de nouvelles prfrences (format des courbes)
                 //ajout d'une option supplmentaire pour les familles de courbes : couleurs multiples
// Label2.caption:='Version 2.2 - 25 avril 2005';//Ajout du titre du dessin en cours dans la barre de titre de la fentre
                 //ajout des courbes de Bzier dans le menu "dfinir/schma"
                 //ajout de nouvelles possibilits pour les segments : ils peuvent dsormais se terminer par des flches,
                 //des crochets ou des arcs et peuvent tre ferms, ouverts ou semi ouverts.
//  Label2.caption:='Version 2.2 - 26 avril 2005';//correction bug sur "courbe point par point" (erreur faite sur la version d'hier)
//  Label2.caption:='Version 2.2 - 30 avril 2005';//nouvelle fonctionnalit : courbe point par point avec lissage par courbes de Bzier
//  Label2.caption:='Version 2.2 - 1er mai 2005';//suppression de l'unit aligrid (remplace par advgrid)
//  Label2.caption:='Version 2.2 - 10 mai 2005';//nouveau menu : Calculs. Pour l'instant seule la commande "Equation..." est implmente
//  Label2.caption:='Version 2.3 - 12 mai 2005';//correction bugs : format des segments mal enregistr, navigation dans
                //la grille de saisie des courbes point par point amliore, titre du graphique statistique sur fond color
                //Nouveau : les textes peuvent tre affichs sur un fond color
//  Label2.Caption:='Version 2.3 - 15 mai 2005';//correction bugs (annuler une quation, effacement des donnes courbe point par point)
//  Label2.Caption:='Version 2.3 - 24 mai 2005';//correction bug dans le calcul d'une quation : ajout d'un bloc
               //try...except permettant d'viter un message "violation d'accs"
//  Label2.Caption:='Version 2.3 - 22 septembre 2005';//correction bug dans statistiques 1 variable. La colonne Effectifs
               //permettait de saisir des rels (frquences). Dsormais, les effectifs sont entiers
//  Label2.Caption:='Version 2.3 - 28 octobre 2005';//Nouveaut : on peut maintenant dessiner des angles (schma)
//  Label2.Caption:='Version 2.3 - 10 novembre 2005';//Nouveaut : table de valeurs pour les fonctions
//  Label2.Caption:='Version 2.3 - 13 novembre 2005';//Nouveau : la table de valeurs fonctionne aussi pour les courbes paramtres
//  Label2.Caption:='Version 2.3 - 14 novembre 2005';//correction bug : il tait impossible d'ouvrir un fichier contenant
               //des donnes statistiques 1 variable avec des valeurs isoles
//  Label2.Caption:='Version 2.3 - 15 novembre 2005';//bug : certaines donnes n'taient pas enregistres (botes  moustaches)
               //et tables de valeurs. De plus ces mmes donnes n'taient pas effaces avec "nouveau dessin".
//  Label2.Caption:='Version 2.3 - 18 novembre 2005';//bug : le repre au format "trigonomtrique" n'tait pas correctement
               //enregistr et les units de graduations se retrouvaient sous forme dcimale
//  Label2.Caption:='Version 2.3 - 8 dcembre 2005';//amlioration dans le trac d'une courbe point par point : le nombre
         //de points intermdiaires est gal  la distance en mm entre 2 points conscutifs (au poins 10 points)
//  Label2.Caption:='Version 2.3 - 1er fvrier 2006';//lgre amlioration de la fonction partie entire
         //(correction de l'erreur qui faisait que int(x)-int(-x)=3 au lieu de 2 lorsque x=1)
//  Label2.Caption:='Version 2.3 - 1er mars 2006';//bug dans l'interprtation de certaines quations de droites
         //dans la cas o l'quation est de la forme y=b+ax au lieu de y=ax+b
//  Label2.Caption:='Version 2.3 - 4 mars 2006';//bug lors de la construction d'une demi-droite dfinie par son origine
         //et son vecteur directeur
//  Label2.Caption:='Version 2.3 - 9 mars 2006';//Nouvelle commande dans le menu Fichier : on peut maintenant enregistrer
         //l'image au format bmp, jpg, emf ou wmf dans un fichier disque.
//  Label2.Caption:='Version 2.3 - 25 mars 2006';//correction bug dans l'interprtation de certaines quations de droites
         //dsormais une quation de type y=ax+b ou y=b+ax accepte les constantes calcules  conditions qu'elles soient entre parenthses
         //l'erreur a t occasionne par la correction du 1er mars 2006
//  Label2.Caption:='Version 2.3 - 30 mars 2006';//Correction bug. Lorsqu'on ouvre un dessin enregistr avec un ordinateur n'ayant
         //pas le mme rglage concernant le sparateur dcimal, il n'y a plus d'erreur.
//  Label2.Caption:='Version 2.3 - 6 avril 2006';//Amlioration : il est maintenant possible de dfinir jusqu' 10 courbes
        //point par point + 10 courbes lisses. Les dessins dj enregistrs qui contenaient une courbe dfinie point
        //par point ne sont malheureusement plus lisibles (sauf  m'envoyer le fichier pour que je le corrige manuellement)
//  Label2.Caption:='Version 2.3 - 8 avril 2006';//Bug : la commande 'nouveau dessin' n'effaait pas les courbes point par point
//  Label2.Caption:='Version 2.3 - 9 avril 2006';//Message d'alerte au oment de quitter ou de crer un nouveau dessin si on n'a pas enregistr
//  Label2.Caption:='Version 2.3 - 15 avril 2006';//Amlioration : les histogrammes reprsentant les sries statistiques regroupes en classes
       //ne sont plus forcment exprims en pourcentage. On peut choisir l'unit de surface gale  un effectif donn
//  Label2.Caption:='Version 2.3 - 21 mai 2006';//Amliorations sur les suites (style des points, Points affichs sur 2 axes
       //vitesse de trac rglable de 1  10
//  Label2.Caption:='Version 2.3 - 25 mai 2006';//Petites retouches sur les suites
//  Label2.Caption:='Version 2.3 - 28 mai 2006';//Amlioration : lorsqu'on demande une table de valeurs, on peut obtenir
               //l'affichage des points de la table sur le graphique, en choisisant le style, la taille et la couleur
//  Label2.Caption:='Version 2.3 - 29 mai 2006';//Correction oubli dans l'affichage des points dfinis dans la table des valeurs
               //seul le type "automatique" tait pris en compte, pas le type "manuel"
//  Label2.Caption:='Version 2.3 - 4 juin 2006';//Amlioration : Droite de Henry pour obtenir une estimation de la loi
               //normale qui peut approcher une distribution statistique  une variable
//  Label2.caption:='Version 2.3 - 5 juin 2006';//Amlioration : onpeut rgler la vitesse d'affichage des courbes et des
               //familles de courbes (lorsque l'option 'voir la progression' est demande)
//  Label2.caption:='Version 2.3 - 14 juin 2006';//Amlioration mineure concernant l'affichage des botes  moustaches
//  Label2.caption:='Version 2.3 - 18 juin 2006';//Amlioration : il est possible dsormais de prciser si une courbe
               //doit tre dessine ou non
//  Label2.caption:='Version 2.3 - 26 juin 2006';//Amlioration (statistiques  une variable): on pouvait reprsenter
               //les FRQUENCES cumules croissantes ou dcroissantes. On peut maintenant le faire avec les EFFECTIFS
//  Label2.caption:='Version 2.3 - 24 aot 2006';//correction bug (enregistrement incorrect dans le cas de courbes dfinies
               //point par point avec pentes lorsqu'il en y a plusieurs. De plus, les courbes,  partir de la 2e taient mal dessines.
//  Label2.caption:='Version 2.3 - 23 septembre 2006';//correction bug. Lorsqu'on dfinit une srie statistique double, la courbe
               //de rgression n'tait pas affiche.(case  cocher non coche)
//  Label2.caption:='Version 2.3 - 28 septembre 2006';//Amlioration (statistiques 1 var) On peut modifier le nombre de carreaux pour
               //l'unit de surface des histogrammes. De plus on peut afficher la mdiane seulement.
//  Label2.caption:='Version 2.3 - 30 septembre 2006';//Correction bug (statistiques 1 var). Les pointills des quartiles et dciles
               //ne sont plus dessins lorsqu'on demande la mdiane seulement...
//  Label2.Caption:='Version 2.4 - 2 octobre 2006';//Inquations et systmes d'inquations
//  Label2.Caption:='Version 2.4 - 3octobre 2006'; //traitement des oprateurs < et > pour dessiner des petits arcs
//  Label2.caption:='Version 2.4 - 4 octobre 2006';//correction bug dans quations de droite de type y=ax+b abec b=''
//  Label2.caption:='Version 2.4 - 14 octobre 2006';// ajout d'une nouvelle possiblit pour les sries statistiques doubles : droite de Mayer
//  Label2.caption:='Version 2.4 - 16 octobre 2006';//posssibilit de dfinir le nombre de points associs  G1 (droite de Mayer)
//  Label2.caption:='Version 2.4 - 19 octobre 2006';//amlioration : meilleure chelle automatique pour la loi normale
               //par ailleurs, les inquations sont maintenant effaces lorsqu'on demande un nouveau dessin
//  Label2.caption:='Version 2.4 - 23 octobre 2006';//Modification de l'initialisation des paramtres d'impression.
               //en cas d'absence d'imprimante installe, le bouton "imprimer" est inactif (bloc try except sur InitialisationCanvasSortie)
//  Label2.caption:='Version 2.4 - 2 novembre 2006';//correction bug :si l'ordinateur n'a pas d'imprimante installe,
              //la commande "copier" ne marchait pas. Maintenant elle fonctionne quand mme mais les distances ne sont pas conserves.
//  Label2.caption:='Version 2.4 - 13 novembre 2006';//correction bug : pour une droite de Mayer, les points n'taient pas forcment
              //dans l'ordre de dpart (en raison du calcul des paramtres qurtiles, dciles et mdianes pour x et y...)
//  Label2.caption:='Version 2.4 - 21 novembre 2006';//meilleur affichage des symboles d'ingalit dans la grille des inquations
              //l'option "zone solution=Zone non hachure est correctement enregistre
//  Label2.caption:='Version 2.4 - 27 novembre 2006';//amlioration. On peut maintenant enregistrer l'image au format Gif
//  Label2.caption:='Version 2.4 - 10 janvier 2007';//amlioration (affichage de l'un des 2 axes du repre)
             //et correction bug (enregistrement des courbes point par point avec lissage)
//  Label2.caption:='Version 2.4 - 17 janvier 2007';//amlioration : on peut prciser le nombre de chiffres significatifs
            //pour les coefficients de la courbe de rgression (stat  2 variables)
//  Label2.caption:='Version 2.4 - 17 fvrier 2007';//correction petit bug : les proprits distances des axes par rapport
            //aux bords de l'cran n'taient pas enregistres dans les prfrences.
//  Label2.caption:='Version 2.4 - 19 fvrier 2007';//correction bug : on ne pouvait pas dessiner de courbe point par point
            //avec lissage par courbes de Bzier comportant plus de 14 points (alors qu'il est possible d'en dfinir 20)
//  Label2.caption:='Version 2.4 - 23 fvrier 2007';//correction bug. Les noms des points apparaissaient 2 fois ...(Flash)
//  Label2.caption:='Version 2.4 - 1er mars 2007'; //correction bugs (affichage des termes d'une suite, affichage des points d'une
           //table de valeurs lorsque x n'appartient pas au domaine de dfinition ...
//  Label2.caption:='Version 2.4 - 1er mars 2007-bis';//correction bug : certaines suites provoquaient un bug encore...
//  Label2.caption:='Version 2.4 - 8 mars 2007' //Correction bug dans statistiques  1 variable : Effectifs cumuls dcroissants seuls faux
//  Label2.caption:='Version 2.4 - 25 mars 2007' //Nouveau : dsormais les dessins sont dsormais enregistrs avec l'extension .sqn par dfaut
           //l'extension .txt est toujours accepte naturellement. On peut ouvrir un fichier sqn en double-cliquant directement dessus
//  Label2.caption:='Version 2.4 - 1 avril 2007'; //Nouveau : comme pour les fonctions ou les courbes paramtres,
           //des cases  cocher ont t ajoutes pour prciser si les droites doivent tre dessines. Idem pour le schma.
//  Label2.caption:='Version 2.4 - 17 avril 2007';//amlioration. On peut maintenant enregistrer l'image au format Png
//  Label2.caption:='Version 2.4 - 18 avril 2007';//Nouveau : on peut dsormais illustrer l'approche d'une intgrale par la mthode
           //des rectangles. (menu Calculs)
//  Label2.caption:='Version 2.4 - 19 avril 2007';//amlioration : le calcul approch d'une intgrale peut se faire au choix, soit
          //par encadrement avec des rectangles, soit, par rectangles point-milieu, soit par des trapzes                         .
//  Label2.caption:='Version 2.4 - 28 avril 2007';//amlioration : la position du nom d'un point se fait par choix sur des boutons
          //radios disposs en cercle (schma et points particuliers des courbes).
          //correction bug : on n'aura plus de nom de fichier image gif.gif ou png.png ...Meilleure gestion de l'enregistrement des images
          //correction bug : la taille des points est conserve lorsqu'on cre un nouveau point
          //amlioration : on peut voir la liste des fonctions diponibles et mme cliquer sur l'une d'elles
//  Label2.caption:='Version 2.4 - 30 avril 2007';//correction bug (encore le problme du nom de l'image gif.gif)
//  Label2.caption:='Version 2.4 - 03 mai 2007';//bug : les styles "souligns" ou "barrs" n'taient pas pris en compte
          //lors de l'enregistrement. De ce fait, aucun style n'tait enregistr et il se produisait une erreur  l'ouverture du fichier.
//  Label2.caption:='Version 2.4 - 08 mai 2007';//bug : la police de caractres pour les noms des points sur un schma n'tait pas
          //correctement enregistre (seul le nom de la police tait correct, pas les attributs)
          //amlioration : la commande qui permet de dessiner un cercle de centre donn et tangent  une droite donne est enfin oprationnelle
//  Label2.caption:='Version 2.4 - 10 mai 2007';//bug dans les quations : les discontinuits de la fonction sont dsormais
          //prises en compte et les "fausses" solutions ne sont plus affiches
//  Label2.caption:='Version 2.4 - 12 mai 2007';//amliorations : dessiner le projet orthogonal d'un point sur une droite
          //ou l'image d'un point par une rotation. Une suite peut maintenant contenir jusqu' prs de 200 termes.
//  Label2.caption:='Version 2.4 - 18 mai 2007';//amlioration : toutes les fentres ont t redimensionnes afin d'assurer leur
          //visibilit sur windows vista.
//  Label2.caption:='Version 2.4 - 22 mai 2007';//correction bug : les grosseurs des points (schma)n'taient pas respectes
          //lors de l'impression ni au moment d'un coller dans word
//  Label2.caption:='Version 2.4 - 6 juin 2007'; //Nouveau : possibilit d'ajouter des textes en LaTeX
//  Label2.caption:='Version 2.4 - 12 juin 2007'; //Nouveau : possibilit de dfinir un point par ses coordonnes polaires
//  Label2.caption:='Version 2.4 - 13 juin 2007'; //correction bug cercle circonscrit ou inscrit dans un triangle aprs tentative
          //de modification d'un point
//  Label2.caption:='Version 2.4 - 18 juin 2007';//correction bug si l'un des points est l'origine, les points dfinis
          //en coordonnes polaires ne sont pas dessins.
//  Label2.caption:='Version 2.4 - 22 juin 2007';//correction bug : la fonction f dfinie par f(x)=1/3*x+4 tait traduite
          //par f(x)=1/(3*x)+4 ce qui est contraire  la convention habituelle des calculatrices. Dsormais cette fonction
          //sera traduite correctement. En revanche f(x)=1/3x+4 reste traduite par f(x)=1/(3*x)+4 (multiplication implicite prioritaire)
//  Label2.caption:='Version 2.4 - 7 juillet 2007';//correction bug : dans le cas d'un fonction dfinie sur un intervalle
          //de type [a, b] ou ]-inf, b], la tangente en b n'tait pas correctement dessine.
//  Label2.caption:='Version 2.4 - 30 juillet 2007';//amlioration : dans les lignes de saisie des fonctions ou des courbes
          //paramtres, ou des droites, le point est automatiquement remplac par le sparateur dcimal de l'ordinateur
//  Label2.caption:='Version 2.4 - 20 aot 2007';//amliorations : touches de raccourci pour dfinir un point, un vecteur ...
          //de plus on peut maintenant zoomer sur la slection (raccourci Ctrl Z)
//  Label2.caption:='Version 2.4 - 29 aot 2007';//correction bug : lorsqu'on a zoom sur la slection ou lorsqu'on a copi
          //la slection, une nouvelle slection faisait apparatre l'ancienne ...
//  Label2.caption:='Version 2.4 - 31 aot 2007';//amlioration : un second appui sur Ctrl Z annule le dernier zoom sur slection
//   Label2.caption:='Version 2.4 - 30 septembre 2007';//modification : les textes sont maintenant dessins aprs la grille
         //ainsi, ils ne sont plus masqus par une grille "papier millimtre"
//  Label2.caption:='Version 2.4 - 21 septembre 2007';//correction bug : les paramtres d'une famille de fonctions n'taient
         //pas correctement reports dans la fentre de saisie (PMin, PMax ...)
//  Label2.caption:='Version 2.4 - 26 septembre 2007';//correction bug mineur : lorsqu'on saisit plusieurs fonctions en une seule
        //fois, les paramtres n'taient pas actualiss (mais conservs en mmoire cependant)
//  Label2.caption:='Version 2.4 - 7 Octobre 2007';//correction bug : mauvaise initialisation des textes dans certains cas.

//   partir de maintenant le numro de version est incrment chaque fois que l'application est "construite" (Projet|Construire Sine qua non)
//  La page d'accueil rcupre maintenant automatiquement le n de version grce  la fonction ApplicationVersion (glane sur Developpez.com)
//  Pour le moment, je ne sais pas comment rcuprer automatiquement la date de la dernire "construction"

//  Label2.caption:=ApplicationVersion +' - 21 Octobre 2007';//amlioration de la prcision dans certains calculs (type double au lieu de single)
//  Label2.caption:=ApplicationVersion +' - 31 Octobre 2007';//possibilit de modifier un angle ou un arc (schma)
//  Label2.caption:=ApplicationVersion +' - 1er novembre 2007';  //amlioration : il n'est plus ncessaire de saisir les points dans l'ordre
         //croissant de leurs abscisses
//  Label2.caption:=ApplicationVersion +' - 19 novembre 2007';  //bug ! l'quation de droite y=-x provoquait une violation d'accs ...
//  Label2.caption:=ApplicationVersion +' - 21 novembre 2007'; //bug dans l'enregistrement du fichier des prfrences : certaines options n'taient pas enregistres
//  Label2.caption:=ApplicationVersion +' - 24 novembre 2007'; //plantage du logiciel aprs avoir enregistr une image au format emf ou wmf
//  Label2.caption:=ApplicationVersion +' - 3 dcembre 2007'; //dans une courbe dfinie point par point avec pente, les points sont rangs en ordre croissant
        //de leurs abscisses et non pas en ordre dcroissant. Le texte du mmo n'est plus partiellement masqu
//  Label2.caption:=ApplicationVersion +' - 6 dcembre 2007'; //amlioration : on peut maintenant rgler la longueur tes tirets au dixime de mm prs (de 0,1  10 mm)
        //cette commende agit sur le style "petits tirets" des droites et de la grille du repre, mais pas des courbes.
//  Label2.caption:=ApplicationVersion +' - 7 dcembre 2007'; //amlioration : on peut maintenant avoir une taille variable entre 5 m et 20 mm pour les petits carreaux
//  Label2.caption:=ApplicationVersion +' - 20 dcembre 2007';//amlioration : on peut maintenant tracer des tangentes ou des doubles flches tangentes aux points
        //des courbes dfinies point par point avec pentes
//  Label2.caption:=ApplicationVersion +' - 8 janvier 2008';//Version 2.5. Nouvelle commande importante permettant de tracer une courbe polaire
//  Label2.caption:=ApplicationVersion +' - 11 fvrier 2008';//On peut maintenant supprimer les points d'arrt sur les courbes (autres paramtres)
//  Label2.caption:=ApplicationVersion +' - 12 fvrier 2008';//Correction bug : mauvais enregistrement du diamtre des points d'arrt dans "Prfrences"
//  Label2.caption:=ApplicationVersion +' - 4 juin 2008';//Amlioration courbes paramtres : affichage de l'intervalle de t pour l'ensemble des 10 courbes
//  Label2.caption:=ApplicationVersion +' - 7 juin 2008';//Amlioration pour les fonctions : l'quation de la tangente est affiche dans l'cran "Autres options"
//  Label2.caption:=ApplicationVersion +' - 8 juin 2008';//Amlioration pour les fonctions : affichage de l'quation de la tangente sur demande de l'utilisateur
//  Label2.caption:=ApplicationVersion +' - 10 septembre 2008';//Amlioration : le nombre d'lments graphiques dans un schma n'est plus limit  255.
                                                               //Correction bug : dans certaines inquations (infrieur ou suprieur strictement), la frontire
                                                               //n'tait pas correctement interprte lorsqu'on souhaitaithachurer la zone non solution
//  Label2.caption:=ApplicationVersion +' - 18 septembre 2008'; //amlioration : le nombre de donnes statistiques  une variable (valeurs isoles) n'est plus limit  100 mais  1000
//  Label2.caption:=ApplicationVersion +' - 22 septembre 2008'; //correction bug : les signes '-' et '^' n'taient pas interprts correctement dans l'cran de saisie des fonctions avec les boutons proposs
//  Label2.caption:=ApplicationVersion +' - 3 novembre 2008'; //amlioration : on peut maintenant tracer la courbe drive ou une courbe primitive d'une fonction donne
//  Label2.caption:=ApplicationVersion +' - 6 novembre 2008'; //Correction bug sur les statistiques 1 var (valeurs isoles). Depuis que le nombre max de valeurs tait 1000 (au lieu de 100),
                              //les donnes n'taient plus enregistres et les graphiques n'taient plus rafrachis automatiquement...
//  Label2.caption:=ApplicationVersion +' - 27 novembre 2008';//Amlioration : si la grille est "petits carreaux", alors les graduations de l'axe Oy sont dcales de 1 pixels vers le haut
                                                              //pour mieux voir les signes -
//  Label2.caption:=ApplicationVersion +' - 1er dcembre 2008';//petit bug : le fichier EquationLatex.gif (temporaire) est dsormais enregistr dans le dossier personel et non plus dans le rpertoire d'installation
//  Label2.caption:=ApplicationVersion +' - 7 fvrier 2009';//petite amlioration : zoom avant/arrire avec Ctrl+molette souris
//  Label2.caption:=ApplicationVersion +' - 19 fvrier 2009';//petite amlioration : augmenter ou diminuer les units de 5 mm avec Shift+molette souris
//  Label2.caption:=ApplicationVersion +' - 4 mars 2009';//correction bug : le zoom avec la souris ne fonctionnait pas bien
//  Label2.caption:=ApplicationVersion +' - 9 juin 2009';//correction bug : les barres de dfilement taient invisibles
//  Label2.caption:=ApplicationVersion +' - 29 juin 2009';//redimensionnement de quelques fentres (fmLatex, fmPrimitive, fmDerivee)
//  Label2.caption:=ApplicationVersion +' - 9 aot 2009';//correction bug : aprs avoir ouvert la fentre des courbes paramtres, les fonctions n'taient plus dessines (variable NomVar non remise  'X')
//  Label2.caption:=ApplicationVersion +' - 17 aot 2009';//Version 2.6 Possibilit d'chelles logarithmiques sur les axes du repre
//  Label2.caption:=ApplicationVersion +' - 20 aot 2009';//export d'une image au format eps (enfin !)
//  Label2.caption:=ApplicationVersion +' - 21 aot 2009';//correction bug : l'axe Ox ne bougeait plus si l'chelle tait logarithmique sur l'axe Oy
//  Label2.caption:=ApplicationVersion +' - 22 aot 2009';//correction bug : la rsolution de l'imprimante PostScript n'tait pas prise en compte lors de l'enregistrement
                                                       //de l'image au format eps
//  Label2.caption:=ApplicationVersion +' - 23 aot 2009';//le zoom avec la molette fonctionne maintenant aussi avec des chelles logarithmiques
//  Label2.caption:=ApplicationVersion +' - 4 septembre 2009';//correction bug concernant la rgression polynomiale : certains coefficients taient mis  zro par erreur
//  Label2.caption:=ApplicationVersion +' - 15 septembre 2009';//amlioration : repre n'ayant aucune graduation
//  Label2.caption:='Version '+ApplicationVersion +' - 23 septembre 2009';//nouvelle fonction x! (x entier naturel infrieur  60)
//  Label2.caption:='Version '+ApplicationVersion +' - 3 octobre 2009';//Une nouvelle commande dans le menu ? permet de vrifier si une mise  jour est disponible
//  Label2.caption:='Version '+ApplicationVersion +' - 16 octobre 2009';//Nouveau : les rsultats d'une table de valeurs peuvent tre des fractions et les donnes manuelles des expressions calcules
//  Label2.caption:='Version '+ApplicationVersion +' - 27 octobre 2009';//correction bug : les valeurs fractionnaires ngatives, dans les tables de valeurs, ne s'affichaient pas
//  Label2.caption:='Version '+ApplicationVersion +' - 15 novembre 2009';//amlioration du trac des angles droits lorsqu'on veut faire du dessin en perspective
//  Label2.caption:='Version '+ApplicationVersion +' - 3 dcembre 2009';//petite amlioration du trac des traits de graduation sur les axes : les petites flches ne seront plus recouvertes par les traits
//  Label2.caption:='Version '+ApplicationVersion +' - 16 dcembre 2009';//petite amlioration : les polygones des effectifs cumuls sont dessins par-dessus la grille
//  Label2.caption:='Version '+ApplicationVersion +' - 13 janvier 2010';//bug : le polygone des ECC n'tait pas effac si on changeait le type de graphique statistique (1 var)
//  Label2.caption:='Version '+ApplicationVersion +' - 14 janvier 2010';//amlioration : maintenant l'information "paramtres visualiss" (stats 1 var) est enregistr avec les autres informations
//  Label2.caption:='Version '+ApplicationVersion +' - 16 janvier 2010';//amlioration : on peut maintenant envoyer un message avec le dessin en cours en pice jointe.
//  Label2.caption:='Version '+ApplicationVersion +' - 17 janvier 2010';//amlioration : la lgende, exprime en carreaux pour les surfaces des histogrammes, varie dsormais avec la taille
                                                  //des petits carreaux (et non plus fixe sur des careaux 5x5 mm)
//  Label2.caption:='Version '+ApplicationVersion +' - 12 fvier 2010';//amliorations : on peut maintenant fermer une fentre en appuyant sur la touche esc. Par ailleurs, il est possible d'obtenir
                                                  // l'cran et sur imprimante, un quadrillage "gausso-arthmtique" vierge (sans la droite de Henry). Il suffit que l'effectif total soit gal  1.
//  Label2.caption:='Version '+ApplicationVersion +' - 25 fvier 2010';//amliorations : pour les graphiques statistiques  une variable on peut choisir plus finement les paramtres  afficher
//  Label2.caption:='Version '+ApplicationVersion +' - 6 mars 2010';//amliorations des points d'arrt "ouverts" : l'arc de cercle est bien mieux dessin
//  Label2.caption:='Version '+ApplicationVersion +' - 10 mars 2010';//correction bug statistiques  1 variable : les quartiles et dciles taient mal dessins dans le cas des polygones des ECD
//  Label2.caption:='Version '+ApplicationVersion +' - 17 mars 2010';//recompilation sans modification car le fichier zip est incorrect...
//  Label2.caption:='Version '+ApplicationVersion +' - 8 juin 2010';//ajout d'une case  cocher "dessiner la srie statistique" dans la fentre de saisie des sries statistiques  1 variable.
//  Label2.caption:='Version '+ApplicationVersion +' - 22 aot 2010';//modification du style 'pointills' pour les courbes et tous les segments et figures gomtriques
                                                 //Ajout du module simulations statistiques.
//  Label2.caption:='Version '+ApplicationVersion +' - 31 aot 2010';//correction bug : pour un nouveau dessin, les donnes de simulations n'taient pas effaces.
//  Label2.caption:='Version '+ApplicationVersion +' - 25 fvrier 2012';//amliorations des sorties imprimes pour les expressions LaTeX
                                                 //ajout du module pour dessiner un arbre de probabilits
//  Label2.caption:='Version '+ApplicationVersion +' - 27 fvrier 2012';//corrections bugs dans arbre de probabilits
//  Label2.caption:='Version '+ApplicationVersion +' - 12 avril 2012';//Nettoyage du code. Suppression de tous les composants AdvStringGrid
//  Label2.caption:='Version '+ApplicationVersion +' - 3 aot 2012';//amliorations du dessin des arbres de probabilits (noms d'vnements avec indices, vraies fractions)
//  Label2.caption:='Version '+ApplicationVersion +' - 21 aot 2012';
//  Label2.caption:='Version '+ApplicationVersion +' - 15 mars 2013';//version 2.8 Tableaux de variation et de signes (Merci  Patrick Pradeau)
                                                 //amliorations des icnes. Centrage de la feuille de dessin sur l'cran ...
//  Label2.caption:='Version '+ApplicationVersion +' - 31 juillet 2013'; //version 2.8.1.0 correction bug dans les fonctions rx et ry (dcalage de 5 mm  gauche sur l'cran)
                                                 //amlioration du trac de segments : on peut ajouter des barres de codage sur les segments gaux
                                                 //suppression de la commande "envoyer en pice jointe" qui ne fonctionnait pas bien
//  Label2.caption:='Version '+ApplicationVersion +' - 31 octobre 2013'; //version 2.8.1.1 correction bug dans la page de saisie "simulations" : les boutons "copier les donnes" et
                                                 //"copier les calculs" n'taient pas fonctionnels.
//  Label2.caption:='Version '+ApplicationVersion +' - 09 novembre 2014'; //version 2.9.0.0 .
//  Label2.caption:='Version '+ApplicationVersion +' - 06 novembre 2015'; //version 2.9.1.0 .Corrections mineures, notamment styles de points nouveaux
//  Label2.caption:='Version '+ApplicationVersion +' - 02 dcembre 2015'; //version 2.9.2.0 .Ajout de la commande Rapporteur trigonomtrique
//  Label2.caption:='Version '+ApplicationVersion +' - 13 fvrier 2016';  //version 2.9.2.3 .Correction d'un bug sur la fonction gamma
//  Label2.caption:='Version '+ApplicationVersion +' - 26 novembre 2016'; //version 2.9.3.2 .Ajout des coniques dans les schmas,
                                                                          // amliorations dans les expressions Latex en haute dfinition:
                                                                          //                     - nombreuses corrections (exposants, indices, espacements, paisseurs)
                                                                          //                     - polices: nouveaux symboles, tailles en progression gomtrique
                                                                          //                     - Reprise des exemples
                                                                          // correction de bugs: tables de valeurs de fonctions, chantillonnage pour les courbes polaires
//  Label2.caption:='Version '+ApplicationVersion +' - 3 janvier 2017'; //version 2.9.3.3. Quelques corrections mineures sur les statistiques :
                                                                        // - diagrammes en botes moins pais (1 variable)
                                                                        // - chelle automatique gnralise
    Label2.caption:='Version '+ApplicationVersion +' - 24 novembre 2018'; //version 2.9.3.4. Commandes popup Couper/Copier/Coller/imprimer sur les Boites  moustaches Multiples
end;

procedure TfmApropos.Label4Click(Sender: TObject);
begin
   ShellExecute( 0, Nil, PChar('mailto:patrice.rabiller@orange.fr'),Nil, Nil, SW_NORMAL );
end;

procedure TfmApropos.Label1Click(Sender: TObject);
begin
   ShellExecute( 0, Nil, PChar('http://patrice-rabiller.fr'),Nil, Nil, SW_NORMAL );
end;

procedure TfmApropos.Label6Click(Sender: TObject);
begin
   ShellExecute( 0, Nil, PChar('mailto:patrick.pradeau@gmail.com'),Nil, Nil, SW_NORMAL );
end;

end.
