unit uAutresParametres;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, shellAPI;

type
  TfmAutresParametres = class(TForm)
    rgPointsD_arret: TRadioGroup;
    Panel13: TPanel;
    Panel14: TPanel;
    Panel15: TPanel;
    rgEpaisseurLignesCote: TRadioGroup;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel8: TPanel;
    Panel7: TPanel;
    Panel6: TPanel;
    Panel5: TPanel;
    Panel9: TPanel;
    Panel10: TPanel;
    Panel11: TPanel;
    Panel12: TPanel;
    btAnnuler: TButton;
    btOK: TButton;
    Label26: TLabel;
    edDiametrePoints: TEdit;
    edDiametre: TEdit;
    udDiametrePoints: TUpDown;
    Label33: TLabel;
    edLongueurTirets: TEdit;
    udLongueurTirets: TUpDown;
    edTirets: TEdit;
    Label38: TLabel;
    Label39: TLabel;
    udEpaisseurTangentes: TUpDown;
    Edit4: TEdit;
    EdEpaisseurTangentes: TEdit;
    Label40: TLabel;
    Label41: TLabel;
    udEpaisseurNormales: TUpDown;
    Edit5: TEdit;
    EdEpaisseurNormales: TEdit;
    Label42: TLabel;
    Label43: TLabel;
    udEpaisseurFleches: TUpDown;
    Edit6: TEdit;
    EdEpaisseurFleches: TEdit;
    Label44: TLabel;
    Label45: TLabel;
    udEpaisseurAxes: TUpDown;
    Edit7: TEdit;
    edEpaisseurAxes: TEdit;
    btnAide: TButton;
    procedure edDiametrePointsChange(Sender: TObject);
    procedure edTiretsChange(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Edit4Change(Sender: TObject);
    procedure Edit5Change(Sender: TObject);
    procedure Edit6Change(Sender: TObject);
    procedure Edit7Change(Sender: TObject);
    procedure btnAideClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  fmAutresParametres: TfmAutresParametres;

implementation

uses uDessin;

{$R *.DFM}

procedure TfmAutresParametres.edDiametrePointsChange(Sender: TObject);
begin
   edDiametre.Text:=FloatToStrf(udDiametrePoints.position/10,ffGeneral,3,3)+' mm';
end;

procedure TfmAutresParametres.edTiretsChange(Sender: TObject);
begin
    edLongueurTirets.Text:=inttostr(udLongueurTirets.position div 10)+','+inttostr(udLongueurTirets.position mod 10)+' mm';
end;

procedure TfmAutresParametres.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   if key=vk_Escape then close;
end;

procedure TfmAutresParametres.Edit4Change(Sender: TObject);
begin
   edEpaisseurTangentes.Text:=inttostr(udEpaisseurTangentes.position div 10)+','+inttostr(udEpaisseurTangentes.position mod 10)+' mm';

end;

procedure TfmAutresParametres.Edit5Change(Sender: TObject);
begin
   edEpaisseurNormales.Text:=inttostr(udEpaisseurNormales.position div 10)+','+inttostr(udEpaisseurNormales.position mod 10)+' mm';

end;

procedure TfmAutresParametres.Edit6Change(Sender: TObject);
begin
   edEpaisseurFleches.Text:=inttostr(udEpaisseurFleches.position div 10)+','+inttostr(udEpaisseurFleches.position mod 10)+' mm';

end;

procedure TfmAutresParametres.Edit7Change(Sender: TObject);
begin
   edEpaisseurAxes.Text:=inttostr(udEpaisseurAxes.position div 10)+','+inttostr(udEpaisseurAxes.position mod 10)+' mm';
end;

procedure TfmAutresParametres.btnAideClick(Sender: TObject);
begin
  Aide(89);
end;

end.
