unit uBezier;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ColorGrd, shellAPI, ComCtrls;

type
  TfmBezier = class(TForm)
    rgType: TRadioGroup;
    edSommets: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    btAnnuler: TButton;
    btOK: TButton;
    cgCouleur: TColorGrid;
    Label3: TLabel;
    btnAide: TButton;
    GroupBox1: TGroupBox;
    Apercu: TImage;
    edEpaisseur: TEdit;
    udEpaisseur: TUpDown;
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnAideClick(Sender: TObject);
    procedure edEpaisseurChange(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  fmBezier: TfmBezier;

implementation

uses uDessin;

{$R *.DFM}

procedure TfmBezier.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    if key=vk_Escape then close;
end;

procedure TfmBezier.btnAideClick(Sender: TObject);
begin
   Aide(38);
end;

procedure TfmBezier.edEpaisseurChange(Sender: TObject);
begin
  edEpaisseur.Text:=inttostr(udEpaisseur.position div 10)+','+inttostr(udEpaisseur.position mod 10)+' mm';
  Apercu.Picture.Assign(fmDessin.ApercuLigne(udEpaisseur.position,cgCouleur.ForeGroundColor));
end;

end.
