unit uCarre;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ColorGrd, shellAPI;

type
  TfmCarre = class(TForm)
    rgDefinition: TRadioGroup;
    Panel1: TPanel;
    Label1: TLabel;
    edCentre1: TEdit;
    Label2: TLabel;
    edCote: TEdit;
    Panel2: TPanel;
    Label3: TLabel;
    Label4: TLabel;
    edCentre2: TEdit;
    edRayon: TEdit;
    Panel3: TPanel;
    Label5: TLabel;
    Label6: TLabel;
    edSommet1: TEdit;
    edSommet2: TEdit;
    Panel4: TPanel;
    Label7: TLabel;
    Label8: TLabel;
    edSommet3: TEdit;
    edSommet4: TEdit;
    Panel5: TPanel;
    rgEpaisseur: TRadioGroup;
    Panel6: TPanel;
    Panel7: TPanel;
    Panel8: TPanel;
    rgStyle: TRadioGroup;
    GroupBox3: TGroupBox;
    Label9: TLabel;
    Label10: TLabel;
    ColorGrid1: TColorGrid;
    ColorGrid2: TColorGrid;
    btAnnuler: TButton;
    btOK: TButton;
    btnAide: TButton;
    procedure FormActivate(Sender: TObject);
    procedure rgDefinitionClick(Sender: TObject);
    procedure edCentre1Exit(Sender: TObject);
    procedure edCentre2Exit(Sender: TObject);
    procedure edSommet1Exit(Sender: TObject);
    procedure edSommet2Exit(Sender: TObject);
    procedure edSommet3Exit(Sender: TObject);
    procedure edSommet4Exit(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnAideClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  fmCarre: TfmCarre;

implementation

uses uDessin;

{$R *.DFM}

procedure TfmCarre.FormActivate(Sender: TObject);
begin
   rgDefinitionClick(sender);
end;

procedure TfmCarre.rgDefinitionClick(Sender: TObject);
var k : integer;
begin
   for k:=0 to ComponentCount-1 do
   begin
      if Components[k] is TLabel then (Components[k] as TLabel).Enabled:=false;
      if Components[k] is TEdit then
      begin
         (Components[k] as TEdit).color:=clBtnFace;
         (Components[k] as TEdit).Enabled:=false;
      end;
   end;
   Label9.Enabled:=true; //'bord'
   Label10.Enabled:=true;//'intrieur'
   case rgDefinition.ItemIndex of
      0 : begin
             Label1.Enabled:=true;
             Label2.Enabled:=true;
             edCentre1.Enabled:=true;
             edCote.Enabled:=true;
             edCentre1.Color:=clWindow;
             edCote.Color:=clWindow;
             if self.visible then edCentre1.SetFocus;
          end;
      1 : begin
             Label3.Enabled:=true;
             Label4.Enabled:=true;
             edCentre2.Enabled:=true;
             edRayon.Enabled:=true;
             edCentre2.Color:=clWindow;
             edRayon.Color:=clWindow;
             if self.visible then edCentre2.SetFocus;
          end;
      2 : begin
             Label5.Enabled:=true;
             Label6.Enabled:=true;
             edSommet1.Enabled:=true;
             edSommet2.Enabled:=true;
             edSommet1.Color:=clWindow;
             edSommet2.Color:=clWindow;
             if self.visible then edSommet1.SetFocus;
          end;
      3 : begin
             Label7.Enabled:=true;
             Label8.Enabled:=true;
             edSommet3.Enabled:=true;
             edSommet4.Enabled:=true;
             edSommet3.Color:=clWindow;
             edSommet4.Color:=clWindow;
             if self.visible then edSommet3.SetFocus;
          end;
   end;
end;

function SansEspace(ch:string):string;
begin
   while pos(' ',ch)>0 do delete(ch,pos(' ',ch),1);
   SansEspace:=ch;
end;

procedure TfmCarre.edCentre1Exit(Sender: TObject);
begin
   edCentre1.Text:=SansEspace(edCentre1.Text);
end;

procedure TfmCarre.edCentre2Exit(Sender: TObject);
begin
   edCentre2.Text:=SansEspace(edCentre2.Text);
end;

procedure TfmCarre.edSommet1Exit(Sender: TObject);
begin
   edSommet1.Text:=SansEspace(edSommet1.Text);
end;

procedure TfmCarre.edSommet2Exit(Sender: TObject);
begin
   edSommet2.Text:=SansEspace(edSommet2.Text);
end;

procedure TfmCarre.edSommet3Exit(Sender: TObject);
begin
   edSommet3.Text:=SansEspace(edSommet3.Text);
end;

procedure TfmCarre.edSommet4Exit(Sender: TObject);
begin
   edSommet4.Text:=SansEspace(edSommet4.Text);
end;

procedure TfmCarre.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   if key=vk_Escape then close;
end;

procedure TfmCarre.btnAideClick(Sender: TObject);
begin
   Aide(33);
end;

end.
