unit uCouleurs;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  StdCtrls, ExtCtrls, Forms;

type
  TCouleurs = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Image1: TImage;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    RadioButton6: TRadioButton;
    RadioButton7: TRadioButton;
    RadioButton8: TRadioButton;
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure RadioButton3Click(Sender: TObject);
    procedure RadioButton4Click(Sender: TObject);
    procedure RadioButton5Click(Sender: TObject);
    procedure RadioButton6Click(Sender: TObject);
    procedure RadioButton7Click(Sender: TObject);
    procedure RadioButton8Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    function  rb(x:integer):TradioButton;
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);

  private
    { Dclarations private }
  public
    { Dclarations public }
  Couleur      : TColor;
  CouleurLaTeX : string;
  numCouleur   : integer;
  end;

var
  Couleurs: TCouleurs;
  CouleurAvant:TColor;
  CouleurLaTeXAvant:string;
  numCouleurAvant:integer;
  OK:boolean;

implementation
uses uTableauVarSgn;
{$R *.DFM}

procedure TCouleurs.RadioButton1Click(Sender: TObject);
begin
Couleur:=clBlack;
CouleurLaTeX:='\black';
numCouleur:=1;
end;

procedure TCouleurs.RadioButton2Click(Sender: TObject);
begin
Couleur:=clBlue;
CouleurLaTeX:='\blue';
numCouleur:=2;
end;

procedure TCouleurs.RadioButton3Click(Sender: TObject);
begin
Couleur:=clRed;
CouleurLaTeX:='\red';
numCouleur:=3;
end;

procedure TCouleurs.RadioButton4Click(Sender: TObject);
begin
Couleur:=clGreen;
CouleurLaTeX:='\green';
numCouleur:=4;
end;

procedure TCouleurs.RadioButton5Click(Sender: TObject);
begin
Couleur:=clYellow;
CouleurLaTeX:='\yellow';
numCouleur:=5;
end;

procedure TCouleurs.RadioButton6Click(Sender: TObject);
begin
Couleur:=clAqua;
CouleurLaTeX:='\cyan';
numCouleur:=6;
end;

procedure TCouleurs.RadioButton7Click(Sender: TObject);
begin
Couleur:=clFuchsia;
CouleurLaTeX:='\magenta';
numCouleur:=7;
end;

procedure TCouleurs.RadioButton8Click(Sender: TObject);
begin
Couleur:=clWhite;
CouleurLaTeX:='\white';
numCouleur:=8;
end;

procedure TCouleurs.FormCreate(Sender: TObject);
begin
Couleur:=clBlack;
CouleurLaTeX:='\black';
numCouleur:=1;
end;

procedure TCouleurs.FormShow(Sender: TObject);
begin
OK:=False;
CouleurAvant:=Couleur;
CouleurLaTeXAvant:=CouleurLaTeX;
numCouleurAvant:=numCouleur;
end;

procedure TCouleurs.Button1Click(Sender: TObject);
var
   Glyphe       : TBitmap;
begin
OK:=True;
Glyphe:=TBitmap.Create;
Glyphe.Assign(fmTableauVarSgn.bbCouleurTextes.Glyph);
With Glyphe.Canvas do
   begin
   Brush.Color:=Couleur;
   FillRect(Classes.Rect(2,2,18,18));
   end;
fmTableauVarSgn.bbCouleurTextes.Glyph.Assign(Glyphe);
Glyphe.Free;
Close;
end;

function  TCouleurs.rb(x:integer):TradioButton;
begin
rb:=TradioButton(FindComponent('RadioButton'+inttostr(x)));
end;


procedure TCouleurs.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
If not OK
   then begin
   Couleur:=CouleurAvant;
   CouleurLaTeX:=CouleurLaTeXAvant;
   rb(numCouleurAvant).Checked:=True;
   numCouleur:=numCouleurAvant;
   end;
end;

procedure TCouleurs.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var n:integer;
begin
If (y>2) and (y<19)
   then begin
   if (x mod 26 > 2) and (x mod 26 < 21)
      then begin
      n:=(x-3) div 26;
      rb(n+1).Checked:=True;
      end;
   end;
end;

end.
