unit uPoint;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ColorGrd, ExtCtrls, shellAPI;

type
  TfmPoint = class(TForm)
    Label1: TLabel;
    edNom: TEdit;
    GroupBox1: TGroupBox;
    rbPoint: TRadioButton;
    rbPlus: TRadioButton;
    rbCroix: TRadioButton;
    rbEtoile: TRadioButton;
    rbCarre: TRadioButton;
    rbLosange: TRadioButton;
    GroupBox2: TGroupBox;
    ColorGrid1: TColorGrid;
    cbLigneCote: TCheckBox;
    btAnnuler: TButton;
    btOK: TButton;
    rgTaille: TRadioGroup;
    rgNature: TRadioGroup;
    Panel1: TPanel;
    edAbscisse: TEdit;
    edOrdonnee: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Panel2: TPanel;
    Label11: TLabel;
    edNomsDroites: TEdit;
    Panel3: TPanel;
    Label12: TLabel;
    edPointsPonderes: TEdit;
    Panel4: TPanel;
    Label14: TLabel;
    edXAB: TEdit;
    Panel5: TPanel;
    Label15: TLabel;
    edIsobarycentre: TEdit;
    Panel6: TPanel;
    Label13: TLabel;
    ed4point: TEdit;
    Panel7: TPanel;
    rbAucuneMarque: TRadioButton;
    gbPositionNom: TGroupBox;
    rbAucunePosition: TRadioButton;
    rbDroite: TRadioButton;
    rbHautDroite: TRadioButton;
    rbHaut: TRadioButton;
    rbHautGauche: TRadioButton;
    rbGauche: TRadioButton;
    rbBasGauche: TRadioButton;
    rbBas: TRadioButton;
    rbBasDroite: TRadioButton;
    lblPosition: TPanel;
    Panel8: TPanel;
    edPoint: TEdit;
    Label10: TLabel;
    Label16: TLabel;
    edDroite: TEdit;
    Panel9: TPanel;
    Label17: TLabel;
    edPointRotation: TEdit;
    Label18: TLabel;
    edCentre: TEdit;
    edAngle: TEdit;
    Label19: TLabel;
    Label22: TLabel;
    edr: TEdit;
    Label23: TLabel;
    edtheta: TEdit;
    cbCartesiennes: TCheckBox;
    cbPolaires: TCheckBox;
    btnAide: TButton;
    Image1: TImage;
    Image2: TImage;
    rbRond: TRadioButton;
    rbCarre2: TRadioButton;
    rbLosange2: TRadioButton;
    procedure FormActivate(Sender: TObject);
    procedure rgNatureClick(Sender: TObject);
    procedure edNomExit(Sender: TObject);
    procedure edXABExit(Sender: TObject);
    procedure edNomsDroitesExit(Sender: TObject);
    procedure edPointsPonderesExit(Sender: TObject);
    procedure edIsobarycentreExit(Sender: TObject);
    procedure rbHautDroiteClick(Sender: TObject);
    procedure rbDroiteClick(Sender: TObject);
    procedure rbHautClick(Sender: TObject);
    procedure rbHautGaucheClick(Sender: TObject);
    procedure rbGaucheClick(Sender: TObject);
    procedure rbBasGaucheClick(Sender: TObject);
    procedure rbBasClick(Sender: TObject);
    procedure rbBasDroiteClick(Sender: TObject);
    procedure rbAucunePositionClick(Sender: TObject);
    procedure edPointExit(Sender: TObject);
    procedure edDroiteExit(Sender: TObject);
    procedure edPointRotationExit(Sender: TObject);
    procedure edCentreExit(Sender: TObject);
    procedure edAngleExit(Sender: TObject);
    procedure cbCartesiennesClick(Sender: TObject);
    procedure cbPolairesClick(Sender: TObject);
    procedure edAbscisseExit(Sender: TObject);
    procedure edOrdonneeExit(Sender: TObject);
    procedure edrExit(Sender: TObject);
    procedure edthetaExit(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnAideClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  fmPoint: TfmPoint;

implementation

{$R *.DFM}

uses uFonctions, uDessin;

procedure TfmPoint.FormActivate(Sender: TObject);
begin
   rgNatureClick(sender);
   if gbPositionNom.tag<0 then begin gbPositionNom.tag:=0;rbDroite.Checked:=true;end;
end;

procedure TfmPoint.rgNatureClick(Sender: TObject);
var k : integer;
begin
   for k:=0 to ComponentCount-1 do
   begin
      if Components[k]is TLabel then (Components[k] as TLabel).Enabled:=false;
      if Components[k] is TEdit then
      begin
         (Components[k] as TEdit).color:=clBtnFace;
         (Components[k] as TEdit).Enabled:=false;
      end;
   end;
   cbCartesiennes.Enabled:=false;cbPolaires.Enabled:=false;
   Label1.enabled:=true;
   edNom.Color:=clWindow;edNom.Enabled:=true;
   case rgNature.ItemIndex of
      0 : begin
             cbCartesiennes.Enabled:=true;cbPolaires.Enabled:=true;   
             if cbCartesiennes.Checked then
             begin
                edAbscisse.Color:=clWindow;edOrdonnee.Color:=clWindow;
                edAbscisse.Enabled:=true;edOrdonnee.Enabled:=true;
                Label2.enabled:=true;Label3.Enabled:=true;
             end
             else
             begin
                edr.Color:=clWindow;edtheta.Color:=clWindow;
                edr.Enabled:=true;edtheta.Enabled:=true;
                Label22.enabled:=true;Label23.Enabled:=true;
             end;
             if self.Visible then if tag=1 then
             begin
                if cbCartesiennes.checked then edAbscisse.SetFocus
                                          else edr.setfocus;
             end
             else edNom.SetFocus;
          end;
      1 : begin
             Label14.Enabled:=true;
             edXAB.Color:=clWindow;edXAB.Enabled:=true;
             if self.Visible then if tag=1 then edXAB.SetFocus
                                           else edNom.SetFocus;
          end;
      2 : begin
             Label11.Enabled:=true;
             edNomsDroites.Color:=clWindow;edNomsDroites.Enabled:=True;
             if self.Visible then if tag=1 then edNomsDroites.SetFocus
                                           else edNom.SetFocus;
          end;
      3 : begin
             Label12.Enabled:=true;
             edPointsPonderes.Color:=clWindow;edPointsPonderes.Enabled:=true;
             if self.Visible then if tag=1 then edPointsPonderes.SetFocus
                                           else edNom.SetFocus;
          end;
      4 : begin
             Label15.Enabled:=true;
             edIsobarycentre.Color:=clWindow;edIsobarycentre.Enabled:=true;
             if self.Visible then if tag=1 then edIsobarycentre.SetFocus
                                           else edNom.SetFocus;
          end;
      5 : begin
             Label13.Enabled:=true;
             ed4Point.Color:=clWindow;ed4Point.Enabled:=true;
             if self.Visible then if tag=1 then ed4Point.SetFocus
                                           else edNom.SetFocus;
          end;
      6 : begin
             Label10.Enabled:=true;Label16.Enabled:=true;
             edPoint.Enabled:=true;edDroite.Enabled:=true;
             edPoint.Color:=clWindow;edDroite.Color:=clWindow;
             if self.Visible then if tag=1 then edPoint.SetFocus
                                           else edNom.SetFocus;
          end;
      7 : begin
             Label17.Enabled:=true;Label18.Enabled:=true;Label19.Enabled:=true;
             edPointRotation.Enabled:=true;edCentre.Enabled:=true;edAngle.Enabled:=true;
             edPointRotation.Color:=clWindow;edCentre.Color:=clWindow;edAngle.Color:=clWindow;
             if self.Visible then if tag=1 then edPointRotation.SetFocus
                                           else edNom.SetFocus;
          end;
   end;
end;

function SansEspace(ch:string):string;
begin
   while pos(' ',ch)>0 do delete(ch,pos(' ',ch),1);
   SansEspace:=ch;
end;

procedure TfmPoint.edNomExit(Sender: TObject);
begin
   edNom.Text:=SansEspace(edNom.text);
end;

procedure TfmPoint.edXABExit(Sender: TObject);
begin
   edXAB.Text:=SansEspace(edXAB.Text);
end;

procedure TfmPoint.edNomsDroitesExit(Sender: TObject);
begin
   edNomsDroites.Text:=SansEspace(edNomsDroites.Text);
end;

procedure TfmPoint.edPointsPonderesExit(Sender: TObject);
begin
   edPointsPonderes.Text:=SansEspace(edPointsPonderes.Text);
end;

procedure TfmPoint.edIsobarycentreExit(Sender: TObject);
begin
   edIsobarycentre.Text:=SansEspace(edIsobarycentre.Text);
end;

procedure TfmPoint.rbDroiteClick(Sender: TObject);
begin
   gbPositionNom.Tag:=0;
   lblPosition.Caption:=' droite';
//   lblPosition.Left:=(gbPositionNom.Width-lblPosition.Canvas.TextWidth(lblPosition.caption))div 2;
end;

procedure TfmPoint.rbHautDroiteClick(Sender: TObject);
begin
   gbPositionNom.Tag:=1;
   lblPosition.Caption:='en haut  droite';
end;


procedure TfmPoint.rbHautClick(Sender: TObject);
begin
   gbPositionNom.Tag:=2;
   lblPosition.Caption:='en haut';
end;

procedure TfmPoint.rbHautGaucheClick(Sender: TObject);
begin
   gbPositionNom.Tag:=3;
   lblPosition.Caption:='en haut  gauche';
end;

procedure TfmPoint.rbGaucheClick(Sender: TObject);
begin
   gbPositionNom.Tag:=4;
   lblPosition.Caption:=' gauche';
end;

procedure TfmPoint.rbBasGaucheClick(Sender: TObject);
begin
   gbPositionNom.Tag:=5;
   lblPosition.Caption:='en bas  gauche';
end;

procedure TfmPoint.rbBasClick(Sender: TObject);
begin
   gbPositionNom.Tag:=6;
   lblPosition.Caption:='en bas';
end;

procedure TfmPoint.rbBasDroiteClick(Sender: TObject);
begin
   gbPositionNom.Tag:=7;
   lblPosition.Caption:='en bas  droite';
end;

procedure TfmPoint.rbAucunePositionClick(Sender: TObject);
begin
   gbPositionNom.Tag:=8;
   lblPosition.Caption:='pas d''affichage du nom';
end;

procedure TfmPoint.edPointExit(Sender: TObject);
begin
   edPoint.Text:=SansEspace(edPoint.Text);
end;

procedure TfmPoint.edDroiteExit(Sender: TObject);
begin
   edDroite.Text:=SansEspace(edDroite.Text);
end;

procedure TfmPoint.edPointRotationExit(Sender: TObject);
begin
   edPointRotation.Text:=SansEspace(edPointRotation.Text);
end;

procedure TfmPoint.edCentreExit(Sender: TObject);
begin
   edcentre.Text:=SansEspace(edcentre.Text);
end;

procedure TfmPoint.edAngleExit(Sender: TObject);
begin
   edAngle.Text:=SansEspace(edAngle.Text);
end;

procedure TfmPoint.cbCartesiennesClick(Sender: TObject);
begin
   cbPolaires.Checked:=not cbCartesiennes.Checked;
   if cbCartesiennes.Checked then
   begin
      edAbscisse.Enabled:=true;
      edAbscisse.Color:=clWindow;
      edOrdonnee.Enabled:=true;
      edOrdonnee.Color:=clWindow;
      edr.Enabled:=false;
      edr.Color:=clBtnFace;
      edTheta.Enabled:=false;
      edTheta.Color:=clBtnFace;
      Label2.Enabled:=true;Label3.Enabled:=true;
      Label22.Enabled:=false;Label23.Enabled:=false;
   end;
end;

procedure TfmPoint.cbPolairesClick(Sender: TObject);
begin
   cbCartesiennes.Checked:=not cbPolaires.Checked;
   if cbPolaires.Checked then
   begin
      edAbscisse.Enabled:=false;
      edAbscisse.Color:=clBtnFace;
      edOrdonnee.Enabled:=false;
      edOrdonnee.Color:=clBtnFace;
      edr.Enabled:=true;
      edr.Color:=clwindow;
      edTheta.Enabled:=true;
      edTheta.Color:=clWindow;
      Label2.Enabled:=false;Label3.Enabled:=false;
      Label22.Enabled:=true;Label23.Enabled:=true;
   end;
end;

procedure TfmPoint.edAbscisseExit(Sender: TObject);
var x,y,r,theta : real;
    chx,chy : string;
    erreur : byte;
begin
   if (edAbscisse.Text<>'')and(edOrdonnee.Text<>'')and(cbCartesiennes.Checked) then
   begin
      chx:=traduction(edAbscisse.Text,erreur);
      if erreur>0 then exit;
      chy:=traduction(edOrdonnee.Text,erreur);
      if erreur>0 then exit;
      ok:=true;
      x:=f(chx,1);if not ok then exit;
      y:=f(chy,1);if not ok then exit;
      r:=sqrt(sqr(x)+sqr(y));
      theta:=0; //initialisation bidon
      if x=0 then
      begin
         if y>0 then theta:=90;
         if y<0 then theta:=-90;
         if y=0 then exit;
      end
      else if x>0 then theta:=arctan(y/x)*180/pi
                  else theta:=arctan(y/x)*180/pi+180;
      edr.Text:=FloatToStr(r);
      edTheta.Text:=FloatToStr(theta);
   end;
end;

procedure TfmPoint.edOrdonneeExit(Sender: TObject);
var x,y,r,theta : real;
    chx,chy : string;
    erreur : byte;
begin
   if (edAbscisse.Text<>'')and(edOrdonnee.Text<>'')and(cbCartesiennes.Checked) then
   begin
      chx:=traduction(edAbscisse.Text,erreur);
      if erreur>0 then exit;
      chy:=traduction(edOrdonnee.Text,erreur);
      if erreur>0 then exit;
      ok:=true;
      theta:=0; //initialisation bidon
      x:=f(chx,1);if not ok then exit;
      y:=f(chy,1);if not ok then exit;
      r:=sqrt(sqr(x)+sqr(y));
      if x=0 then
      begin
         if y>0 then theta:=90;
         if y<0 then theta:=-90;
         if y=0 then exit;
      end
      else if x>0 then theta:=arctan(y/x)*180/pi
                  else theta:=arctan(y/x)*180/pi+180;
      edr.Text:=FloatToStr(r);
      edTheta.Text:=FloatToStr(theta);
   end;
end;

procedure TfmPoint.edrExit(Sender: TObject);
var x,y,r,theta : real;
    chr,chtheta : string;
    erreur : byte;
begin
   if (edr.Text<>'')and(edtheta.Text<>'')and(cbPolaires.Checked) then
   begin
      chr:=traduction(edr.Text,erreur);
      if erreur>0 then exit;
      chtheta:=traduction(edtheta.Text,erreur);
      if erreur>0 then exit;
      ok:=true;
      r:=f(chr,1);if not ok then exit;
      if r<0 then begin showmessage('La distance polaire doit tre positive !');edr.text:='';exit;end;
      theta:=f(chtheta,1);if not ok then exit;
      x:=r*cos(theta*pi/180);
      y:=r*sin(theta*pi/180);
      edAbscisse.Text:=FloatToStr(x);
      edOrdonnee.Text:=FloatToStr(y);
   end;
end;

procedure TfmPoint.edthetaExit(Sender: TObject);
var x,y,r,theta : real;
    chr,chtheta : string;
    erreur : byte;
begin
   if (edr.Text<>'')and(edtheta.Text<>'')and(cbPolaires.Checked) then
   begin
      chr:=traduction(edr.Text,erreur);
      if erreur>0 then exit;
      chtheta:=traduction(edtheta.Text,erreur);
      if erreur>0 then exit;
      ok:=true;
      r:=f(chr,1);if not ok then exit;
      theta:=f(chtheta,1);if not ok then exit;
      x:=r*cos(theta*pi/180);
      y:=r*sin(theta*pi/180);
      edAbscisse.Text:=FloatToStr(x);
      edOrdonnee.Text:=FloatToStr(y);
   end;
end;

procedure TfmPoint.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    if key=vk_Escape then close;
end;

procedure TfmPoint.btnAideClick(Sender: TObject);
begin
   Aide(29);
end;

end.
