unit uPolygonePredefini;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ColorGrd, shellAPI;

type
  TfmPolygonePredefini = class(TForm)
    rgNature: TRadioGroup;
    Edit1: TEdit;
    Edit2: TEdit;
    LblNomsSommets: TLabel;
    edNomsSommets: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    rgEpaisseur: TRadioGroup;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    rgStyle: TRadioGroup;
    GroupBox3: TGroupBox;
    Label7: TLabel;
    Label8: TLabel;
    ColorGrid1: TColorGrid;
    ColorGrid2: TColorGrid;
    btAnnuler: TButton;
    btOK: TButton;
    rgOptions: TRadioGroup;
    btnAide: TButton;
    procedure rgNatureClick(Sender: TObject);
    procedure rgOptionsClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure edNomsSommetsExit(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnAideClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  fmPolygonePredefini: TfmPolygonePredefini;

implementation

uses uDessin;

{$R *.DFM}

procedure TfmPolygonePredefini.rgNatureClick(Sender: TObject);
var k : byte;
begin
   for k:=0 to ComponentCount-1 do
   begin
      if Components[k] is TLabel then (Components[k] as TLabel).visible:=false;
      if Components[k] is TEdit then (Components[k] as TEdit).visible:=false;
   end;
   Label7.Visible:=true;Label8.Visible:=true;
   LblNomsSommets.visible:=true;
   edNomsSommets.visible:=true;
   rgOptions.Visible:=false;
   case rgNature.ItemIndex of
      0 : begin    //Triangle quilatral
             edNomsSommets.Text:='A,B,C';
             label1.visible:=true;label1.Caption:='Longueur du ct :';
             edit1.visible:=true;edit1.Text:='6';
          end;
      1 : begin   //triangle isocle
             rgOptions.Visible:=true;
             rgOptions.Caption:=' Options du triangle isocle ';
             rgOptions.Items[0]:='base et hauteur';
             rgOptions.Items[1]:='base et cts gaux';
             edNomsSommets.Text:='A,B,C';
             label1.visible:=true;label1.Caption:='Longueur de la base :';
             edit1.visible:=true;edit1.text:='6';
             label2.visible:=true;
             case rgOptions.ItemIndex of
                0 : label2.Caption:='Longueur de la hauteur :';
                1 : label2.Caption:='Longueur des 2 cts gaux :';
             end;
             edit2.visible:=true;edit2.text:='8';
          end;
      2 : begin                                  //triangle rectangle
             edNomsSommets.Text:='A,B,C';
             label1.visible:=true;label1.Caption:='Longueur du ct 1 :';
             edit1.visible:=true;edit1.Text:='8';
             label2.visible:=true;label2.Caption:='Longueur du ct 2 :';
             edit2.visible:=true;edit2.Text:='6';
          end;
      3 : begin                         //triangle rectangle isocle
             rgOptions.Visible:=true;
             rgOptions.Caption:=' Options du triangle rectangle isocle ';
             rgOptions.Items[0]:='Longueur des cts de l''angle droit';
             rgOptions.Items[1]:='Longueur de l''hypothnuse';
             edNomsSommets.Text:='A,B,C';
             label1.visible:=true;
             edit1.visible:=true;edit1.text:='6';
             case rgOptions.ItemIndex of
                0 : label1.Caption:='Ct de l''angle droit :';
                1 : label1.Caption:='Longueur de l''hypothnuse :';
             end;
          end;
      4 : begin    //triangle dont les longueurs des 3 cts sont connues
             edNomsSommets.Text:='A,B,C';
             label1.visible:=true;label1.caption:='Longueur du ct 1 :';
             label2.visible:=true;label2.caption:='Longueur du ct 2 :';
             label3.visible:=true;label3.caption:='Longueur du ct 3 :';
             edit1.visible:=true;edit1.Text:='8';
             edit2.visible:=true;edit2.Text:='7';
             edit3.visible:=true;edit3.Text:='5';
          end;
      5 : if edNomsSommets.text='' then edNomsSommets.Text:='A,B,C'; //triangle quelconque
      6 : begin   //carr
             edNomsSommets.Text:='A,B,C,D';
             label1.visible:=true;label1.caption:='Longueur du ct :';
             edit1.visible:=true;edit1.Text:='6';
          end;
      7 : begin   //rectangle
             edNomsSommets.Text:='A,B,C,D';
             label1.visible:=true;label1.caption:='Longueur du rectangle :';
             label2.visible:=true;label2.caption:='Largeur du rectangle :';
             edit1.visible:=true;edit1.Text:='8';
             edit2.visible:=true;edit2.Text:='6';
          end;
      8 : begin   //paralllogramme
             edNomsSommets.Text:='A,B,C,D';
             label1.visible:=true;label1.caption:='Longueur du ct horizontal :';
             label2.visible:=true;label2.caption:='Hauteur du paralllogramme :';
             label3.Visible:=true;label3.Caption:='Coef. directeur de (AD) :';
             edit1.visible:=true;edit1.Text:='8';
             edit2.visible:=true;edit2.Text:='5';
             edit3.visible:=true;edit3.Text:='2';
          end;
      9 : begin   //losange
             edNomsSommets.Text:='A,B,C,D';
             label1.visible:=true;label1.caption:='Largeur (axe horizontal) :';
             label2.visible:=true;label2.caption:='Hauteur (axe vertical) :';
             edit1.visible:=true;edit1.Text:='5';
             edit2.visible:=true;edit2.Text:='8';
          end;
      10: begin   //trapze quelconque
             edNomsSommets.Text:='A,B,C,D';
          end;
      11: begin   //trapze rectangle
             edNomsSommets.Text:='A,B,C,D';
             label1.visible:=true;label1.caption:='Grande base :';
             label2.visible:=true;label2.caption:='Petite base :';
             label3.Visible:=true;label3.Caption:='Hauteur :';
             edit1.visible:=true;edit1.Text:='8';
             edit2.visible:=true;edit2.Text:='5';
             edit3.visible:=true;edit3.Text:='3';
          end;
       12: begin   //trapze isocle
             edNomsSommets.Text:='A,B,C,D';
             label1.visible:=true;label1.caption:='Grande base :';
             label2.visible:=true;label2.caption:='Petite base :';
             label3.Visible:=true;label3.Caption:='Hauteur :';
             edit1.visible:=true;edit1.Text:='8';
             edit2.visible:=true;edit2.Text:='5';
             edit3.visible:=true;edit3.Text:='3';
           end;
       13: edNomsSommets.Text:='A,B,C,D'; //quadrilatre quelconque
   end;
   if edit1.Visible then Edit1.TabOrder:=1;
   if edit2.Visible then edit2.TabOrder:=2;
   if edit3.Visible then edit3.TabOrder:=3;
end;

procedure TfmPolygonePredefini.rgOptionsClick(Sender: TObject);
begin
   rgNatureClick(sender);
end;

procedure TfmPolygonePredefini.FormActivate(Sender: TObject);
var k : byte;
begin
   for k:=0 to ComponentCount-1 do
      if Components[k] is TEdit then (Components[k] as TEdit).Text:='';
   rgNatureClick(sender);
end;

function SansEspace(ch:string):string;
begin
   while pos(' ',ch)>0 do delete(ch,pos(' ',ch),1);
   SansEspace:=ch;
end;

procedure TfmPolygonePredefini.edNomsSommetsExit(Sender: TObject);
begin
   edNomsSommets.Text:=SansEspace(edNomsSommets.Text);
end;

procedure TfmPolygonePredefini.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    if key=vk_Escape then close;
end;

procedure TfmPolygonePredefini.btnAideClick(Sender: TObject);
begin
   Aide(34);
end;

end.
