unit uRepere;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, ColorGrd, Buttons, ExtCtrls, shellAPI;

type
  TfmRepere = class(TForm)
    gbAxeX: TGroupBox;
    gbAxeY: TGroupBox;
    Label1: TLabel;
    edOrigineAxeX: TEdit;
    Label2: TLabel;
    edUniteX: TEdit;
    Label3: TLabel;
    edLongueurUx: TEdit;
    edLongueurUx_mm: TEdit;
    udUx: TUpDown;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    edOrigineAxeY: TEdit;
    edUniteY: TEdit;
    edLongueurUy: TEdit;
    edLongueurUy_mm: TEdit;
    udUy: TUpDown;
    Label7: TLabel;
    Label8: TLabel;
    edPosAxeX: TEdit;
    edPosAxeX_mm: TEdit;
    udPosAxeX: TUpDown;
    Label9: TLabel;
    Label10: TLabel;
    edPosAxeY: TEdit;
    edPosAxeY_mm: TEdit;
    udPosAxeY: TUpDown;
    btnOK: TButton;
    btnAnnuler: TButton;
    gbParametreT: TGroupBox;
    gbOptions: TGroupBox;
    cbRepereVisible: TCheckBox;
    cbGraduationsPar5mm: TCheckBox;
    gbInfoAxeX: TGroupBox;
    LabelXMin: TLabel;
    LabelXMax: TLabel;
    gbInfoAxeY: TGroupBox;
    LabelYMin: TLabel;
    LabelYMax: TLabel;
    rbAucune: TRadioButton;
    rbCroix: TRadioButton;
    rbPetitsCarreaux: TRadioButton;
    cgAxes: TColorGrid;
    Label13: TLabel;
    Label14: TLabel;
    rbPointillesFins: TRadioButton;
    cbGraduationsCompletes: TCheckBox;
    rbPointillesMoyens: TRadioButton;
    rbTirets: TRadioButton;
    Label19: TLabel;
    Label20: TLabel;
    btPoliceGraduations: TButton;
    FontDialog1: TFontDialog;
    Label15: TLabel;
    Label16: TLabel;
    edNomAxeOx: TEdit;
    edNomAxeOy: TEdit;
    Image1: TImage;
    cdCouleurFond: TColorDialog;
    cdCouleurGrille: TColorDialog;
    btCouleurGrille: TButton;
    btCouleurFond: TButton;
    rbPapierMillimetre: TRadioButton;
    edChiffresSignificatifsX: TEdit;
    Label11: TLabel;
    Label12: TLabel;
    udChiffresSignificatifsX: TUpDown;
    edChiffresSignificatifsY: TEdit;
    Label17: TLabel;
    Label18: TLabel;
    udChiffresSignificatifsY: TUpDown;
    cbAxeOx: TCheckBox;
    cbAxeOy: TCheckBox;
    edLongueurTirets: TEdit;
    Edit2: TEdit;
    udLongueurTirets: TUpDown;
    Label21: TLabel;
    Label34: TLabel;
    edTaillePetitsCarreaux: TEdit;
    udTaillePetitsCarreaux: TUpDown;
    cbLogX: TCheckBox;
    Label22: TLabel;
    edLongueurModuleX_mm: TEdit;
    edLongueurModuleX: TEdit;
    udLongueurModuleX: TUpDown;
    cbLogY: TCheckBox;
    Label23: TLabel;
    edLongueurModuleY: TEdit;
    udLongueurModuleY: TUpDown;
    edLongueurModuleY_mm: TEdit;
    cbAucuneGraduation: TCheckBox;
    Label24: TLabel;
    rbPapierPointe: TRadioButton;
    edDiametrePoints: TEdit;
    Edit3: TEdit;
    udDiametrePoints: TUpDown;
    rbGraduationsTransparentes: TRadioButton;
    rbGraduationsOpaques: TRadioButton;
    btnAide: TButton;
    procedure edLongueurUx_mmChange(Sender: TObject);
    procedure edLongueurUy_mmChange(Sender: TObject);
    procedure edPosAxeX_mmChange(Sender: TObject);
    procedure edPosAxeY_mmChange(Sender: TObject);
    procedure edOrigineAxeXExit(Sender: TObject);
    procedure edUniteXExit(Sender: TObject);
    procedure edOrigineAxeYExit(Sender: TObject);
    procedure edUniteYExit(Sender: TObject);
    procedure edLongueurUxExit(Sender: TObject);
    procedure edPosAxeXExit(Sender: TObject);
    procedure edLongueurUyExit(Sender: TObject);
    procedure edPosAxeYExit(Sender: TObject);
    procedure cbGraduationsPar5mmClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btPoliceGraduationsClick(Sender: TObject);
    procedure rbAucuneClick(Sender: TObject);
    procedure rbCroixClick(Sender: TObject);
    procedure rbPointillesFinsClick(Sender: TObject);
    procedure rbPointillesMoyensClick(Sender: TObject);
    procedure rbTiretsClick(Sender: TObject);
    procedure rbPetitsCarreauxClick(Sender: TObject);
    procedure btCouleurGrilleClick(Sender: TObject);
    procedure btCouleurFondClick(Sender: TObject);
    procedure cdCouleurGrilleShow(Sender: TObject);
    procedure cdCouleurFondShow(Sender: TObject);
    procedure rbPapierMillimetreClick(Sender: TObject);
    procedure edUniteXKeyPress(Sender: TObject; var Key: Char);
    procedure edUniteYKeyPress(Sender: TObject; var Key: Char);
    procedure edLongueurUxKeyPress(Sender: TObject; var Key: Char);
    procedure edLongueurUyKeyPress(Sender: TObject; var Key: Char);
    procedure edPosAxeXKeyPress(Sender: TObject; var Key: Char);
    procedure edPosAxeYKeyPress(Sender: TObject; var Key: Char);
    procedure cbRepereVisibleClick(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure edTaillePetitsCarreauxChange(Sender: TObject);
    procedure edLongueurModuleX_mmChange(Sender: TObject);
    procedure cbLogXClick(Sender: TObject);
    procedure cbLogYClick(Sender: TObject);
    procedure edLongueurModuleY_mmChange(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure rbPapierPointeClick(Sender: TObject);
    procedure Edit3Change(Sender: TObject);
    procedure btnAideClick(Sender: TObject);
  private
    { Dclarations prives }
    procedure InformationMinMax;
  public
    { Dclarations publiques }
  end;

var
  fmRepere                 : TfmRepere;
  GrosDessin,PetitDessin   : TBitMap;

implementation
uses uDessin,uFonctions;

{$R *.DFM}

var FormatUxBis,FormatUyBis  : byte;

procedure TfmRepere.InformationMinMax;
var r,a : real;
begin
   blLogX:=cbLogX.Checked;blLogY:=cbLogY.Checked;
   r:=(LargeurDessin_mm-udPosAxeY.Position)/udUx.Position+valConstante(edOrigineAxeX.Text); //XMax
   if blLogX then    //calcul de XMax dans le cas d'chelle logarithmique
   begin
      a:=(LargeurDessin_mm-udPosAxeY.Position)/udLongueurModuleX.Position+ln(ValConstante(edOrigineAxeX.text))/ln(10);
      //a est le logarithme dcimal de XMax
      r:=exp(a*ln(10));
   end;
   LabelXMax.Caption:='X maximum : '+FloatToStrF(r,ffGeneral,10,4);
   r:=r-LargeurDessin_mm/udUx.Position;
   if blLogX then
   begin
      a:=-udPosAxeY.Position/udLongueurModuleX.Position+ln(valConstante(edOrigineAxeX.Text))/ln(10);
      r:=exp(a*ln(10));
   end;
   LabelXMin.Caption:='X minimum : '+FloatToStrF(r,ffGeneral,10,4);
   r:=udPosAxeX.Position/udUy.Position*ValConstante(edUniteY.Text)+
      valConstante(edOrigineAxeY.Text);
   if blLogY then    //calcul de YMax dans le cas d'chelle logarithmique
   begin
      a:=udPosAxeX.Position/udLongueurModuleY.Position+ln(ValConstante(edOrigineAxeY.text))/ln(10);
      //a est le logarithme dcimal de YMax
      r:=exp(a*ln(10));
   end;
   LabelYMax.Caption:='Y maximum : '+FloatToStrF(r,ffGeneral,10,4);
   r:=r-HauteurDessin_mm/udUy.Position*ValConstante(edUniteY.Text);
   if blLogY then
   begin
      a:=(udPosAxeX.Position-HauteurDessin_mm)/udLongueurModuleY.Position+ln(valConstante(edOrigineAxeY.Text))/ln(10);
      r:=exp(a*ln(10));
   end;
   LabelYMin.Caption:='Y minimum : '+FloatToStrF(r,ffGeneral,10,4);
end;

procedure TfmRepere.edLongueurUx_mmChange(Sender: TObject);
var ch : string;
begin
   ch:=FloatToStrF(udUx.position/10,ffFixed,4,1);
   edLongueurUx.Text:=ch+' cm';
   InformationMinMax;
end;

procedure TfmRepere.edLongueurUy_mmChange(Sender: TObject);
var ch : string;
begin
   ch:=FloatToStrF(udUy.position/10,ffFixed,4,1);
   edLongueurUy.Text:=ch+' cm';
   InformationMinMax;
end;

procedure TfmRepere.edPosAxeX_mmChange(Sender: TObject);
var ch : string;
begin
   ch:=FloatToStrF(udPosAxeX.position/10,ffFixed,4,1);
   edPosAxeX.Text:=ch+' cm';
   InformationMinMax;
end;

procedure TfmRepere.edPosAxeY_mmChange(Sender: TObject);
var ch : string;
begin
   ch:=FloatToStrF(udPosAxeY.position/10,ffFixed,4,1);
   edPosAxeY.Text:=ch+' cm';
   InformationMinMax;
end;

procedure TfmRepere.edOrigineAxeXExit(Sender: TObject);
var ch : string;
    err : byte;
    i: integer;
begin
   ch:= edOrigineAxeX.Text;
   i:=pos('.',ch);
   if i>0   //remplace ventuellement un . par une ,
      then begin
      delete(ch,i,1);
      insert(',',ch,i);
      edOrigineAxeX.Text:=ch;
      end;
   NomVar:='X';
   ch:=Traduction(edOrigineAxeX.text,err);
   if err>0 then
   begin
      ShowMessage('La constante '+edOrigineAxeX.Text+' n''est pas correcte');
      edOrigineAxeX.Text:=FloatToStrF(AbscisseAxeY,ffGeneral,10,4);
   end;
//   TryStrToFloat(edOrigineAxeX.text,x);
//   x:=udessin.arrondi(x);
//   edOrigineAxeX.text:=FloatToStrF(x,ffgeneral,1,2);
   InformationMinMax;
end;

procedure TfmRepere.edUniteXExit(Sender: TObject);
var ch : string;
    err : byte;
    i: integer;
begin
   ch:= edUniteX.Text;
   i:=pos('.',ch);
   if i>0   //remplace ventuellement un . par une ,
      then begin
      delete(ch,i,1);
      insert(',',ch,i);
      edUniteX.Text:=ch;
      end;
   NomVar:='X';
   ch:=Traduction(edUniteX.text,err);
   if Pos('',ch)>0 then FormatUxBis:=2 else FormatUxBis:=1;
   if err>0 then
   begin
      ShowMessage('La constante '+edUniteX.Text+' n''est pas correcte');
      edUniteX.Text:=FloatToStrF(Ux,ffGeneral,10,4);
   end;
   if F(ch,1)<=0 then
   begin
      ShowMessage('La constante '+edUniteX.Text+' (unit de graduation en X) n''est pas strictement positive');
      edUniteX.Text:=FloatToStrF(Ux,ffGeneral,10,4);
   end;
//   TryStrToFloat(edUniteX.text,x);
//   x:=udessin.arrondi(x);
//   edUniteX.text:=FloatToStrF(x,ffgeneral,1,2);
   InformationMinMax;
end;

procedure TfmRepere.edOrigineAxeYExit(Sender: TObject);
var ch : string;
    err : byte;
    i: integer;
begin
   ch:= edOrigineAxeY.Text;
   i:=pos('.',ch);
   if i>0   //remplace ventuellement un . par une ,
      then begin
      delete(ch,i,1);
      insert(',',ch,i);
      edOrigineAxeY.Text:=ch;
      end;
   NomVar:='X';
   ch:=Traduction(edOrigineAxeY.text,err);
   if err>0 then
   begin
      ShowMessage('La constante '+edOrigineAxeY.Text+' n''est pas correcte');
      edOrigineAxeY.Text:=FloatToStrF(OrdonneeAxeX,ffGeneral,10,4);
   end;
//   TryStrToFloat(edOrigineAxeY.text,x);
//   x:=udessin.arrondi(x);
//   edOrigineAxeY.text:=FloatToStrF(x,ffgeneral,1,2);
   InformationMinMax;
end;

procedure TfmRepere.edUniteYExit(Sender: TObject);
var ch : string;
    err : byte;
    i: integer;
begin
   ch:= edUniteY.Text;
   i:=pos('.',ch);
   if i>0   //remplace ventuellement un . par une ,
      then begin
      delete(ch,i,1);
      insert(',',ch,i);
      edUniteY.Text:=ch;
      end;
   NomVar:='X';
   ch:=Traduction(edUniteY.text,err);
   if Pos('',ch)>0 then FormatUyBis:=2 else FormatUyBis:=1;
   if err>0 then
   begin
      ShowMessage('La constante '+edUniteY.Text+' (unit de graduation en Y) n''est pas correcte');
      edUniteY.Text:=FloatToStrF(Uy,ffGeneral,10,4);
   end;
   if F(ch,1)<=0 then
   begin
      ShowMessage('La constante '+edUniteY.Text+' n''est pas strictement positive');
      edUniteY.Text:=FloatToStrF(Uy,ffGeneral,10,4);
   end;
//   TryStrToFloat(edUniteY.text,x);
//   x:=udessin.arrondi(x);
//   edUniteY.text:=FloatToStrF(x,ffgeneral,1,2);
   InformationMinMax;
end;

procedure TfmRepere.edLongueurUxExit(Sender: TObject);
var ch : string;
    k  : integer;
    r  : real;
begin
   ch:=edLongueurUx.text;
   k:=1;
   while (k<length(ch))and(ch[k] in ['0'..'9',DecimalSeparator]) do inc(k);
   ch:=copy(ch,1,k);
   r:=StrToFloat(ch)*10;
   udUx.Position:=round(r);
   InformationMinMax;
end;

procedure TfmRepere.edPosAxeXExit(Sender: TObject);
var ch : string;
    k  : integer;
    r  : real;
begin
   ch:=edPosAxeX.text;
   k:=1;
   while (k<length(ch))and(ch[k] in ['0'..'9',DecimalSeparator]) do inc(k);
   ch:=copy(ch,1,k);
   r:=StrToFloat(ch)*10;
   udPosAxeX.Position:=round(r);
   InformationMinMax;
end;

procedure TfmRepere.edLongueurUyExit(Sender: TObject);
var ch : string;
    k  : integer;
    r  : real;
begin
   ch:=edLongueurUy.text;
   k:=1;
   while (k<length(ch))and(ch[k] in ['0'..'9',DecimalSeparator]) do inc(k);
   ch:=copy(ch,1,k);
   r:=StrToFloat(ch)*10;
   udUy.Position:=round(r);
   InformationMinMax;
end;

procedure TfmRepere.edPosAxeYExit(Sender: TObject);
var ch : string;
    k  : integer;
    r  : real;
begin
   ch:=edPosAxeY.text;
   k:=1;
   while (k<length(ch))and(ch[k] in ['0'..'9',DecimalSeparator]) do inc(k);
   ch:=copy(ch,1,k);
   r:=StrToFloat(ch)*10;
   udPosAxeY.Position:=round(r);
   InformationMinMax;
end;

procedure TfmRepere.cbGraduationsPar5mmClick(Sender: TObject);
begin
   if cbGraduationsPar5mm.Checked then
   begin
      UdUx.Increment:=5;
      UdUy.Increment:=5;
   end
   else
   begin
      UdUx.Increment:=1;
      UdUy.Increment:=1;
   end;
end;

Procedure DessinerGrille;
var i,j,k,a,b,c : integer;
   r:real;
   CanevasGrille:TCanvas;
begin
	if blAntiCrenelage
   	then begin
      ResEX:=ResEX*4;
      ResEY:=ResEY*4;
      CanevasGrille:=GrosDessin.Canvas;
      CanevasGrille.Pen.Width:=4;
      c:=420
      end else begin
      CanevasGrille:=PetitDessin.Canvas;
      CanevasGrille.Pen.Width:=1;
      c:=105
      end;
   with CanevasGrille do
   begin
      brush.color:=fmRepere.cdCouleurFond.color;
      brush.Style:=bsSolid;
      rectangle(0,0,c,c);
      brush.style:=bsClear;
      pen.color:=fmRepere.cdCouleurGrille.Color;
      if fmRepere.rbCroix.Checked then for i:=0 to round(c*25.4/ResEX/tpc) do for j:=0 to round(c*25.4/ResEY/tpc) do
      begin
         MoveTo(round((tpc*i-0.5)*ResEX/25.4),round(tpc*j*ResEY/25.4));
         LineTo(round((tpc*i+0.5)*ResEX/25.4),round(tpc*j*ResEY/25.4));
         MoveTo(round(tpc*i*ResEX/25.4),round((tpc*j-0.5)*ResEY/25.4));
         LineTo(round(tpc*i*ResEX/25.4),round((tpc*j+0.5)*ResEY/25.4));
      end;
      if fmRepere.rbPointillesFins.checked then
      begin
         for i:=0 to round(c*25.4/ResEX/tpc) do for k:=0 to round(c*25.4/ResEY)
         	do begin
         	if blAntiCrenelage
            	then Ellipse(round(tpc*i*ResEX/25.4-2),round(k*ResEY/25.4-2),round(tpc*i*ResEX/25.4+1),round(k*ResEY/25.4+1))
               else pixels[round(tpc*i*ResEX/25.4),round(k*ResEY/25.4)]:=fmRepere.cdCouleurGrille.Color;
            end;
         for j:=0 to round(c*25.4/ResEY/tpc) do for k:=0 to round(c*25.4/ResEX)
         	do begin
            if blAntiCrenelage
            	then Ellipse(round(k*ResEX/25.4-2),round(tpc*j*ResEY/25.4-2),round(k*ResEX/25.4+1),round(tpc*j*ResEY/25.4+1))
            	else pixels[round(k*ResEX/25.4),round(tpc*j*ResEY/25.4)]:=fmRepere.cdCouleurGrille.Color;
            end;
      end;
      if fmRepere.rbPointillesMoyens.checked then
      begin
         for i:=0 to round(c*25.4/ResEX/tpc) do for k:=0 to round(c*25.4/ResEY) do
         begin
         a:=round(tpc*i*ResEX/25.4);b:=round(k*ResEY/25.4);
         if blAntiCrenelage
         	then begin
            Ellipse(a-4,b-4,a+3,b+3);
            end else begin
            pixels[a-1,b-1]:=fmRepere.cdCouleurGrille.Color;pixels[a,b-1]:=fmRepere.cdCouleurGrille.Color;
            pixels[a-1,b]:=fmRepere.cdCouleurGrille.Color;pixels[a,b]:=fmRepere.cdCouleurGrille.Color;
            end;
         end;
         for j:=0 to round(c*25.4/ResEY/tpc) do for k:=0 to round(c*25.4/ResEX) do
         begin
            a:=round(k*ResEX/25.4);b:=round(tpc*j*ResEY/25.4);
         if blAntiCrenelage
         	then begin
            Ellipse(a-4,b-4,a+3,b+3);
            end else begin
            pixels[a-1,b-1]:=fmRepere.cdCouleurGrille.Color;pixels[a,b-1]:=fmRepere.cdCouleurGrille.Color;
            pixels[a-1,b]:=fmRepere.cdCouleurGrille.Color;pixels[a,b]:=fmRepere.cdCouleurGrille.Color;
            end;
         end;
      end;
      if fmRepere.rbTirets.checked then
      begin
         {for i:=0 to round(105*25.4/ResEX/5) do for k:=0 to round(105*25.4/ResEY/1.25) do
         begin
            MoveTo(round(5*i*ResEX/25.4),round((1.25*k-0.625)*ResEY/25.4));
            if odd(k+1) then LineTo(round(5*i*ResEX/25.4),round((1.25*k+0.625)*ResEY/25.4));
         end;
         for j:=0 to round(105*25.4/ResEY/5) do for k:=0 to round(105*25.4/ResEX/1.25) do
         begin
            MoveTo(round((1.25*k-0.625)*ResEX/25.4),round(5*j*ResEY/25.4));
            if odd(k+1) then LineTo(round((1.25*k+0.625)*ResEX/25.4),round(5*j*ResEY/25.4));
         end;}
         for i:=0 to round(c*25.4/ResEX/tpc) do  //i=abscisse
            for j:=0 to Round(c*254/LongueurTirets/ResEY/2) do
            begin
               MoveTo(round(i*10*tpc*ResEX/254),Round(2*j*LongueurTirets*ResEY/254));
               LineTo(round(i*10*tpc*ResEX/254),Round((2*j+1)*LongueurTirets*ResEY/254));
            end;
         for j:=0 to round(c*25.4/ResEY/tpc) do  //j=ordonne
            for i:=0 to Round(c*254/LongueurTirets/ResEX/2) do
            begin
               MoveTo(Round(2*i*LongueurTirets*ResEX/254),round(j*10*tpc*ResEY/254));
               LineTo(Round((2*i+1)*LongueurTirets*ResEX/254),round(j*10*tpc*ResEY/254));
            end;
      end;
      if fmRepere.rbPetitsCarreaux.checked then for i:=0 to round(c*25.4/ResEX/tpc) do
      begin
         MoveTo(0,round(tpc*i*ResEY/25.4));LineTo(c+10,round(tpc*i*ResEY/25.4));
         MoveTo(round(tpc*i*ResEX/25.4),0);LineTo(round(tpc*i*ResEX/25.4),c+10);
      end;
      if fmRepere.rbPapierMillimetre.Checked then
      begin
         for i:=0 to round(c*25.4/ResEX) do
         begin
         	if blAntiCrenelage
            	then begin
               pen.Width:=round(0.1*ResEX/25.4);
            	if i mod 5 = 0 then pen.Width:=round(0.2*ResEX/25.4);
            	if i mod 10 = 0 then pen.Width:=round(0.3*ResEX/25.4);
               end else begin
            	if i mod 5 = 0 then pen.Width:=2 else pen.Width:=1;
            	end;
            MoveTo(round(i*ResEX/25.4),0);LineTo(round(i*ResEX/25.4),c+10);
         end;
         for i:=0 to round(c*25.4/ResEY) do
         begin
         	if blAntiCrenelage
            	then begin
               pen.Width:=round(0.1*ResEX/25.4);
            	if i mod 5 = 0 then pen.Width:=round(0.2*ResEX/25.4);
            	if i mod 10 = 0 then pen.Width:=round(0.3*ResEX/25.4);
               end else begin
            	if i mod 5 = 0 then pen.Width:=2 else pen.Width:=1;
            	end;
            MoveTo(0,round(i*ResEY/25.4));LineTo(c+10,round(i*ResEY/25.4));
         end;
      end;
      if fmRepere.rbPapierPointe.Checked
         then begin
         r:=DiametrePoints/20.0;       //rayon des points en mm
         brush.color:=fmRepere.cdCouleurGrille.Color;
         for i:=0 to round(c*25.4/ResEX/tpc) do for j:=0 to round(c*25.4/ResEY/tpc) do
            begin
            Ellipse(round((tpc*i-r)*ResEX/25.4) ,round((tpc*j-r)*ResEY/25.4) ,round((tpc*i+r)*ResEX/25.4) ,round((tpc*j+r)*ResEY/25.4) );
            end;
         end;
   end;
   if blAntiCrenelage
   	then begin
      ResEX:=ResEX div 4;
      ResEY:=ResEY div 4;
      fmdessin.FastAntiAliasPicture(GrosDessin,PetitDessin);
      end;
   fmrepere.Image1.picture.bitmap.assign(PetitDessin);
end;

procedure TfmRepere.FormShow(Sender: TObject);
begin
   InformationMinMax;
   DessinerGrille;
   rbTirets.Caption:='Petits tirets ('+inttostr(LongueurTirets div 10)+','+inttostr(LongueurTirets mod 10)+' mm)';
   udLongueurTirets.Position:=LongueurTirets;
end;

procedure TfmRepere.FormCreate(Sender: TObject);
begin
   GrosDessin:=TBitmap.Create;
   GrosDessin.PixelFormat:=pf24bit;
   Grosdessin.Width:=420;
   Grosdessin.Height:=420;
   PetitDessin:=TBitmap.Create;
   PetitDessin.PixelFormat:=pf24bit;
   Petitdessin.Width:=105;
   Petitdessin.Height:=105;
   {sbAucune.Glyph.LoadFromResourceName(HInstance,'AUCUNEGRILLE');
   sbCroix.Glyph.LoadFromResourceName(HInstance,'PETITESCROIX');
   sbPetitsCarreaux.Glyph.LoadFromResourceName(HInstance,'PETITSCARREAUX');
   sbPointillesFins.Glyph.LoadFromResourceName(HInstance,'POINTILLES');
   sbPointillesMoyens.Glyph.LoadFromResourceName(HInstance,'POINTILLESMOYENS');
   sbTirets.Glyph.LoadFromResourceName(HInstance,'TIRETS');}
end;

procedure TfmRepere.btPoliceGraduationsClick(Sender: TObject);
begin
   FontDialog1.Font.name:=PoliceGraduations.name;
   FontDialog1.Font.size:=PoliceGraduations.size;
   FontDialog1.Font.style:=PoliceGraduations.style;
   FontDialog1.Font.color:=PoliceGraduations.color;
   if FontDialog1.execute then
   begin
      PoliceGraduations.name:=FontDialog1.Font.name;
      PoliceGraduations.size:=FontDialog1.Font.size;
      PoliceGraduations.style:=FontDialog1.Font.style;
      PoliceGraduations.color:=FontDialog1.Font.color;
      btPoliceGraduations.caption:=PoliceGraduations.name+' - '+inttostr(PoliceGraduations.size);
      btPoliceGraduations.Font.color:=PoliceGraduations.color;
      btPoliceGraduations.Font.style:=PoliceGraduations.style;
   end;
end;

procedure TfmRepere.rbAucuneClick(Sender: TObject);
begin
   DessinerGrille;
end;

procedure TfmRepere.rbCroixClick(Sender: TObject);
begin
   DessinerGrille;
end;

procedure TfmRepere.rbPointillesFinsClick(Sender: TObject);
begin
   DessinerGrille;
end;

procedure TfmRepere.rbPointillesMoyensClick(Sender: TObject);
begin
   DessinerGrille;
end;

procedure TfmRepere.rbTiretsClick(Sender: TObject);
begin
   DessinerGrille;
end;

procedure TfmRepere.rbPetitsCarreauxClick(Sender: TObject);
begin
   DessinerGrille;
end;

procedure TfmRepere.rbPapierPointeClick(Sender: TObject);
begin
   DessinerGrille;
end;

procedure TfmRepere.btCouleurGrilleClick(Sender: TObject);
var CouleurAvant : TColor;
begin
   CouleurAvant:=cdCouleurGrille.Color;
   if not cdCouleurGrille.Execute then cdCouleurGrille.Color:=CouleurAvant;
   DessinerGrille;
end;

procedure TfmRepere.btCouleurFondClick(Sender: TObject);
var CouleurAvant : TColor;
begin
   CouleurAvant:=cdCouleurFond.Color;
   if not cdCouleurFond.Execute then cdCouleurFond.Color:=CouleurAvant;
   DessinerGrille;
end;

procedure TfmRepere.cdCouleurGrilleShow(Sender: TObject);
var titleColorDlg : Pchar;
begin
   titleColorDlg := Pchar('Slection d''une couleur pour la grille');
   SendMessage(cdCouleurGrille.Handle, WM_SetText, 0, Integer(titleColorDlg));
end;

procedure TfmRepere.cdCouleurFondShow(Sender: TObject);
var titleColorDlg : Pchar;
begin
   titleColorDlg := Pchar('Slection d''une couleur pour le fond');
   SendMessage(cdCouleurFond.Handle, WM_SetText, 0, Integer(titleColorDlg));
end;

procedure TfmRepere.rbPapierMillimetreClick(Sender: TObject);
begin
   DessinerGrille;
end;

procedure TfmRepere.edUniteXKeyPress(Sender: TObject; var Key: Char);
begin
   if (key='.')or(key=',')then key:=DecimalSeparator;
end;

procedure TfmRepere.edUniteYKeyPress(Sender: TObject; var Key: Char);
begin
   if (key='.')or(key=',')then key:=DecimalSeparator;
end;

procedure TfmRepere.edLongueurUxKeyPress(Sender: TObject; var Key: Char);
begin
   if (key='.')or(key=',')then key:=DecimalSeparator;
end;

procedure TfmRepere.edLongueurUyKeyPress(Sender: TObject; var Key: Char);
begin
   if (key='.')or(key=',')then key:=DecimalSeparator;
end;

procedure TfmRepere.edPosAxeXKeyPress(Sender: TObject; var Key: Char);
begin
   if (key='.')or(key=',')then key:=DecimalSeparator;
end;

procedure TfmRepere.edPosAxeYKeyPress(Sender: TObject; var Key: Char);
begin
   if (key='.')or(key=',')then key:=DecimalSeparator;
end;

procedure TfmRepere.cbRepereVisibleClick(Sender: TObject);
begin
   cbAxeOx.Visible:=not cbRepereVisible.Checked;
   cbAxeOy.Visible:=not cbRepereVisible.Checked;
end;

procedure TfmRepere.Edit2Change(Sender: TObject);
begin
   edLongueurTirets.Text:=inttostr(udLongueurTirets.position div 10)+','+inttostr(udLongueurTirets.position mod 10)+' mm';
   LongueurTirets:=udLongueurTirets.position;
//   rbTirets.Caption:='Petits tirets ('+inttostr(LongueurTirets div 10)+','+inttostr(LongueurTirets mod 10)+' mm)';
   DessinerGrille;
end;

procedure TfmRepere.Edit3Change(Sender: TObject);
begin
   edDiametrePoints.Text:=inttostr(udDiametrePoints.position div 10)+','+inttostr(udDiametrePoints.position mod 10)+' mm';
   DiametrePoints:=udDiametrePoints.position;
   DessinerGrille;
end;


procedure TfmRepere.edTaillePetitsCarreauxChange(Sender: TObject);
begin
   tpc:=udTaillePetitsCarreaux.Position;
   DessinerGrille;
end;

procedure TfmRepere.edLongueurModuleX_mmChange(Sender: TObject);
var ch : string;
begin
   ch:=FloatToStrF(udLongueurModuleX.position/10,ffFixed,4,1);
   edLongueurModuleX.Text:=ch+' cm';
   InformationMinMax;
end;

procedure TfmRepere.cbLogXClick(Sender: TObject);
{Lorsque la case est coche, on passe en chelle logarithmique :
Si l'origine de l'axe est a alors elle devient 10^a
Par exemple si l'origine de l'axe est 2, elle devient 100.
La longueur de l'unit n'est pas utilise pour l'chelle logarithmique. On se sert de la longueur du module.
}
begin
   blLogX:=cbLogX.Checked;
   udLongueurModuleX.Enabled:=blLogX;
   edLongueurModuleX.Enabled:=blLogX;
   edLongueurUx.Enabled:=not(blLogX);
   edUnitex.Enabled:=not(blLogX);
   if blLogX then edOrigineAxeX.Text:=FloatToStrF(exp(ValConstante(edOrigineAxeX.Text)*ln(10)),ffGeneral,10,4)
             else edOrigineAxeX.Text:=FloatToStrF(ln(ValConstante(edOrigineAxeX.Text))/ln(10),ffGeneral,10,4);
   if blLogX or blLogY
      then begin
      rbCroix.Enabled:=False;
      rbPapierPointe.Enabled:=False;
      Label24.Enabled:=False;
      edDiametrePoints.Enabled:=False;
      Edit3.Enabled:=False;
      udDiametrePoints.Enabled:=False;
      end else begin
      rbCroix.Enabled:=True;
      rbPapierPointe.Enabled:=True;
      Label24.Enabled:=True;
      edDiametrePoints.Enabled:=True;
      Edit3.Enabled:=True;
      udDiametrePoints.Enabled:=True;
      end;
   InformationMinMax;
end;

procedure TfmRepere.cbLogYClick(Sender: TObject);
begin
   blLogY:=cbLogY.Checked;
   udLongueurModuleY.Enabled:=blLogY;
   edLongueurModuleY.Enabled:=blLogY;
   edLongueurUy.Enabled:=not(blLogY);
   edUniteY.Enabled:=not(blLogY);
   if blLogY then edOrigineAxeY.Text:=FloatToStrF(exp(ValConstante(edOrigineAxeY.Text)*ln(10)),ffGeneral,10,4)
             else edOrigineAxeY.Text:=FloatToStrF(ln(ValConstante(edOrigineAxeY.Text))/ln(10),ffGeneral,10,4);
   if blLogX or blLogY
      then begin
      rbCroix.Enabled:=False;
      rbPapierPointe.Enabled:=False;
      Label24.Enabled:=False;
      edDiametrePoints.Enabled:=False;
      Edit3.Enabled:=False;
      udDiametrePoints.Enabled:=False;
      end else begin
      rbCroix.Enabled:=True;
      rbPapierPointe.Enabled:=True;
      Label24.Enabled:=True;
      edDiametrePoints.Enabled:=True;
      Edit3.Enabled:=True;
      udDiametrePoints.Enabled:=True;
      end;
   InformationMinMax;
end;

procedure TfmRepere.edLongueurModuleY_mmChange(Sender: TObject);
var ch : string;
begin
   ch:=FloatToStrF(udLongueurModuleY.position/10,ffFixed,4,1);
   edLongueurModuleY.Text:=ch+' cm';
   InformationMinMax;
end;

procedure TfmRepere.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    if key=vk_Escape then close;
end;

procedure TfmRepere.btnAideClick(Sender: TObject);
begin
   Aide(11);
end;

end.
