unit uVecteur;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ColorGrd, Spin, shellAPI;

type
  TfmVecteur = class(TForm)
    Label1: TLabel;
    edNom: TEdit;
    rgNature: TRadioGroup;
    Panel1: TPanel;
    Label2: TLabel;
    edX: TEdit;
    Label3: TLabel;
    edY: TEdit;
    Panel2: TPanel;
    Label4: TLabel;
    edOrigine: TEdit;
    Label5: TLabel;
    edExtremite: TEdit;
    Label6: TLabel;
    cbPositionNom: TComboBox;
    GroupBox1: TGroupBox;
    rgEpaisseur: TRadioGroup;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    GroupBox3: TGroupBox;
    ColorGrid1: TColorGrid;
    cbDessinFleche: TCheckBox;
    btAnnuler: TButton;
    btOK: TButton;
    rgStyle: TGroupBox;
    rbStyle1: TRadioButton;
    Image1: TImage;
    rbStyle2: TRadioButton;
    Image2: TImage;
    rbStyle3: TRadioButton;
    Image3: TImage;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    edXOrigine: TEdit;
    edYOrigine: TEdit;
    SpinEdit1: TSpinEdit;
    Label10: TLabel;
    btnAide: TButton;
    procedure rgEpaisseurClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure rgNatureClick(Sender: TObject);
    procedure cbDessinFlecheClick(Sender: TObject);
    procedure edNomExit(Sender: TObject);
    procedure edOrigineExit(Sender: TObject);
    procedure edExtremiteExit(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnAideClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  fmVecteur: TfmVecteur;

implementation

uses uDessin;

{$R *.DFM}

procedure TfmVecteur.rgEpaisseurClick(Sender: TObject);
begin
   with Image1.canvas do
   begin
      pen.color:=clBtnFace;
      brush.style:=bsSolid;brush.color:=clBtnFace;Rectangle(0,0,89,17);
      pen.color:=clBlack;pen.width:=rgEpaisseur.ItemIndex+1;
      MoveTo(10,9);LineTo(80,9);
      MoveTo(72,5);LineTo(80,9);LineTo(71,14);
   end;
   with Image2.Canvas do
   begin
      pen.color:=clBtnFace;
      brush.style:=bsSolid;brush.color:=clBtnFace;Rectangle(0,0,89,17);
      pen.color:=clBlack;pen.width:=rgEpaisseur.ItemIndex+1;
      MoveTo(10,9);LineTo(73-pen.width,9);pen.width:=1;
      MoveTo(72,9);LineTo(72,5);LineTo(80,9);LineTo(72,13);LineTo(72,9);
      brush.style:=bsSolid;Brush.color:=clBlack;
      FloodFill(77,9,clBlack,fsBorder);
   end;
   with Image3.canvas do
   begin
      pen.color:=clBtnFace;
      brush.style:=bsSolid;brush.color:=clBtnFace;Rectangle(0,0,89,17);
      pen.color:=clBlack;pen.width:=rgEpaisseur.ItemIndex+1;
      MoveTo(10,9);LineTo(75-pen.width,9);pen.width:=1;
      MoveTo(75,9);LineTo(72,5);LineTo(80,9);LineTo(72,13);LineTo(75,9);
      brush.style:=bsSolid;Brush.color:=clBlack;
      FloodFill(77,9,clBlack,fsBorder);
   end;
end;

procedure TfmVecteur.FormActivate(Sender: TObject);
var k : integer;
begin
   for k:=0 to ComponentCount-1 do
         if Components[k] is TEdit then(Components[k] as TEdit).color:=clBtnFace;
   if cbPositionNom.ItemIndex<0 then cbPositionNom.ItemIndex:=0;
   edNom.Color:=clWindow;
   rgEpaisseurClick(sender);
   rgEpaisseur.Enabled:=cbDessinFleche.Checked;
   rbStyle1.Enabled:=cbDessinFleche.Checked;
   rbStyle2.Enabled:=cbDessinFleche.Checked;
   rbStyle3.Enabled:=cbDessinFleche.Checked;
   Label7.Enabled:=(cbDessinFleche.Checked)and(rgNature.ItemIndex=0);
   Label8.Enabled:=(cbDessinFleche.Checked)and(rgNature.ItemIndex=0);
   Label9.Enabled:=(cbDessinFleche.Checked)and(rgNature.ItemIndex=0);
   if (cbDessinFleche.Checked)and(rgNature.ItemIndex=0)then
   begin
      edXOrigine.Color:=clWhite;
      edYOrigine.Color:=clWhite;
   end
   else
   begin
      edXOrigine.Color:=clBtnFace;
      edYOrigine.Color:=clBtnFace;
   end;
   ColorGrid1.Enabled:=cbDessinFleche.Checked;
   rgNatureClick(sender);
end;

procedure TfmVecteur.rgNatureClick(Sender: TObject);
begin
   Label7.Enabled:=(rgNature.ItemIndex=0)and(cbDessinFleche.checked);
   Label8.Enabled:=(rgNature.ItemIndex=0)and(cbDessinFleche.checked);
   Label9.Enabled:=(rgNature.ItemIndex=0)and(cbDessinFleche.checked);
   if (rgNature.ItemIndex=0)and(cbDessinFleche.checked) then
   begin
      edXOrigine.Color:=clWhite;
      edYorigine.Color:=clWhite;
      cbPositionNom.Color:=clWindow;
   end
   else
   begin
      edXorigine.Color:=clBtnFace;
      edYOrigine.Color:=clBtnFace;
      cbPositionNom.Color:=clBtnFace;
   end;
   if rgNature.ItemIndex=0 then
   begin
      edX.Color:=clWindow;
      edY.Color:=clWindow;
      edOrigine.Color:=clBtnFace;
      edExtremite.Color:=clBtnFace;
   end
   else
   begin
      edX.Color:=clBtnFace;
      edY.Color:=clBtnFace;
      edOrigine.Color:=clWindow;
      edExtremite.Color:=clWindow;
   end;
end;

procedure TfmVecteur.cbDessinFlecheClick(Sender: TObject);
begin
   rgEpaisseur.Enabled:=cbDessinFleche.Checked;
   rbStyle1.Enabled:=cbDessinFleche.Checked;
   rbStyle2.Enabled:=cbDessinFleche.Checked;
   rbStyle3.Enabled:=cbDessinFleche.Checked;
   Label7.Enabled:=(cbDessinFleche.Checked)and(rgNature.ItemIndex=0);
   Label8.Enabled:=(cbDessinFleche.Checked)and(rgNature.ItemIndex=0);
   Label9.Enabled:=(cbDessinFleche.Checked)and(rgNature.ItemIndex=0);
   if (cbDessinFleche.Checked)and(rgNature.ItemIndex=0)then
   begin
      edXOrigine.Color:=clWhite;
      edYOrigine.Color:=clWhite;
      cbPositionNom.Color:=clWhite;
   end
   else
   begin
      edXOrigine.Color:=clBtnFace;
      edYOrigine.Color:=clBtnFace;
      cbPositionNom.Color:=clBtnFace;
   end;
   ColorGrid1.Enabled:=cbDessinFleche.Checked;
end;

function SansEspace(ch:string):string;
begin
   while pos(' ',ch)>0 do delete(ch,pos(' ',ch),1);
   SansEspace:=ch;
end;

procedure TfmVecteur.edNomExit(Sender: TObject);
begin
   edNom.Text:=SansEspace(edNom.Text);
end;

procedure TfmVecteur.edOrigineExit(Sender: TObject);
begin
   edOrigine.Text:=SansEspace(edOrigine.Text);
end;

procedure TfmVecteur.edExtremiteExit(Sender: TObject);
begin
   edExtremite.Text:=SansEspace(edExtremite.Text);
end;

procedure TfmVecteur.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    if key=vk_Escape then close;
end;

procedure TfmVecteur.btnAideClick(Sender: TObject);
begin
   Aide(31);
end;

end.
