program sinequanon;

uses
  Forms,
  uAccueil in 'uAccueil.pas' {fmAccueil},
  uDessin in 'uDessin.pas' {fmDessin},
  uFonctions in 'uFonctions.pas',
  uMiseEnPage in 'uMiseEnPage.pas' {fmMiseEnPage},
  uRepere in 'uRepere.pas' {fmRepere},
  uListeFonctions in 'uListeFonctions.pas' {fmListeFonctions},
  uAutresOptions in 'uAutresOptions.pas' {fmAutresOptions},
  uListeCourbesParametrees in 'uListeCourbesParametrees.pas' {fmListeCourbesParametrees},
  uApropos in 'uApropos.pas' {fmApropos},
  uFamille in 'uFamille.pas' {fmFamille},
  uPreferences in 'uPreferences.pas' {fmPreferences},
  uDroites in 'uDroites.pas' {fmDroites},
  uSchema in 'uSchema.pas' {fmSchema},
  uPoint in 'uPoint.pas' {fmPoint},
  uSegment in 'uSegment.pas' {fmSegment},
  uVecteur in 'uVecteur.pas' {fmVecteur},
  uObjDroite in 'uObjDroite.pas' {fmObjDroite},
  uDemiDroite in 'uDemiDroite.pas' {fmDemiDroite},
  uCercle in 'uCercle.pas' {fmCercle},
  uEllipse in 'uEllipse.pas' {fmEllipse},
  uCarre in 'uCarre.pas' {fmCarre},
  uPolygone in 'uPolygone.pas' {fmPolygone},
  uPolygonePredefini in 'uPolygonePredefini.pas' {fmPolygonePredefini},
  uAutresParametres in 'uAutresParametres.pas' {fmAutresParametres},
  uConique in 'uConique.pas' {fmConique},
  uPointParPoint in 'uPointParPoint.pas' {fmPointParPoint},
  uStatistiques1Var in 'uStatistiques1Var.pas' {fmStatistiques1var},
  uStatistiques2Var in 'uStatistiques2Var.pas' {fmStatistiques2Var},
  uLoiBinomiale in 'uLoiBinomiale.pas' {fmLoiBinomiale},
  uLoiPoisson in 'uLoiPoisson.pas' {fmLoiPoisson},
  uLoiNormale in 'uLoiNormale.pas' {fmLoiNormale},
  uSuite in 'uSuite.pas' {fmSuites},
  uIntegrale in 'uIntegrale.pas' {fmIntegrale},
  uBezier in 'uBezier.pas' {fmBezier},
  uEquation in 'uEquation.pas' {fmEquation},
  uAngle in 'uAngle.pas' {fmAngle},
  uTableValeurs in 'uTableValeurs.pas' {fmTableValeurs},
  uInequations in 'uInequations.pas' {fmInequations},
  uMethodeDesRectangles in 'uMethodeDesRectangles.pas' {fmMethodeDesRectangles},
  uLatex in 'uLatex.pas' {fmLatex},
  uCourbesPolaires in 'uCourbesPolaires.pas' {fmListeCourbesPolaires},
  uDerivee in 'uDerivee.pas' {fmDerivee},
  uPrimitive in 'uPrimitive.pas' {fmPrimitive},
  uSimulations in 'uSimulations.pas' {fmSimulations},
  uArbreDeProbabilites in 'uArbreDeProbabilites.pas' {fmArbreDeProbabilites},
  uPaint in 'uPaint.pas' {fmColorier},
  uTableauVarSgn in 'uTableauVarSgn.pas' {fmTableauVarSgn},
  uCouleurs in 'uCouleurs.pas' {Couleurs},
  uLoiExponentielle in 'uLoiExponentielle.pas' {fmLoiExponentielle},
  uRapporteur in 'uRapporteur.pas' {fmRapporteur};

//  uAide in 'uAide.pas' {fmAide};

{$R *.res}

var fmAccueil : TfmAccueil;

begin
  fmAccueil:=TfmAccueil.Create(Application);
  fmAccueil.Show;
  fmAccueil.Update;
  Application.Initialize;
  Application.Title := 'Sine qua non';
  Application.CreateForm(TfmDessin, fmDessin);
  Application.CreateForm(TfmMiseEnPage, fmMiseEnPage);
  Application.CreateForm(TfmRepere, fmRepere);
  Application.CreateForm(TfmListeFonctions, fmListeFonctions);
  Application.CreateForm(TfmAutresOptions, fmAutresOptions);
  Application.CreateForm(TfmListeCourbesParametrees, fmListeCourbesParametrees);
  Application.CreateForm(TfmApropos, fmApropos);
  Application.CreateForm(TfmFamille, fmFamille);
  Application.CreateForm(TfmPreferences, fmPreferences);
  Application.CreateForm(TfmDroites, fmDroites);
  Application.CreateForm(TfmSchema, fmSchema);
  Application.CreateForm(TfmPoint, fmPoint);
  Application.CreateForm(TfmSegment, fmSegment);
  Application.CreateForm(TfmVecteur, fmVecteur);
  Application.CreateForm(TfmObjDroite, fmObjDroite);
  Application.CreateForm(TfmDemiDroite, fmDemiDroite);
  Application.CreateForm(TfmCercle, fmCercle);
  Application.CreateForm(TfmEllipse, fmEllipse);
  Application.CreateForm(TfmCarre, fmCarre);
  Application.CreateForm(TfmPolygone, fmPolygone);
  Application.CreateForm(TfmPolygonePredefini, fmPolygonePredefini);
  Application.CreateForm(TfmAutresParametres, fmAutresParametres);
  Application.CreateForm(TfmConique, fmConique);
  Application.CreateForm(TfmPointParPoint, fmPointParPoint);
  Application.CreateForm(TfmStatistiques1var, fmStatistiques1var);
  Application.CreateForm(TfmStatistiques2Var, fmStatistiques2Var);
  Application.CreateForm(TfmLoiBinomiale, fmLoiBinomiale);
  Application.CreateForm(TfmLoiPoisson, fmLoiPoisson);
  Application.CreateForm(TfmLoiNormale, fmLoiNormale);
  Application.CreateForm(TfmSuites, fmSuites);
  Application.CreateForm(TfmIntegrale, fmIntegrale);
  Application.CreateForm(TfmBezier, fmBezier);
  Application.CreateForm(TfmEquation, fmEquation);
  Application.CreateForm(TfmAngle, fmAngle);
  Application.CreateForm(TfmTableValeurs, fmTableValeurs);
  Application.CreateForm(TfmInequations, fmInequations);
  Application.CreateForm(TfmMethodeDesRectangles, fmMethodeDesRectangles);
  Application.CreateForm(TfmLatex, fmLatex);
  Application.CreateForm(TfmListeCourbesPolaires, fmListeCourbesPolaires);
  Application.CreateForm(TfmDerivee, fmDerivee);
  Application.CreateForm(TfmPrimitive, fmPrimitive);
  Application.CreateForm(TfmSimulations, fmSimulations);
  Application.CreateForm(TfmArbreDeProbabilites, fmArbreDeProbabilites);
  Application.CreateForm(TfmColorier, fmColorier);
  Application.CreateForm(TfmTableauVarSgn, fmTableauVarSgn);
  Application.CreateForm(TCouleurs, Couleurs);
  Application.CreateForm(TfmLoiExponentielle, fmLoiExponentielle);
  Application.CreateForm(TfmRapporteur, fmRapporteur);
  //  Application.CreateForm(TfmAide, fmAide);
  fmAccueil.Hide;
  fmAccueil.Free;
  Application.Run;
end.
