unit uCercle;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ColorGrd, StdCtrls, ExtCtrls, shellAPI, ComCtrls;

type
  TfmCercle = class(TForm)
    rgDefinition: TRadioGroup;
    rgStyle: TRadioGroup;
    GroupBox3: TGroupBox;
    ColorGrid1: TColorGrid;
    ColorGrid2: TColorGrid;
    Label1: TLabel;
    Label2: TLabel;
    btAnnuler: TButton;
    btOK: TButton;
    Panel4: TPanel;
    Label3: TLabel;
    edCentre1: TEdit;
    Label4: TLabel;
    edRayon: TEdit;
    Panel5: TPanel;
    Label5: TLabel;
    Label6: TLabel;
    edCentre2: TEdit;
    edPoint: TEdit;
    Panel6: TPanel;
    Label7: TLabel;
    Label8: TLabel;
    edPoint1: TEdit;
    edPoint2: TEdit;
    Panel7: TPanel;
    Label9: TLabel;
    edTriangle1: TEdit;
    Panel8: TPanel;
    Label10: TLabel;
    edTriangle2: TEdit;
    Label11: TLabel;
    Label12: TLabel;
    edCentre3: TEdit;
    edDroite: TEdit;
    btnAide: TButton;
    GroupBox1: TGroupBox;
    Apercu: TImage;
    edEpaisseur: TEdit;
    udEpaisseur: TUpDown;
    procedure rgDefinitionClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure edCentre1Exit(Sender: TObject);
    procedure edCentre2Exit(Sender: TObject);
    procedure edRayonExit(Sender: TObject);
    procedure edPointExit(Sender: TObject);
    procedure edPoint1Exit(Sender: TObject);
    procedure edPoint2Exit(Sender: TObject);
    procedure edTriangle1Exit(Sender: TObject);
    procedure edTriangle2Exit(Sender: TObject);
    procedure edCentre3Exit(Sender: TObject);
    procedure edDroiteExit(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnAideClick(Sender: TObject);
    procedure edEpaisseurChange(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  fmCercle: TfmCercle;

implementation

uses uDessin;

{$R *.DFM}

procedure TfmCercle.rgDefinitionClick(Sender: TObject);
var k : integer;
begin
   for k:=0 to ComponentCount-1 do
   begin
      if Components[k] is TLabel then (Components[k] as TLabel).Enabled:=false;
      if Components[k] is TEdit and not(Components[k].Name='edEpaisseur')then
      begin
         (Components[k] as TEdit).color:=clBtnFace;
         (Components[k] as TEdit).Enabled:=false;
      end;
   end;
   Label1.Enabled:=true;Label2.Enabled:=true;
   case rgDefinition.ItemIndex of
      0 : begin
             edCentre1.Enabled:=true;edRayon.Enabled:=true;Label3.Enabled:=true;
             Label4.Enabled:=true;edCentre1.Color:=clWindow;edRayon.Color:=clWindow;
             if self.Visible then edCentre1.SetFocus;
          end;
      1 : begin
             edCentre2.Enabled:=true;edPoint.Enabled:=true;Label5.Enabled:=true;
             Label6.Enabled:=true;edCentre2.Color:=clWindow;edPoint.Color:=clWindow;
             if self.Visible then edCentre2.SetFocus;
          end;
      2 : begin
             edPoint1.Enabled:=true;edPoint2.Enabled:=true;Label7.Enabled:=true;
             Label8.Enabled:=true;edPoint1.Color:=clWindow;edPoint2.Color:=clWindow;
             if self.Visible then edPoint1.SetFocus;
          end;
      3 : begin
             edTriangle1.Enabled:=true;Label9.Enabled:=true;
             edTriangle1.Color:=clWindow;
             if self.Visible then edTriangle1.SetFocus;
          end;
      4 : begin
             edTriangle2.Enabled:=true;Label10.Enabled:=true;
             edTriangle2.Color:=clWindow;
             if self.Visible then edTriangle2.SetFocus;
          end;
      5 : begin
             edCentre3.Enabled:=true;edDroite.Enabled:=true;Label11.Enabled:=true;
             Label12.Enabled:=true;edCentre3.Color:=clWindow;edDroite.Color:=clWindow;
             if self.Visible then edCentre3.SetFocus;
          end;
   end;
end;

procedure TfmCercle.FormActivate(Sender: TObject);
begin
   rgDefinitionClick(sender);
end;

function SansEspace(ch:string):string;
begin
   while pos(' ',ch)>0 do delete(ch,pos(' ',ch),1);
   SansEspace:=ch;
end;

procedure TfmCercle.edCentre1Exit(Sender: TObject);
begin
   edCentre1.Text:=SansEspace(edCentre1.Text);
end;

procedure TfmCercle.edCentre2Exit(Sender: TObject);
begin
   edCentre2.Text:=SansEspace(edCentre2.Text);
end;

procedure TfmCercle.edRayonExit(Sender: TObject);
begin
   edRayon.Text:=SansEspace(edRayon.Text);
end;

procedure TfmCercle.edPointExit(Sender: TObject);
begin
   edPoint.Text:=SansEspace(edPoint.Text);
end;

procedure TfmCercle.edPoint1Exit(Sender: TObject);
begin
   edPoint1.Text:=SansEspace(edPoint1.Text);
end;

procedure TfmCercle.edPoint2Exit(Sender: TObject);
begin
   edPoint2.Text:=SansEspace(edPoint2.Text);
end;

procedure TfmCercle.edTriangle1Exit(Sender: TObject);
begin
   edTriangle1.Text:=SansEspace(edTriangle1.Text);
end;

procedure TfmCercle.edTriangle2Exit(Sender: TObject);
begin
   edTriangle2.Text:=SansEspace(edTriangle2.Text);
end;

procedure TfmCercle.edCentre3Exit(Sender: TObject);
begin
   edCentre2.Text:=SansEspace(edCentre2.Text);
end;

procedure TfmCercle.edDroiteExit(Sender: TObject);
begin
   edDroite.Text:=SansEspace(edDroite.Text);
end;

procedure TfmCercle.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    if key=vk_Escape then close;
end;

procedure TfmCercle.btnAideClick(Sender: TObject);
begin
   Aide(33);
end;

procedure TfmCercle.edEpaisseurChange(Sender: TObject);
begin
  edEpaisseur.Text:=inttostr(udEpaisseur.position div 10)+','+inttostr(udEpaisseur.position mod 10)+' mm';
  Apercu.Picture.Assign(fmDessin.ApercuLigne(udEpaisseur.position,ColorGrid1.ForeGroundColor));
end;

end.
