unit uDemiDroite;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ColorGrd, shellAPI;

type
  TfmDemiDroite = class(TForm)
    rgDefinition: TRadioGroup;
    Label1: TLabel;
    edOrigine: TEdit;
    Panel1: TPanel;
    edPoint: TEdit;
    Label2: TLabel;
    Panel2: TPanel;
    Label3: TLabel;
    edVecteurDirecteur: TEdit;
    Panel3: TPanel;
    edAnglePolaire: TEdit;
    rbDegres: TRadioButton;
    rbRadians: TRadioButton;
    rgEpaisseur: TRadioGroup;
    Panel4: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    rgStyle: TRadioGroup;
    GroupBox3: TGroupBox;
    ColorGrid1: TColorGrid;
    btAnnuler: TButton;
    btOK: TButton;
    Label4: TLabel;
    btnAide: TButton;
    procedure rgDefinitionClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure edOrigineExit(Sender: TObject);
    procedure edPointExit(Sender: TObject);
    procedure edVecteurDirecteurExit(Sender: TObject);
    procedure edAnglePolaireExit(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnAideClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  fmDemiDroite: TfmDemiDroite;

implementation

uses uDessin;

{$R *.DFM}

procedure TfmDemiDroite.rgDefinitionClick(Sender: TObject);
begin
   case rgDefinition.ItemIndex of
      0 : begin
             edPoint.Color:=clWindow;
             Label2.Enabled:=true;
             edVecteurDirecteur.Color:=clBtnFace;
             Label3.Enabled:=false;
             edAnglePolaire.Color:=clBtnFace;
             rbDegres.Enabled:=false;
             rbRadians.Enabled:=false;
             if Self.Visible then edPoint.SetFocus;
          end;
      1 : begin
             edPoint.Color:=clBtnFace;
             Label2.Enabled:=false;
             edVecteurDirecteur.Color:=clWindow;
             Label3.Enabled:=true;
             edAnglePolaire.Color:=clBtnFace;
             rbDegres.Enabled:=false;
             rbRadians.Enabled:=false;
             if Self.visible then edVecteurDirecteur.SetFocus;
          end;
      2 : begin
             edPoint.Color:=clBtnFace;
             Label2.Enabled:=false;
             edVecteurDirecteur.Color:=clBtnFace;
             Label3.Enabled:=false;
             edAnglePolaire.Color:=clWindow;
             rbDegres.Enabled:=true;
             rbRadians.Enabled:=true;
             if self.Visible then edAnglePolaire.SetFocus;
          end;
   end;
end;

procedure TfmDemiDroite.FormActivate(Sender: TObject);
begin
   rgDefinitionClick(sender);
end;

function SansEspace(ch:string):string;
begin
   while pos(' ',ch)>0 do delete(ch,pos(' ',ch),1);
   SansEspace:=ch;
end;

procedure TfmDemiDroite.edOrigineExit(Sender: TObject);
begin
   edOrigine.Text:=SansEspace(edOrigine.Text);
end;

procedure TfmDemiDroite.edPointExit(Sender: TObject);
begin
   edPoint.Text:=SansEspace(edPoint.Text);
end;

procedure TfmDemiDroite.edVecteurDirecteurExit(Sender: TObject);
begin
   edVecteurDirecteur.Text:=SansEspace(edVecteurDirecteur.Text);
end;

procedure TfmDemiDroite.edAnglePolaireExit(Sender: TObject);
begin
   edAnglePolaire.Text:=SansEspace(edAnglePolaire.Text);
end;

procedure TfmDemiDroite.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    if key=vk_Escape then close;
end;

procedure TfmDemiDroite.btnAideClick(Sender: TObject);
begin
   Aide(32); 
end;

end.
