unit uListeCourbesParametrees;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ColorGrd, ExtCtrls, StdCtrls, ComCtrls, shellAPI;

type
  TfmListeCourbesParametrees = class(TForm)
    LabelExpressionsX: TLabel;
    LabelNomsX: TLabel;
    btnOK: TButton;
    gbFormat: TGroupBox;
    rgStyle: TRadioGroup;
    Panel4: TPanel;
    Label1: TLabel;
    cgCouleur: TColorGrid;
    btnAutresOptions: TButton;
    btnAnnuler: TButton;
    LabelNomsY: TLabel;
    LabelExpressionsY: TLabel;
    gbParametreT: TGroupBox;
    Label2: TLabel;
    edTMin: TEdit;
    Label3: TLabel;
    edTMax: TEdit;
    Label4: TLabel;
    edNbT: TEdit;
    udNbT: TUpDown;
    Label5: TLabel;
    Label36: TLabel;
    udEpaisseurCourbesParametrees: TUpDown;
    Edit2: TEdit;
    EdEpaisseurCourbesParametrees: TEdit;
    btnAide: TButton;
    Apercu: TImage;
    procedure FormCreate(Sender: TObject);
    procedure edCourbeParametreeExit(Sender : TObject);
    procedure edCourbeParametreeEnter(Sender : TObject);
    procedure FormShow(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
    procedure cgCouleurChange(Sender: TObject);
    procedure edTMinExit(Sender: TObject);
    procedure edTMaxExit(Sender: TObject);
    procedure udNbTExit(Sender: TObject);
    procedure btnAnnulerClick(Sender: TObject);
//  procedure rgEpaisseurClick(Sender: TObject);
    procedure rgStyleClick(Sender: TObject);
    procedure btnAutresOptionsClick(Sender: TObject);
    procedure edNbTExit(Sender: TObject);
    procedure udNbTChanging(Sender: TObject; var AllowChange: Boolean);
    procedure edTMinKeyPress(Sender: TObject; var Key: Char);
    procedure edTMaxKeyPress(Sender: TObject; var Key: Char);
    procedure CheckBox1Click(Sender: TObject);
    procedure edCourbeParametreeKeyPress(Sender: TObject; var Key: Char);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Edit2Change(Sender: TObject);
    procedure btnAideClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  fmListeCourbesParametrees: TfmListeCourbesParametrees;
  edCourbesParametrees : array[1..2,1..10] of TEdit;
  lbNomsCourbes : array[1..2,1..10] of TLabel;
  cbDessiner : array[1..10] of TCheckBox;
  lbIntervalles : array[1..10] of TLabel;

implementation
uses uDessin, ufonctions, uAutresOptions;
var CourbesParametreesBis : array[1..10] of TCourbesParametrees;
{$R *.DFM}

procedure TfmListeCourbesParametrees.FormCreate(Sender: TObject);
var k,i : byte;
    h   : integer;
begin
   h:=ClientHeight div 12;
   for i:=1 to 2 do for k:=1 to 10 do
   begin
      edCourbesParametrees[i,k]:=TEdit.Create(self);
      edCourbesParametrees[i,k].parent:=fmListeCourbesParametrees;
      edCourbesParametrees[i,k].left:=60+250*(i-1);
      edCourbesParametrees[i,k].top:=25+h*(k-1);
      edCourbesParametrees[i,k].width:=190;
      edCourbesParametrees[i,k].text:='';
      edCourbesParametrees[i,k].font.name:='Courier New';
      edCourbesParametrees[i,k].font.size:=10;
      edCourbesParametrees[i,k].font.color:=clBlack;
      edCourbesParametrees[i,k].tag:=10*i+k;
      edCourbesParametrees[i,k].OnExit:=edCourbeParametreeExit;
      edCourbesParametrees[i,k].OnEnter:=edCourbeParametreeEnter;
      edCourbesParametrees[i,k].OnKeyPress:=edCourbeParametreeKeyPress;
      if i=1 then
      begin
         cbDessiner[k]:=TCheckBox.Create(self);
         cbDessiner[k].parent:=fmListeCourbesParametrees;
         cbDessiner[k].caption:='';
         cbDessiner[k].left:=505;
         cbDessiner[k].top:=25+h*(k-1);
         cbDessiner[k].width:=20;
         cbDessiner[k].checked:=false;
         cbDessiner[k].tag:=k;
         cbDessiner[k].OnClick:=CheckBox1Click;
         lbIntervalles[k]:=TLabel.Create(self);
         lbIntervalles[k].parent:=fmListeCourbesParametrees;
         lbIntervalles[k].caption:='';
         lbIntervalles[k].top:=28+h*(k-1);
         lbIntervalles[k].left:=530;
         lbIntervalles[k].width:=52;
      end;
   end;
   for k:=1 to 10 do for i:=1 to 2 do edCourbesParametrees[i,k].TabOrder:=2*(k-1)+i-1;
   LabelNomsX.left:=5;
   LabelExpressionsX.left:=60;
   LabelNomsY.left:=255;
   LabelExpressionsY.left:=310;
   for i:=1 to 2 do for k:=1 to 10 do
   begin
      lbNomsCourbes[i,k]:=TLabel.Create(self);
      lbNomsCourbes[i,k].parent:=fmListeCourbesParametrees;
      lbNomsCourbes[i,k].left:=5+250*(i-1);
      lbNomsCourbes[i,k].top:=28+h*(k-1);
      lbNomsCourbes[i,k].font.name:='Courier New';
      lbNomsCourbes[i,k].font.size:=10;
      lbNomsCourbes[i,k].font.color:=clBlack;
      if i=1 then lbNomsCourbes[i,k].caption:='x'+inttostr(k)+'(t)='
             else lbNomsCourbes[i,k].caption:='y'+inttostr(k)+'(t)='
   end;
end;

procedure TfmListeCourbesParametrees.edCourbeParametreeExit(Sender : TObject);
var ch,chErreur : string;
    k           : integer;
    err : byte;
begin
   with (Sender as TEdit) do
   begin
      ch:=Text;
      err:=0;
      NomVar:='T';
      ch:=Traduction(ch,err);
      if err>0 then
      begin
         if err=3 then chErreur:='problme de parenthses.';
         if err=4 then chErreur:='fonction ou symbole non reconnu.';
         if err=5 then chErreur:='mauvaise utilisation du symbole ';
         ShowMessage('Erreur de syntaxe dans la fonction f(t) = '+Text+ ' : '+chErreur);
      end;
      k:=(tag-1)mod 10 +1;
      if (tag-1)div 10=1 then CourbesParametreesBis[k].ExpressionX:=Text
                         else CourbesParametreesBis[k].ExpressionY:=Text ;
      cbDessiner[k].checked:=(CourbesParametreesBis[k].ExpressionX<>'')and(CourbesParametreesBis[k].ExpressionY<>'');
      CourbesParametreesBis[k].blDessiner:=cbDessiner[k].checked;
      if (CourbesParametreesbis[k].ExpressionX<>'')and(CourbesParametreesbis[k].ExpressionY<>'')
          then lbIntervalles[k].caption:='['+CourbesParametreesbis[k].chTMin+';'+CourbesParametreesbis[k].chTMax+']'
          else lbIntervalles[k].caption:='';
   end;
end;

procedure TfmListeCourbesParametrees.edCourbeParametreeEnter(Sender : TObject);
var k,num,den : integer;
    ch        : string;
begin
   with (Sender as TEdit) do
   begin
      for k:=1 to 10 do
      begin
         edCourbesParametrees[1,k].color:=clWhite;
         edCourbesParametrees[2,k].color:=clWhite;
         lbNomsCourbes[1,k].font.style:=[];
         lbNomsCourbes[2,k].font.style:=[];
      end;
      k:=(tag-1)mod 10 +1;
      gbFormat.caption:='Format courbe paramtre '+inttostr(k);
//      showmessage('k='+inttostr(k)+' : chTMin='+CourbesParametreesBis[k].chTMin);
      if CourbesParametreesBis[k].expressionX='' then
      begin        //valeurs prfrentielles pour les nouvelles courbes paramtres
         cgCouleur.ForeGroundIndex:=cgCouleur.ColorToIndex(clCourbesParametrees);
//       rgEpaisseur.ItemIndex:=EpaisseurCourbesParametrees-1;
   		udEpaisseurCourbesParametrees.Position:=EpaisseurCourbesParametrees;
         rgStyle.ItemIndex:=ord(StyleCourbesParametrees);
         if DecomposeFraction(abs(TMin)/pi,num,den)or(den=1) then
         begin
            ch:=inttostr(num)+'pi/'+inttostr(den);
            if num=0 then ch:='0';
            if num=1 then delete(ch,1,1);
            if den=1 then delete(ch,length(ch)-1,2);
            if TMin<0 then ch:='-'+ch;
            edTMin.Text:=ch;
         end
         else edTMin.Text:=CourbesParametreesBis[k].chTMin;
         if DecomposeFraction(abs(TMax)/pi,num,den)or(den=1) then
         begin
            ch:=inttostr(num)+'pi/'+inttostr(den);
            if num=0 then ch:='0';
            if num=1 then delete(ch,1,1);
            if den=1 then delete(ch,length(ch)-1,2);
            if TMax<0 then ch:='-'+ch;
            edTMax.Text:=ch;
         end
         else edTMax.Text:=CourbesParametreesBis[k].chTMax;
         udNbt.Position:=nbt;
      end
      else
      begin
         cgCouleur.ForeGroundIndex:=cgCouleur.ColorToIndex(CourbesParametreesBis[k].Couleur);
//       rgEpaisseur.ItemIndex:=CourbesParametreesBis[k].Epaisseur-1;
         udEpaisseurCourbesParametrees.Position:=CourbesParametreesBis[k].Epaisseur;
         rgStyle.ItemIndex:=ord(CourbesParametreesBis[k].style);
         edTMin.Text:=CourbesParametreesBis[k].chTMin;
         edTMax.Text:=CourbesParametreesBis[k].chTMax;
         udNbt.Position:=CourbesParametreesBis[k].nbt;
      end;
      gbParametreT.Caption:='Intervalle de variation du paramtre T (Courbe paramtre n '
                                        +inttostr(k)+')';
      edCourbesParametrees[1,k].color:=$00aaffff;
      edCourbesParametrees[2,k].color:=$00aaffff;
      lbNomsCourbes[1,k].font.style:=[fsBold];
      lbNomsCourbes[2,k].font.style:=[fsBold];
   end;
end;

procedure TfmListeCourbesParametrees.FormShow(Sender: TObject);
var k : byte;
begin
   for k:=1 to 10 do   // on effectue une copie des donnes avant de les modifier ventuellement
   begin
      CourbesParametreesBis[k]:=CourbesParametrees[k];
      edCourbesParametrees[1,k].Text:=CourbesParametrees[k].ExpressionX;
      edCourbesParametrees[2,k].Text:=CourbesParametrees[k].ExpressionY;
      edCourbesParametrees[1,k].Font.color:=CourbesParametrees[k].couleur;
      edCourbesParametrees[2,k].Font.color:=CourbesParametrees[k].couleur;
      if(CourbesParametrees[k].ExpressionX<>'')and(CourbesParametrees[k].ExpressionY<>'')
          then lbIntervalles[k].caption:='['+CourbesParametrees[k].chTMin+';'+CourbesParametrees[k].chTMax+']'
          else lbIntervalles[k].caption:='';
   end;
   edCourbesParametrees[1,1].SetFocus;
end;

procedure TfmListeCourbesParametrees.btnOKClick(Sender: TObject);
var k : byte;
begin
   for k:=1 to 10 do CourbesParametrees[k]:=CourbesParametreesBis[k];
end;

procedure TfmListeCourbesParametrees.cgCouleurChange(Sender: TObject);
var ch : string;
    k  : byte;
begin
   ch:=gbFormat.caption;
   if ch[length(ch)]='0' then ch:=Copy(ch,length(ch)-1,2)
                         else ch:=Copy(ch,length(ch),1);
   k:=StrToInt(ch);
   CourbesParametreesBis[k].Couleur:=cgCouleur.ForegroundColor;
   edCourbesParametrees[1,k].Font.Color:=CourbesParametreesBis[k].Couleur;
   edCourbesParametrees[2,k].Font.Color:=CourbesParametreesBis[k].Couleur;
end;

procedure TfmListeCourbesParametrees.edTMinExit(Sender: TObject);
var ch  : string;
    err : byte;
    k   : integer;
begin
   ch:=gbFormat.Caption;  //rcupration du n de la courbe  l'aide du caption de gbFormat
                          //gbFormat.caption='Format de la courbe n k' (1<=k<=10)

   if ch[length(ch)]='0' then ch:=Copy(ch,length(ch)-1,2)
                         else ch:=Copy(ch,length(ch),1);
   k:=strtoint(ch);
   NomVar:='X';
   ch:=Traduction(edTMin.text,err);
   if (err>0)or(pos('X',ch)>0) then
   begin
      ShowMessage('La constante '+edTMin.Text+' n''est pas correcte');
      //on remet la valeur initiale de TMin
      edTMin.Text:=CourbesParametreesBis[k].chTMin;
   end;
   CourbesParametreesBis[k].chTMin:=edTMin.Text;
   lbIntervalles[k].caption:='['+edTMin.Text+';'+edTMax.Text+']';
end;

procedure TfmListeCourbesParametrees.edTMaxExit(Sender: TObject);
var ch  : string;
    err : byte;
    k   : integer;
begin
   ch:=gbFormat.Caption;  //rcupration du n de la courbe  l'aide du caption de gbFormat
                          //gbFormat.caption='Format de la courbe n k' (1<=k<=10)

   if ch[length(ch)]='0' then ch:=Copy(ch,length(ch)-1,2)
                         else ch:=Copy(ch,length(ch),1);
   k:=strtoint(ch);
   NomVar:='X';
   ch:=Traduction(edTMax.text,err);
   if (err>0)or(pos('X',ch)>0) then
   begin
      ShowMessage('La constante '+edTMax.Text+' n''est pas correcte');
      //on remet la valeur initiale de chTMax
      edTMax.Text:=CourbesParametreesBis[k].chTMax;
   end;
   CourbesParametreesBis[k].chTMax:=edTMax.Text;
   lbIntervalles[k].caption:='['+edTMin.Text+';'+edTMax.Text+']';
end;

procedure TfmListeCourbesParametrees.udNbTExit(Sender: TObject);
var ch : string;
    k  : integer;
begin
   ch:=gbFormat.Caption;  //rcupration du n de la courbe  l'aide du caption de gbFormat
                          //gbFormat.caption='Format de la courbe n k' (1<=k<=10)

   if ch[length(ch)]='0' then ch:=Copy(ch,length(ch)-1,2)
                         else ch:=Copy(ch,length(ch),1);
   k:=strtoint(ch);
   CourbesParametreesBis[k].nbT:=udNbT.Position;
end;

procedure TfmListeCourbesParametrees.btnAnnulerClick(Sender: TObject);
begin
   {rien  faire :
      - le tableau CourbesParametrees[] n'est pas mis  jour,
      - les TEdits seront rinitialiss  la prochaine ouverture
    }
end;
{
procedure TfmListeCourbesParametrees.rgEpaisseurClick(Sender: TObject);
var ch : string;
    k  : integer;
begin
   ch:=gbFormat.Caption;  //rcupration du n de la courbe  l'aide du caption de gbFormat
                          //gbFormat.caption='Format de la courbe n k' (1<=k<=10)

   if ch[length(ch)]='0' then ch:=Copy(ch,length(ch)-1,2)
                         else ch:=Copy(ch,length(ch),1);
   k:=strtoint(ch);
   CourbesParametreesBis[k].epaisseur:=rgEpaisseur.ItemIndex+1;
end;
}
procedure TfmListeCourbesParametrees.rgStyleClick(Sender: TObject);
var ch : string;
    k  : integer;
begin
   ch:=gbFormat.Caption;  //rcupration du n de la courbe  l'aide du caption de gbFormat
                          //gbFormat.caption='Format de la courbe n k' (1<=k<=10)

   if ch[length(ch)]='0' then ch:=Copy(ch,length(ch)-1,2)
                         else ch:=Copy(ch,length(ch),1);
   k:=strtoint(ch);
   CourbesParametreesBis[k].style:=TStyleCourbe(rgStyle.ItemIndex);
end;

procedure TfmListeCourbesParametrees.btnAutresOptionsClick(
  Sender: TObject);
var ch : string;
    k,i  : byte;
begin
   with fmAutresOptions do
   begin
      ch:=gbFormat.caption;
      if ch[length(ch)]='0' then ch:=Copy(ch,length(ch)-1,2)
                            else ch:=Copy(ch,length(ch),1);
      k:=StrToInt(ch);
      Tag:=k;
      Caption:='Autres options de la courbe paramtre n '+ch;

      {on transfre les variables de la courbe k  la fiche des autres options
       puis, si on appuie sur le bouton OK, on rcupre les nouvelles valeurs}

      cbVoirProgressionDessin.Checked:=CourbesParametreesBis[k].blVoirProgressionDessin;
      cbEnveloppe.checked:=CourbesParametreesBis[k].blEnveloppeTangentielle;
      cbDeveloppee.Checked:=CourbesParametreesBis[k].blDeveloppeeNormale;
      udVitesse.Position:=CourbesParametreesBis[k].vitesse;
      for i:=1 to 10 do PointsParticuliers[i]:=CourbesParametreesBis[k].PointsParticuliers[i];
      if ShowModal=mrOK then
      begin
         CourbesParametreesBis[k].blVoirProgressionDessin:=cbVoirProgressionDessin.Checked;
         CourbesParametreesBis[k].blEnveloppeTangentielle:=cbEnveloppe.checked;
         CourbesParametreesBis[k].blDeveloppeeNormale:=cbDeveloppee.Checked;
         CourbesParametreesBis[k].vitesse:=udVitesse.Position;
         for i:=1 to 10 do CourbesParametreesBis[k].PointsParticuliers[i]:=PointsParticuliers[i];
      end;
   end;
end;

procedure TfmListeCourbesParametrees.edNbTExit(Sender: TObject);
var k,i,erreur : integer;
    ch       : string;
begin
   val(edNbT.text,k,erreur);if erreur>0 then k:=200;
   if erreur=0 then udNbT.Position:=k;
   ch:=gbFormat.caption;
   if ch[length(ch)]='0' then ch:=Copy(ch,length(ch)-1,2)
                         else ch:=Copy(ch,length(ch),1);
   i:=StrToInt(ch);
   CourbesParametreesBis[i].NbT:=k;
end;

procedure TfmListeCourbesParametrees.udNbTChanging(Sender: TObject;
  var AllowChange: Boolean);
begin
   if udNbT.Position>1000 then udNbT.Increment:=100
   else if udNbT.Position<100 then udNbT.Increment:=1
   else udNbT.Increment:=10;
end;

procedure TfmListeCourbesParametrees.edTMinKeyPress(Sender: TObject;
  var Key: Char);
begin
   if (key='.')or(key=',')then key:=DecimalSeparator;
end;

procedure TfmListeCourbesParametrees.edTMaxKeyPress(Sender: TObject;
  var Key: Char);
begin
   if (key='.')or(key=',')then key:=DecimalSeparator;
end;

procedure TfmListeCourbesParametrees.CheckBox1Click(Sender: TObject);
begin
   if sender is TCheckBox then with (Sender as TCheckBox) do
   begin
      CourbesParametreesBis[tag].blDessiner:=checked;
   end;
end;

procedure TfmListeCourbesParametrees.edCourbeParametreeKeyPress(
  Sender: TObject; var Key: Char);
begin
   if sender is TEdit then with (Sender as TEdit) do
      if Key='.' then Key:=DecimalSeparator;
end;

procedure TfmListeCourbesParametrees.FormKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
   if key=vk_Escape then close;
end;

procedure TfmListeCourbesParametrees.Edit2Change(Sender: TObject);
var ch : string;
    k  : integer;
begin
   edEpaisseurCourbesParametrees.Text:=inttostr(udEpaisseurCourbesParametrees.position div 10)+','
                                      +inttostr(udEpaisseurCourbesParametrees.position mod 10)+' mm';
	Apercu.Picture.Assign(fmDessin.ApercuLigne(udEpaisseurCourbesParametrees.position,cgCouleur.ForegroundColor));
   ch:=gbFormat.Caption;  //rcupration du n de la courbe  l'aide du caption de gbFormat
                          //gbFormat.caption='Format de la courbe n k' (1<=k<=10)

   if ch[length(ch)]='0' then ch:=Copy(ch,length(ch)-1,2)
                         else ch:=Copy(ch,length(ch),1);
   if ch<>'t' then
   begin
   	k:=strtoint(ch);
   	CourbesParametreesBis[k].epaisseur:=udEpaisseurCourbesParametrees.position;
   end;

end;

procedure TfmListeCourbesParametrees.btnAideClick(Sender: TObject);
begin
   Aide(20);
end;

end.


