unit uListeFonctions;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Stdctrls, ColorGrd, ExtCtrls, ComCtrls, shellAPI;

type
  TfmListeFonctions = class(TForm)
    LabelExpressions: TLabel;
    LabelNoms: TLabel;
    btnOK: TButton;
    gbFormat: TGroupBox;
    rgStyle: TRadioGroup;
    Panel4: TPanel;
    cgCouleur: TColorGrid;
    Label1: TLabel;
    btnAnnuler: TButton;
    btnAutresOptions: TButton;
    Label2: TLabel;
    btAbs: TButton;
    btArcCos: TButton;
    btArcSin: TButton;
    btArcTan: TButton;
    btArgCh: TButton;
    btArgSh: TButton;
    btArgTh: TButton;
    btCarre: TButton;
    btCos: TButton;
    btCh: TButton;
    btExp: TButton;
    btFrac: TButton;
    btInt: TButton;
    btLn: TButton;
    btLog: TButton;
    btRacine: TButton;
    btSh: TButton;
    btSin: TButton;
    btTan: TButton;
    btTh: TButton;
    btPlus: TButton;
    btMoins: TButton;
    btMultiplie: TButton;
    btDivise: TButton;
    btExposant: TButton;
    Button1: TButton;
    Button2: TButton;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    edEpaisseur: TEdit;
    Edit1: TEdit;
    udEpaisseur: TUpDown;
    btnAide: TButton;
    Apercu: TImage;
    procedure FormCreate(Sender: TObject);
    procedure edFonctionExit(Sender : TObject);
    procedure edFonctionEnter(Sender : TObject);
    procedure FormShow(Sender: TObject);
    procedure btnAnnulerClick(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
    procedure cgCouleurChange(Sender: TObject);
//  procedure rgEpaisseurClick(Sender: TObject);
    procedure rgStyleClick(Sender: TObject);
    procedure btnAutresOptionsClick(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure btAbsClick(Sender: TObject);
    procedure btArcCosClick(Sender: TObject);
    procedure btArcSinClick(Sender: TObject);
    procedure btArcTanClick(Sender: TObject);
    procedure btArgChClick(Sender: TObject);
    procedure btArgShClick(Sender: TObject);
    procedure btArgThClick(Sender: TObject);
    procedure btCarreClick(Sender: TObject);
    procedure btCosClick(Sender: TObject);
    procedure btChClick(Sender: TObject);
    procedure btExpClick(Sender: TObject);
    procedure btFracClick(Sender: TObject);
    procedure btIntClick(Sender: TObject);
    procedure btLnClick(Sender: TObject);
    procedure btLogClick(Sender: TObject);
    procedure btRacineClick(Sender: TObject);
    procedure btShClick(Sender: TObject);
    procedure btSinClick(Sender: TObject);
    procedure btTanClick(Sender: TObject);
    procedure btThClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure btPlusClick(Sender: TObject);
    procedure btMoinsClick(Sender: TObject);
    procedure btMultiplieClick(Sender: TObject);
    procedure btDiviseClick(Sender: TObject);
    procedure btExposantClick(Sender: TObject);
    procedure edFonctionKeyPress(Sender: TObject; var Key: Char);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Edit1Change(Sender: TObject);
    procedure btnAideClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }

  end;

var
  fmListeFonctions: TfmListeFonctions;
  edFonctions : array[1..10] of TEdit;
  lbNomsFonctions : array[1..10] of TLabel;
  cbDessiner : array[1..10] of TCheckBox;
  cbDerivee  : array[1..10] of TCheckBox;
  PositionCaret : integer;


implementation
uses uDessin,ufonctions, uAutresOptions;
var CourbesBis : array[1..10] of TCourbes;

{$R *.DFM}

procedure TfmListeFonctions.FormCreate(Sender: TObject);
var k   : byte;
    h   : integer;
begin
   h:=ClientHeight div 14;
   for k:=1 to 10 do
   begin
      edFonctions[k]:=TEdit.Create(self);
      edFonctions[k].parent:=fmListeFonctions;
      edFonctions[k].left:=60;
      edFonctions[k].top:=30+h*(k-1);
      edFonctions[k].width:=260;
      edFonctions[k].text:='';
      edFonctions[k].font.name:='Courier New';
      edFonctions[k].font.size:=10;
      edFonctions[k].font.color:=clBlack;
      edFonctions[k].tag:=k;
      edFonctions[k].TabOrder:=k-1;
      edFonctions[k].OnExit:=edFonctionExit;
      edFonctions[k].OnEnter:=edFonctionEnter;
      edFonctions[k].OnKeyPress:=edFonctionKeyPress;
      cbDessiner[k]:=TCheckBox.Create(self);
      cbDessiner[k].parent:=fmListeFonctions;
      cbDessiner[k].caption:='';
      cbDessiner[k].left:=330;
      cbDessiner[k].top:=30+h*(k-1);
      cbDessiner[k].width:=20;
      cbDessiner[k].checked:=false;
      cbDessiner[k].tag:=k;
      cbDessiner[k].OnClick:=CheckBox1Click;
      LabelExpressions.left:=60;
      lbNomsFonctions[k]:=TLabel.Create(self);
      lbNomsFonctions[k].parent:=fmListeFonctions;
      lbNomsFonctions[k].left:=5;
      lbNomsFonctions[k].top:=33+h*(k-1);
      lbNomsFonctions[k].font.name:='Courier New';
      lbNomsFonctions[k].font.size:=10;
      lbNomsFonctions[k].font.color:=clBlack;
      lbNomsFonctions[k].caption:='f'+inttostr(k)+'(x)=';
      LabelNoms.left:=5;
   end;
   fmListeFonctions.Color:=clBtnFace;
end;

procedure TfmListeFonctions.edFonctionExit(Sender : TObject);
begin
   with Sender as TEdit do
   begin
      PositionCaret:=SelStart;
      if Text<>'' then begin cbDessiner[tag].checked:=true;CourbesBis[tag].Expression:=Text;end;
   end;
end;

procedure TfmListeFonctions.edFonctionEnter(Sender : TObject);
var i : integer;
begin
   if sender is TEdit then with (Sender as TEdit) do
   begin
      for i:=1 to 10 do
      begin
         edFonctions[i].color:=clWhite;
         lbNomsFonctions[i].font.style:=[];
      end;
      gbFormat.caption:='Format de la courbe de f'+inttostr(tag);
      if CourbesBis[tag].expression='' then
      begin  //format par dfaut pour les nouvelles courbes
         cgCouleur.ForegroundIndex:=cgCouleur.ColorToIndex(clFonctions);
//       rgEpaisseur.ItemIndex:=EpaisseurFonctions-1;
         udEpaisseur.Position:=EpaisseurFonctions;
         rgStyle.ItemIndex:=ord(StyleFonctions);
      end
      else
      begin
         cgCouleur.ForeGroundIndex:=cgCouleur.ColorToIndex(CourbesBis[Tag].Couleur);
//       rgEpaisseur.ItemIndex:=CourbesBis[Tag].Epaisseur-1;
         udEpaisseur.Position:=CourbesBis[Tag].Epaisseur;
         rgStyle.ItemIndex:=ord(CourbesBis[Tag].style);
      end;
      LbNomsFonctions[tag].font.style:=[fsBold];
      color:=$00AAFFFF;//clYellow;
   end;
end;

procedure TfmListeFonctions.edFonctionKeyPress(Sender: TObject; var Key: Char);
begin
   if sender is TEdit then with (Sender as TEdit) do
      if Key='.' then Key:=DecimalSeparator;
end;

procedure TfmListeFonctions.FormShow(Sender: TObject);
var k : byte;
begin
   For k:=1 to 10 do
   begin // on effectue une copie des donnes avant de les modifier ventuellement
      CourbesBis[k]:=Courbes[k];
      edFonctions[k].text:=Courbes[k].expression;
      edFonctions[k].font.color:=Courbes[k].couleur;
      cbDessiner[k].checked:=CourbesBis[k].blDessiner;
   end;
   edFonctions[1].SetFocus;
end;

procedure TfmListeFonctions.btnAnnulerClick(Sender: TObject);
var k,err : byte;
begin
   for k:=1 to 10 do
   begin
      edFonctions[k].text:=Courbes[k].expression;
      case k of //on retraduit les 10 fonctions utilisateur
         1 : f1:=Traduction(Courbes[k].expression,err);
         2 : f2:=Traduction(Courbes[k].expression,err);
         3 : f3:=Traduction(Courbes[k].expression,err);
         4 : f4:=Traduction(Courbes[k].expression,err);
         5 : f5:=Traduction(Courbes[k].expression,err);
         6 : f6:=Traduction(Courbes[k].expression,err);
         7 : f7:=Traduction(Courbes[k].expression,err);
         8 : f8:=Traduction(Courbes[k].expression,err);
         9 : f9:=Traduction(Courbes[k].expression,err);
         10 : f10:=Traduction(Courbes[k].expression,err);
      end;
   end;
end;

procedure TfmListeFonctions.btnOKClick(Sender: TObject);
var k,n,err     : byte;
    ch,chErreur,ch1 : Ansistring;
begin
   NomVar:='X';
   for n:=1 to 10 do
   begin
      ch:=edFonctions[n].Text;
      ch1:=ch;
      err:=0;
      case n of
         1 : f1:=Traduction(ch,err);
         2 : f2:=Traduction(ch,err);
         3 : f3:=Traduction(ch,err);
         4 : f4:=Traduction(ch,err);
         5 : f5:=Traduction(ch,err);
         6 : f6:=Traduction(ch,err);
         7 : f7:=Traduction(ch,err);
         8 : f8:=Traduction(ch,err);
         9 : f9:=Traduction(ch,err);
         10 : f10:=Traduction(ch,err);
      end;
      if err>0 then
      begin            //erreurs de syntaxe
         if err=3 then chErreur:='problme de parenthses.';
         if err=4 then chErreur:='fonction ou symbole non reconnu.';
         if err=5 then chErreur:='mauvaise utilisation du symbole ';
         ShowMessage('Erreur de syntaxe dans la fonction f'+inttostr(n)+
                                '(x) = '+ch+ ' : '+chErreur);
      end;
      try
         ch:=Traduction(ch,err);
         if ch<>'' then f(ch,500*random);      //utilisation d'une fonction comme s'il s'agissait d'une procdure !
      except
         showMessage('Erreur de syntaxe dans la fonction f'+inttostr(n)+'(x) = '+text);
      end;
      CourbesBis[n].Expression:=ch1;
      CourbesBis[n].blDessiner:=cbDessiner[n].checked;
   end;
   for k:=1 to 10 do Courbes[k]:=CourbesBis[k];
end;

procedure TfmListeFonctions.cgCouleurChange(Sender: TObject);
var ch : string;
    k  : byte;
begin
   ch:=Copy(gbFormat.caption,25,2);
   k:=StrToInt(ch);
   CourbesBis[k].Couleur:=cgCouleur.ForegroundColor;
   edFonctions[k].Font.Color:=CourbesBis[k].Couleur;
   edFonctions[k].Color:=$00AAFFFF;
end;
{
procedure TfmListeFonctions.rgEpaisseurClick(Sender: TObject);
var ch : string;
    k  : byte;
begin
   ch:=Copy(gbFormat.caption,25,2);
   k:=StrToInt(ch);
   CourbesBis[k].Epaisseur:=rgEpaisseur.ItemIndex+1;
   edFonctions[k].Color:=$00AAFFFF;
end;
}
procedure TfmListeFonctions.rgStyleClick(Sender: TObject);
var ch : string;
    k  : byte;
begin
   ch:=Copy(gbFormat.caption,25,2);
   k:=StrToInt(ch);
   CourbesBis[k].Style:=TStyleCourbe(rgStyle.ItemIndex);
   edFonctions[k].Color:=$00AAFFFF;
end;

procedure TfmListeFonctions.btnAutresOptionsClick(Sender: TObject);
var ch : string;
    k,i  : byte;
begin
   with fmAutresOptions do
   begin
      ch:=Copy(gbFormat.caption,25,2);
      k:=StrToInt(ch);
      Tag:=k;
      Caption:='Autres options de la courbe d''quation y=f'+ch+'(x)='+CourbesBis[k].Expression;

      {on transfre les variables de la courbe k  la fiche des autres options
       puis, si on appuie sur le bouton OK, on rcupre les nouvelles valeurs}

      cbVoirProgressionDessin.Checked:=CourbesBis[k].blVoirProgressionDessin;
      cbEnveloppe.checked:=CourbesBis[k].blEnveloppeTangentielle;
      cbDeveloppee.Checked:=CourbesBis[k].blDeveloppeeNormale;
      udVitesse.Position:=CourbesBis[k].Vitesse;
      panel1.caption:=CourbesBis[k].Expression;
      for i:=1 to 10 do PointsParticuliers[i]:=CourbesBis[k].PointsParticuliers[i];
      if ShowModal=mrOK then
      begin
         CourbesBis[k].blVoirProgressionDessin:=cbVoirProgressionDessin.Checked;
         CourbesBis[k].blEnveloppeTangentielle:=cbEnveloppe.checked;
         CourbesBis[k].blDeveloppeeNormale:=cbDeveloppee.Checked;
         CourbesBis[k].vitesse:=udVitesse.Position;
         for i:=1 to 10 do CourbesBis[k].PointsParticuliers[i]:=PointsParticuliers[i];
      end;
      edFonctions[k].Color:=$00AAFFFF;
   end;
end;



procedure TfmListeFonctions.CheckBox1Click(Sender: TObject);
begin
   if sender is TCheckBox then with (Sender as TCheckBox) do
   begin
      CourbesBis[tag].blDessiner:=checked;
   end;
end;

procedure TfmListeFonctions.btAbsClick(Sender: TObject);
var ch : string;
    k : integer;
begin
   ch:=Copy(gbFormat.caption,25,2);
   k:=StrToInt(ch);
   edFonctions[k].SetFocus;
   edFonctions[k].SelStart:=PositionCaret;
   edFonctions[k].SelText:=(Sender as TButton).caption;
end;

procedure TfmListeFonctions.btArcCosClick(Sender: TObject);
var ch : string;
    k : integer;
begin
   ch:=Copy(gbFormat.caption,25,2);
   k:=StrToInt(ch);
   edFonctions[k].SetFocus;
   edFonctions[k].SelStart:=PositionCaret;
   edFonctions[k].SelText:=(Sender as TButton).caption;
end;

procedure TfmListeFonctions.btArcSinClick(Sender: TObject);
var ch : string;
    k : integer;
begin
   ch:=Copy(gbFormat.caption,25,2);
   k:=StrToInt(ch);
   edFonctions[k].SetFocus;
   edFonctions[k].SelStart:=PositionCaret;
   edFonctions[k].SelText:=(Sender as TButton).caption;
end;

procedure TfmListeFonctions.btArcTanClick(Sender: TObject);
var ch : string;
    k : integer;
begin
   ch:=Copy(gbFormat.caption,25,2);
   k:=StrToInt(ch);
   edFonctions[k].SetFocus;
   edFonctions[k].SelStart:=PositionCaret;
   edFonctions[k].SelText:=(Sender as TButton).caption;
end;

procedure TfmListeFonctions.btArgChClick(Sender: TObject);
var ch : string;
    k : integer;
begin
   ch:=Copy(gbFormat.caption,25,2);
   k:=StrToInt(ch);
   edFonctions[k].SetFocus;
   edFonctions[k].SelStart:=PositionCaret;
   edFonctions[k].SelText:=(Sender as TButton).caption;
end;

procedure TfmListeFonctions.btArgShClick(Sender: TObject);
var ch : string;
    k : integer;
begin
   ch:=Copy(gbFormat.caption,25,2);
   k:=StrToInt(ch);
   edFonctions[k].SetFocus;
   edFonctions[k].SelStart:=PositionCaret;
   edFonctions[k].SelText:=(Sender as TButton).caption;
end;

procedure TfmListeFonctions.btArgThClick(Sender: TObject);
var ch : string;
    k : integer;
begin
   ch:=Copy(gbFormat.caption,25,2);
   k:=StrToInt(ch);
   edFonctions[k].SetFocus;
   edFonctions[k].SelStart:=PositionCaret;
end;

procedure TfmListeFonctions.btCarreClick(Sender: TObject);
var ch : string;
    k : integer;
begin
   ch:=Copy(gbFormat.caption,25,2);
   k:=StrToInt(ch);
   edFonctions[k].SetFocus;
   edFonctions[k].SelStart:=PositionCaret;
   edFonctions[k].SelText:=(Sender as TButton).caption;
end;

procedure TfmListeFonctions.btCosClick(Sender: TObject);
var ch : string;
    k : integer;
begin
   ch:=Copy(gbFormat.caption,25,2);
   k:=StrToInt(ch);
   edFonctions[k].SetFocus;
   edFonctions[k].SelStart:=PositionCaret;
   edFonctions[k].SelText:=(Sender as TButton).caption;
end;



procedure TfmListeFonctions.btChClick(Sender: TObject);
var ch : string;
    k : integer;
begin
   ch:=Copy(gbFormat.caption,25,2);
   k:=StrToInt(ch);
   edFonctions[k].SetFocus;
   edFonctions[k].SelStart:=PositionCaret;
   edFonctions[k].SelText:=(Sender as TButton).caption;
end;


procedure TfmListeFonctions.btExpClick(Sender: TObject);
var ch : string;
    k : integer;
begin
   ch:=Copy(gbFormat.caption,25,2);
   k:=StrToInt(ch);
   edFonctions[k].SetFocus;
   edFonctions[k].SelStart:=PositionCaret;
   edFonctions[k].SelText:=(Sender as TButton).caption;
end;

procedure TfmListeFonctions.btFracClick(Sender: TObject);
var ch : string;
    k : integer;
begin
   ch:=Copy(gbFormat.caption,25,2);
   k:=StrToInt(ch);
   edFonctions[k].SetFocus;
   edFonctions[k].SelStart:=PositionCaret;
   edFonctions[k].SelText:=(Sender as TButton).caption;
end;

procedure TfmListeFonctions.btIntClick(Sender: TObject);
var ch : string;
    k : integer;
begin
   ch:=Copy(gbFormat.caption,25,2);
   k:=StrToInt(ch);
   edFonctions[k].SetFocus;
   edFonctions[k].SelStart:=PositionCaret;
   edFonctions[k].SelText:=(Sender as TButton).caption;
end;

procedure TfmListeFonctions.btLnClick(Sender: TObject);
var ch : string;
    k : integer;
begin
   ch:=Copy(gbFormat.caption,25,2);
   k:=StrToInt(ch);
   edFonctions[k].SetFocus;
   edFonctions[k].SelStart:=PositionCaret;
   edFonctions[k].SelText:=(Sender as TButton).caption;
end;


procedure TfmListeFonctions.btLogClick(Sender: TObject);
var ch : string;
    k : integer;
begin
   ch:=Copy(gbFormat.caption,25,2);
   k:=StrToInt(ch);
   edFonctions[k].SetFocus;
   edFonctions[k].SelStart:=PositionCaret;
   edFonctions[k].SelText:=(Sender as TButton).caption;
end;


procedure TfmListeFonctions.btRacineClick(Sender: TObject);
var ch : string;
    k : integer;
begin
   ch:=Copy(gbFormat.caption,25,2);
   k:=StrToInt(ch);
   edFonctions[k].SetFocus;
   edFonctions[k].SelStart:=PositionCaret;
   edFonctions[k].SelText:=(Sender as TButton).caption;
end;

procedure TfmListeFonctions.btShClick(Sender: TObject);
var ch : string;
    k : integer;
begin
   ch:=Copy(gbFormat.caption,25,2);
   k:=StrToInt(ch);
   edFonctions[k].SetFocus;
   edFonctions[k].SelStart:=PositionCaret;
   edFonctions[k].SelText:=(Sender as TButton).caption;
end;

procedure TfmListeFonctions.btSinClick(Sender: TObject);
var ch : string;
    k : integer;
begin
   ch:=Copy(gbFormat.caption,25,2);
   k:=StrToInt(ch);
   edFonctions[k].SetFocus;
   edFonctions[k].SelStart:=PositionCaret;
   edFonctions[k].SelText:=(Sender as TButton).caption;
end;


procedure TfmListeFonctions.btTanClick(Sender: TObject);
var ch : string;
    k : integer;
begin
   ch:=Copy(gbFormat.caption,25,2);
   k:=StrToInt(ch);
   edFonctions[k].SetFocus;
   edFonctions[k].SelStart:=PositionCaret;
   edFonctions[k].SelText:=(Sender as TButton).caption;
end;


procedure TfmListeFonctions.btThClick(Sender: TObject);
var ch : string;
    k : integer;
begin
   ch:=Copy(gbFormat.caption,25,2);
   k:=StrToInt(ch);
   edFonctions[k].SetFocus;
   edFonctions[k].SelStart:=PositionCaret;
   edFonctions[k].SelText:=(Sender as TButton).caption;
end;

procedure TfmListeFonctions.Button1Click(Sender: TObject);
var ch : string;
    k : integer;
begin
   ch:=Copy(gbFormat.caption,25,2);
   k:=StrToInt(ch);
   edFonctions[k].SetFocus;
   edFonctions[k].SelStart:=PositionCaret;
   edFonctions[k].SelText:='pi';
end;

procedure TfmListeFonctions.Button2Click(Sender: TObject);
var ch : string;
    k : integer;
begin
   ch:=Copy(gbFormat.caption,25,2);
   k:=StrToInt(ch);
   edFonctions[k].SetFocus;
   edFonctions[k].SelStart:=PositionCaret;
   edFonctions[k].SelText:='e';
end;

procedure TfmListeFonctions.btPlusClick(Sender: TObject);
var ch : string;
    k : integer;
begin
   ch:=Copy(gbFormat.caption,25,2);
   k:=StrToInt(ch);
   edFonctions[k].SetFocus;
   edFonctions[k].SelStart:=PositionCaret;
   edFonctions[k].SelText:='+';//(Sender as TButton).caption;
end;


procedure TfmListeFonctions.btMoinsClick(Sender: TObject);
var ch : string;
    k : integer;
begin
   ch:=Copy(gbFormat.caption,25,2);
   k:=StrToInt(ch);
   edFonctions[k].SetFocus;
   edFonctions[k].SelStart:=PositionCaret;
   edFonctions[k].SelText:='-';//(Sender as TButton).caption;
end;



procedure TfmListeFonctions.btMultiplieClick(Sender: TObject);
var ch : string;
    k : integer;
begin
   ch:=Copy(gbFormat.caption,25,2);
   k:=StrToInt(ch);
   edFonctions[k].SetFocus;
   edFonctions[k].SelStart:=PositionCaret;
   edFonctions[k].SelText:='*';//(Sender as TButton).caption;
end;


procedure TfmListeFonctions.btDiviseClick(Sender: TObject);
var ch : string;
    k : integer;
begin
   ch:=Copy(gbFormat.caption,25,2);
   k:=StrToInt(ch);
   edFonctions[k].SetFocus;
   edFonctions[k].SelStart:=PositionCaret;
   edFonctions[k].SelText:='/';//(Sender as TButton).caption;
end;


procedure TfmListeFonctions.btExposantClick(Sender: TObject);
var ch : string;
    k : integer;
begin
   ch:=Copy(gbFormat.caption,25,2);
   k:=StrToInt(ch);
   edFonctions[k].SetFocus;
   edFonctions[k].SelStart:=PositionCaret;
   edFonctions[k].SelText:='^';
end;



procedure TfmListeFonctions.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   if key=vk_Escape then close;
end;

procedure TfmListeFonctions.Edit1Change(Sender: TObject);
var ch : string;
    k  : byte;
begin
   edEpaisseur.Text:=inttostr(udEpaisseur.position div 10)+','+inttostr(udEpaisseur.position mod 10)+' mm';
   Apercu.Picture.Assign(fmDessin.ApercuLigne(udEpaisseur.position,cgCouleur.ForegroundColor));
   ch:=Copy(gbFormat.caption,25,2);
   if ch<>'' then k:=StrToInt(ch) else k:=0;
   CourbesBis[k].Epaisseur:=udEpaisseur.position;
   edFonctions[k].Color:=$00AAFFFF;
   fmListeFonctions.Color:=clBtnFace;
end;

procedure TfmListeFonctions.btnAideClick(Sender: TObject);
begin
   Aide(16);
end;

end.
