unit uLoiExponentielle;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, shellAPI;

type
  TfmLoiExponentielle = class(TForm)
    gbTypeCalcul: TGroupBox;
    lblAcol: TLabel;
    lblBcol: TLabel;
    edAcol: TEdit;
    edBcol: TEdit;
    GroupBox1: TGroupBox;
    pnCourbe: TPanel;
    lblCouleurCourbe: TLabel;
    cbDessiner: TCheckBox;
    btOK: TButton;
    cbAfficher: TCheckBox;
    Label5: TLabel;
    edTitre: TEdit;
    btAnnuler: TButton;
    Label8: TLabel;
    Image1: TImage;
    cbAcol: TCheckBox;
    cbBcol: TCheckBox;
    cbCDcol: TCheckBox;
    lblCcol: TLabel;
    edCcol: TEdit;
    lblDcol: TLabel;
    edDcol: TEdit;
    pnAcol: TPanel;
    pnBcol: TPanel;
    pnCDcol: TPanel;
    cd1: TColorDialog;
    GroupBox2: TGroupBox;
    lblAh: TLabel;
    lblBh: TLabel;
    lblCh: TLabel;
    lblDh: TLabel;
    edAh: TEdit;
    edBh: TEdit;
    cbAh: TCheckBox;
    cbBh: TCheckBox;
    cbCDh: TCheckBox;
    edCh: TEdit;
    edDh: TEdit;
    GroupBox3: TGroupBox;
    edMoyenne: TEdit;
    Image2: TImage;
    eddemi: TEdit;
    Image3: TImage;
    rbMoy: TRadioButton;
    rbDemi: TRadioButton;
    rbTinf: TRadioButton;
    rbTsup: TRadioButton;
    lblAdef: TLabel;
    edAdef: TEdit;
    lblBdef: TLabel;
    edBdef: TEdit;
    Label35: TLabel;
    udEpaisseurCourbe: TUpDown;
    Edit9: TEdit;
    edEpaisseurCourbe: TEdit;
    Apercu: TImage;
    udStyle1: TUpDown;
    Panel1: TPanel;
    shStyleDomaine1: TShape;
    udStyle2: TUpDown;
    Panel2: TPanel;
    shStyleDomaine2: TShape;
    udStyle3: TUpDown;
    Panel3: TPanel;
    shStyleDomaine3: TShape;
    rbLambda: TRadioButton;
    edLambda: TEdit;
    Label1: TLabel;
    btnAide: TButton;
    procedure pnAcolClick(Sender: TObject);
    procedure lblCouleurCourbeClick(Sender: TObject);
    procedure pnCourbeClick(Sender: TObject);
    procedure eddemiKeyPress(Sender: TObject; var Key: Char);
    procedure edMoyenneKeyPress(Sender: TObject; var Key: Char);
    procedure edAdefKeyPress(Sender: TObject; var Key: Char);
    procedure edBdefKeyPress(Sender: TObject; var Key: Char);
    procedure edAcolKeyPress(Sender: TObject; var Key: Char);
    procedure edBcolKeyPress(Sender: TObject; var Key: Char);
    procedure edCcolKeyPress(Sender: TObject; var Key: Char);
    procedure edDcolKeyPress(Sender: TObject; var Key: Char);
    procedure edAhKeyPress(Sender: TObject; var Key: Char);
    procedure edBhKeyPress(Sender: TObject; var Key: Char);
    procedure edChKeyPress(Sender: TObject; var Key: Char);
    procedure edDhKeyPress(Sender: TObject; var Key: Char);
    procedure eddemiChange(Sender: TObject);
    procedure edMoyenneChange(Sender: TObject);
    procedure btAnnulerClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure edEpaisseurCourbeChange(Sender: TObject);
    procedure rbMoyClick(Sender: TObject);
    procedure rbDemiClick(Sender: TObject);
    procedure rbTinfClick(Sender: TObject);
    procedure rbTsupClick(Sender: TObject);
    procedure edBdefChange(Sender: TObject);
    procedure edAdefChange(Sender: TObject);
    procedure cbAcolClick(Sender: TObject);
    procedure cbBcolClick(Sender: TObject);
    procedure cbCDcolClick(Sender: TObject);
    procedure cbAhClick(Sender: TObject);
    procedure cbBhClick(Sender: TObject);
    procedure cbCDhClick(Sender: TObject);
    procedure pnBcolClick(Sender: TObject);
    procedure pnCDcolClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure MajParametres;
    procedure MajComposants;
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure udStyle1Click(Sender: TObject; Button: TUDBtnType);
    procedure udStyle2Click(Sender: TObject; Button: TUDBtnType);
    procedure udStyle3Click(Sender: TObject; Button: TUDBtnType);
    procedure FormShow(Sender: TObject);
    procedure edLambdaKeyPress(Sender: TObject; var Key: Char);
    procedure edLambdaChange(Sender: TObject);
    procedure rbLambdaClick(Sender: TObject);
    procedure btnAideClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  lambda,
  ZoneColA,ZoneColB,ZoneColC,ZoneColD,
  ZoneHachA,ZoneHachB,ZoneHachC,ZoneHachD                : real;
  Epaisseur,StyleHachures1,StyleHachures2,StyleHachures3 : integer;
  CouleurA,CouleurB,CouleurCD,CouleurCourbe              : TColor;
  Titre                                                  : String;
  AfficherResultats                                      : Boolean;
  end;


var
  fmLoiExponentielle: TfmLoiExponentielle;

implementation

uses uDessin;


{$R *.DFM}

procedure TfmLoiExponentielle.pnAcolClick(Sender: TObject);
begin
   cd1.Color:=pnAcol.Color;
   if cd1.Execute then
   begin
      pnAcol.Color:=cd1.Color;
      CouleurA:=cd1.Color;
   end;
end;

procedure TfmLoiExponentielle.lblCouleurCourbeClick(Sender: TObject);
begin
   cd1.Color:=pnCourbe.Color;
   if cd1.Execute then
   begin
      pnCourbe.Color:=cd1.Color;
      CouleurCourbe:=cd1.Color;
   end;
end;

procedure TfmLoiExponentielle.pnCourbeClick(Sender: TObject);
begin
   cd1.Color:=pnCourbe.Color;
   if cd1.Execute then
   begin
      pnCourbe.Color:=cd1.Color;
      CouleurCourbe:=cd1.Color;
      Apercu.Picture.Assign(fmDessin.ApercuLigne(udEpaisseurCourbe.position,CouleurCourbe));
   end;
end;


procedure TfmLoiExponentielle.eddemiKeyPress(Sender: TObject; var Key: Char);
begin
   if (key='.')or(key=',') then key:=DecimalSeparator;
end;

procedure TfmLoiExponentielle.edMoyenneKeyPress(Sender: TObject; var Key: Char);
begin
   if (key='.')or(key=',') then key:=DecimalSeparator;
end;

procedure TfmLoiExponentielle.edAdefKeyPress(Sender: TObject; var Key: Char);
begin
   if (key='.')or(key=',') then key:=DecimalSeparator;
end;

procedure TfmLoiExponentielle.edBdefKeyPress(Sender: TObject; var Key: Char);
begin
   if (key='.')or(key=',') then key:=DecimalSeparator;
end;

procedure TfmLoiExponentielle.edAcolKeyPress(Sender: TObject;
  var Key: Char);
begin
   if (key='.')or(key=',') then key:=DecimalSeparator;
end;

procedure TfmLoiExponentielle.edBcolKeyPress(Sender: TObject;
  var Key: Char);
begin
   if (key='.')or(key=',') then key:=DecimalSeparator;
end;

procedure TfmLoiExponentielle.edCcolKeyPress(Sender: TObject;
  var Key: Char);
begin
   if (key='.')or(key=',') then key:=DecimalSeparator;
end;

procedure TfmLoiExponentielle.edDcolKeyPress(Sender: TObject;
  var Key: Char);
begin
   if (key='.')or(key=',') then key:=DecimalSeparator;
end;

procedure TfmLoiExponentielle.edAhKeyPress(Sender: TObject; var Key: Char);
begin
   if (key='.')or(key=',') then key:=DecimalSeparator;
end;

procedure TfmLoiExponentielle.edBhKeyPress(Sender: TObject; var Key: Char);
begin
   if (key='.')or(key=',') then key:=DecimalSeparator;
end;

procedure TfmLoiExponentielle.edChKeyPress(Sender: TObject; var Key: Char);
begin
   if (key='.')or(key=',') then key:=DecimalSeparator;
end;

procedure TfmLoiExponentielle.edDhKeyPress(Sender: TObject; var Key: Char);
begin
   if (key='.')or(key=',') then key:=DecimalSeparator;
end;

procedure TfmLoiExponentielle.eddemiChange(Sender: TObject);
var p : real;
begin
{if edDemi.focused then      //proposition de Patrick Pradeau
  begin
	  try
		  lambda:=0.693147180559945/StrToFloat(edDemi.text);
   	except
   	  edDemi.Text:='6.93';
		  lambda:=0.1;
   	end;
	  edMoyenne.Text:=FloatToStrF(1.0/lambda,ffgeneral,3,0);
	  try
		  p:=StrToFloat(edBdef.text);
   	except
   	  edBdef.text:='0,632';
		  p:=0.632120558828557;
   	end;
	  edAdef.Text:=FloatToStrF(-Ln(1-p)/lambda,ffgeneral,3,0);
	end;}
  if edDemi.focused then     //proposition de Patrice Rabiller
  begin
	  try
		  lambda:=0.693147180559945/StrToFloat(edDemi.text);    //lambda = ln2 / (Demi-vie)
   	except
   	  lambda:=0;      //lorsque la saisie est incorrecte
		                  //on positionne lambda=0 : les calculs sont impossibles provisoirement
   	end;
	  if lambda>0 then
    begin
       edMoyenne.Text:=FloatToStrF(1.0/lambda,ffgeneral,3,0);
       edLambda.Text:=FloatToStrF(Lambda,ffGeneral,3,0);
    end else edMoyenne.Text:='';
                //les valeurs de a et de b restent inchanges
	end;
end;

procedure TfmLoiExponentielle.edMoyenneChange(Sender: TObject);
var p:real;
begin
  if edMoyenne.focused then
  begin
    try
		  lambda:=1/StrToFloat(edMoyenne.text);
    except
      lambda:=0;
   	end;
	  if lambda>0 then
    begin
       edDemi.Text:=FloatToStrF(0.693147180559945/lambda,ffgeneral,3,0);
       edLambda.Text:=FloatToStrF(Lambda,ffGeneral,3,0);
    end else edDemi.Text:='';
	end;
end;

procedure TfmLoiExponentielle.btAnnulerClick(Sender: TObject);
//remet tous les composants dans leur tat standard
begin
{lambda:=0.1;
rbMoy.Checked:=True;
edMoyenne.Text:='10';
edMoyenne.Enabled:=True;
edDemi.Text:='6,93';
edDemi.Enabled:=False;
lblAdef.Enabled:=False;
edAdef.Text:='10';
edAdef.Enabled:=False;
lblBdef.Enabled:=False;
edBdef.Text:='0,632';
edBdef.Enabled:=False;
cbAcol.Checked:=False;
lblAcol.Enabled:=False;
edAcol.Text:='5';
pnAcol.Color:=$00FFBFFF;
edBcol.Enabled:=False;
cbBcol.Checked:=False;
lblBcol.Enabled:=False;
edBcol.Text:='20';
edBcol.Enabled:=False;
pnBcol.Color:=$00FFBFFF;
cbCDcol.Checked:=False;
lblCcol.Enabled:=False;
edCcol.Text:='10';
edCcol.Enabled:=False;
lblDcol.Enabled:=False;
edDcol.Text:='15';
edDcol.Enabled:=False;
pnCDcol.Color:=$00FFBFFF;
cbAh.Checked:=False;
lblAh.Enabled:=False;
edAh.Text:='5';
edBh.Enabled:=False;
cbBh.Checked:=False;
lblBh.Enabled:=False;
edBh.Text:='20';
edBh.Enabled:=False;
cbCDh.Checked:=False;
lblCh.Enabled:=False;
edCh.Text:='10';
edCh.Enabled:=False;
lblDh.Enabled:=False;
edDh.Text:='15';
edDh.Enabled:=False;
udEpaisseurCourbe.position:=3;
pnCourbe.Color:=clBlack;}
   cbDessiner.Checked:=false;
end;

procedure TfmLoiExponentielle.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key=vk_Escape then close;
end;

procedure TfmLoiExponentielle.edEpaisseurCourbeChange(Sender: TObject);
begin
  edEpaisseurCourbe.Text:=inttostr(udEpaisseurCourbe.position div 10)+','+inttostr(udEpaisseurCourbe.position mod 10)+' mm';
  Apercu.Picture.Assign(fmDessin.ApercuLigne(udEpaisseurCourbe.position,CouleurCourbe));
end;

procedure TfmLoiExponentielle.rbMoyClick(Sender: TObject);
begin
   lblAdef.Enabled:=False;  edAdef.Color:=clBtnFace;
   lblBdef.Enabled:=False;  edBdef.Color:=clBtnFace;
   edLambda.Enabled:=False; edLambda.Color:=clBtnFace;
   edAdef.Enabled:=False;   edMoyenne.Color:=clWhite;
   edBdef.Enabled:=False;   edDemi.Color:=clBtnFace;
   edMoyenne.Enabled:=true; edDemi.Enabled:=false;
   edMoyenne.SetFocus;
end;

procedure TfmLoiExponentielle.rbDemiClick(Sender: TObject);
begin
   lblAdef.Enabled:=False;  edAdef.Color:=clBtnFace;
   lblBdef.Enabled:=False;  edBdef.Color:=clBtnFace;
   edLambda.Enabled:=False; edLambda.Color:=clBtnFace;
   edAdef.Enabled:=False;   edMoyenne.Color:=clBtnFace;
   edBdef.Enabled:=False;   edDemi.Color:=clWhite;
   edMoyenne.Enabled:=false;edDemi.Enabled:=true;
   edDemi.SetFocus;
end;

procedure TfmLoiExponentielle.rbTinfClick(Sender: TObject);
begin
   lblAdef.Enabled:=True;   edAdef.Color:=clWhite;
   lblBdef.Enabled:=True;   edBdef.Color:=clWhite;
   edLambda.Enabled:=False; edLambda.Color:=clBtnFace;
   edAdef.Enabled:=True;    edMoyenne.Color:=clBtnFace;
   edBdef.Enabled:=True;    edDemi.Color:=clBtnFace;
   edMoyenne.Enabled:=false;edDemi.Enabled:=false;
   edAdef.SetFocus;
end;

procedure TfmLoiExponentielle.rbTsupClick(Sender: TObject);
begin
   lblAdef.Enabled:=True;   edAdef.Color:=clWhite;
   lblBdef.Enabled:=True;   edBdef.Color:=clWhite;
   edLambda.Enabled:=False; edLambda.Color:=clBtnFace;
   edAdef.Enabled:=True;    edMoyenne.Color:=clBtnFace;
   edBdef.Enabled:=True;    edDemi.Color:=clBtnFace;
   edMoyenne.Enabled:=false;edDemi.Enabled:=false;
   edAdef.SetFocus;
end;

procedure TfmLoiExponentielle.edBdefChange(Sender: TObject);
var p,t:real;
begin
  if edBdef.focused then
  begin
	  try
   	  p:=StrToFloat(edBdef.text);
      t:=StrToFloat(edAdef.text);
   	except
   	end;
    if ((p>0)and(p<1)and(t>0)) then
    begin                   //les valeurs de lambda et de la demi-vie ne sont calcules que dans ce cas
       if rbTinf.checked
   	   then lambda:=-Ln(1-p)/t
       else Lambda:=-Ln(p)/t;
	     edMoyenne.Text:=FloatToStrF(1/lambda,ffgeneral,3,0);
	     edDemi.Text:=FloatToStrF(0.693147180559945/lambda,ffgeneral,3,0);
       edLambda.Text:=FloatToStrF(Lambda,ffGeneral,3,0);
    end;
	end;
end;

procedure TfmLoiExponentielle.edAdefChange(Sender: TObject);
var p,t:real;
begin
  if edAdef.focused then
  begin
	  try
   	  p:=StrToFloat(edBdef.text);
      t:=StrToFloat(edAdef.text);
   	except
   	end;
    if ((p>0)and(p<1)and(t>0)) then
    begin
      if rbTinf.checked
   	  then lambda:=-Ln(1-p)/t
      else Lambda:=-Ln(p)/t;
	    edMoyenne.Text:=FloatToStrF(1/lambda,ffgeneral,3,0);
	    edDemi.Text:=FloatToStrF(0.693147180559945/lambda,ffgeneral,3,0);
      edLambda.Text:=FloatToStrF(Lambda,ffGeneral,3,0);
    end;
	end;
end;

procedure TfmLoiExponentielle.cbAcolClick(Sender: TObject);
begin
  If cbAcol.checked then
  begin
    edAcol.Enabled:=True;
    lblAcol.Enabled:=True;
  end
  else begin
    edAcol.Enabled:=False;
    lblAcol.Enabled:=False;
  end;
end;

procedure TfmLoiExponentielle.cbBcolClick(Sender: TObject);
begin
  If cbBcol.checked then
  begin
    edBcol.Enabled:=True;
    lblBcol.Enabled:=True;
  end
  else begin
    edBcol.Enabled:=False;
    lblBcol.Enabled:=False;
  end;
end;

procedure TfmLoiExponentielle.cbCDcolClick(Sender: TObject);
begin
  If cbCDcol.checked then
  begin
    edCcol.Enabled:=True;
    edDcol.Enabled:=True;
    lblCcol.Enabled:=True;
    lblDcol.Enabled:=True;
  end
  else begin
    edCcol.Enabled:=False;
    edDcol.Enabled:=False;
    lblCcol.Enabled:=False;
    lblDcol.Enabled:=False;
  end;
end;

procedure TfmLoiExponentielle.cbAhClick(Sender: TObject);
begin
  If cbAh.checked then
  begin
    edAh.Enabled:=True;
    lblAh.Enabled:=True;
  end
  else begin
    edAh.Enabled:=False;
    lblAh.Enabled:=False;
  end;
end;

procedure TfmLoiExponentielle.cbBhClick(Sender: TObject);
begin
  If cbBh.checked then
  begin
    edBh.Enabled:=True;
    lblBh.Enabled:=True;
  end
  else begin
    edBh.Enabled:=False;
    lblBh.Enabled:=False;
  end;
end;

procedure TfmLoiExponentielle.cbCDhClick(Sender: TObject);
begin
  If cbCDh.checked
	then begin
    edCh.Enabled:=True;
    edDh.Enabled:=True;
    lblCh.Enabled:=True;
    lblDh.Enabled:=True;
  end
  else begin
    edCh.Enabled:=False;
    edDh.Enabled:=False;
    lblCh.Enabled:=False;
    lblDh.Enabled:=False;
  end;
end;

procedure TfmLoiExponentielle.pnBcolClick(Sender: TObject);
begin
   cd1.Color:=pnBcol.Color;
   if cd1.Execute then pnBcol.Color:=cd1.Color;
end;

procedure TfmLoiExponentielle.pnCDcolClick(Sender: TObject);
begin
   cd1.Color:=pnCDcol.Color;
   if cd1.Execute then pnCDcol.Color:=cd1.Color;
end;

procedure TfmLoiExponentielle.FormActivate(Sender: TObject);
begin
  cbDessiner.Checked:=true;
  MajParametres;
end;

procedure TfmLoiExponentielle.MajParametres;
begin
  try
	  lambda:=1/StrToFloat(edMoyenne.text);
  except
    lambda:=0;
//    ShowMessage('Calculs impossibles');
    exit;
  end;
  if cbAcol.Checked then
  begin
    try
	   	zoneColA:=StrToFloat(edAcol.text);
   	except
   	  edAcol.Text:='10';
   	  zoneColA:=10.0;
   	end;
	end else
  begin
    zoneColA:=-1;
	end;
  if cbBcol.Checked then
  begin
    try
	   	zoneColB:=StrToFloat(edBcol.text);
   	except
   	  edBcol.Text:='20';
   	  zoneColB:=20.0;
   	end;
  end else
  begin
    zoneColB:=-1;
	end;
  if cbCDcol.Checked then
  begin
    try
	   	zoneColC:=StrToFloat(edCcol.text);
   	except
   	  edCcol.Text:='10';
   	  zoneColC:=10.0;
   	end;
    try
		  zoneColD:=StrToFloat(edDcol.text);
   	except
   	  edDcol.Text:='15';
   	  zoneColD:=15.0;
   	end;
    if ZoneColC>ZoneColD then
    begin
      edCcol.Text:=FloatToStr(ZoneColD);
      edDcol.Text:=FloatToStr(ZoneColC);
      zoneColC:=StrToFloat(edCcol.text);
      zoneColD:=StrToFloat(edDcol.text);
    end;
	end else
  begin
    zoneColC:=-1;
    zoneColD:=-1;
	end;
  if cbAh.Checked then
  begin
    try
	   	zoneHachA:=StrToFloat(edAh.text);
   	except
   	  edAh.Text:='5';
   	  zoneHachA:=5.0;
   	end;
	end else
  begin
    ZoneHachA:=-1;
	end;
  if cbBh.Checked then
  begin
    try
	   	zoneHachB:=StrToFloat(edBh.text);
   	except
   	  edBh.Text:='20';
   	  zoneHachB:=20.0;
   	end;
	end else
  begin
    ZoneHachB:=-1;
	end;
  if cbCDh.Checked then
  begin
    try
	   	zoneHachC:=StrToFloat(edCh.text);
   	except
   	  edCh.Text:='10';
   	  zoneHachC:=10.0;
   	end;
    try
		  zoneHachD:=StrToFloat(edDh.text);
   	except
   	  edDh.Text:='15';
   	  zoneHachD:=15.0;
   	end;
    if ZoneHachC>ZoneHachD then
    begin
      edCh.Text:=FloatToStr(ZoneHachD);
      edDh.Text:=FloatToStr(ZoneHachC);
      zoneHachC:=StrToFloat(edCh.text);
      zoneHachD:=StrToFloat(edDh.text);
    end;
	end else
  begin
    ZoneHachC:=-1;
    ZoneHachD:=-1;
	end;
  CouleurA:= pnAcol.color;
  CouleurB:= pnBcol.color;
  CouleurCD:= pnCDcol.color;
  CouleurCourbe:= pnCourbe.color;
  Epaisseur:=udEpaisseurCourbe.Position;
  StyleHachures1:=udStyle1.position;
  StyleHachures2:=udStyle2.position;
  StyleHachures3:=udStyle3.position;
  Titre:=edTitre.Text;
  If cbAfficher.checked
  then AfficherResultats:=True
  else AfficherResultats:=False;
end;

procedure TfmLoiExponentielle.MajComposants;
begin
edMoyenne.Text:=FloatToStrF(1.0/lambda,ffgeneral,3,0);
edDemi.Text:=FloatToStrF(0.693147180559945/lambda,ffgeneral,3,0);
edAdef.Text:=edMoyenne.Text;
if ZoneColA>-1
	then begin
   cbAcol.Checked:=True;
   edAcol.Text:=FloatToStrF(ZoneColA,ffgeneral,3,0);
   pnAcol.Color:=couleurA;
   end;
if ZoneColB>-1
	then begin
   cbBcol.Checked:=True;
   edBcol.Text:=FloatToStrF(ZoneColB,ffgeneral,3,0);
   pnAcol.Color:=couleurB;
   end;
if ZoneColC>-1
	then begin
   cbCDcol.Checked:=True;
   edCcol.Text:=FloatToStrF(ZoneColC,ffgeneral,3,0);
   edDcol.Text:=FloatToStrF(ZoneColD,ffgeneral,3,0);
   pnCDcol.Color:=couleurCD;
   end;
if ZoneHachA>-1
	then begin
   cbAh.Checked:=True;
   edAh.Text:=FloatToStrF(ZoneHachA,ffgeneral,3,0);
   udStyle1.Position:=StyleHachures1;
   shStyleDomaine1.Brush.Style:=TBrushStyle(udStyle1.position);
{   if udStyle1.position=1 then shStyleDomaine1.Brush.Style:=bsBDiagonal;
  	if udStyle1.position=2 then shStyleDomaine1.Brush.Style:=bsFDiagonal;
  	if udStyle1.position=3 then shStyleDomaine1.Brush.Style:=bsVertical;
  	if udStyle1.position=4 then shStyleDomaine1.Brush.Style:=bsHorizontal;
  	if udStyle1.position=5 then shStyleDomaine1.Brush.Style:=bsCross;
	  if udStyle1.position=6 then shStyleDomaine1.Brush.Style:=bsDiagCross;}
   end;
if ZoneHachB>-1
	then begin
   cbBh.Checked:=True;
   edBh.Text:=FloatToStrF(ZoneHachB,ffgeneral,3,0);
   udStyle2.Position:=StyleHachures2;
   shStyleDomaine2.Brush.Style:=TBrushStyle(udStyle2.position);
{   if udStyle2.position=1 then shStyleDomaine2.Brush.Style:=bsBDiagonal;
   	if udStyle2.position=2 then shStyleDomaine2.Brush.Style:=bsFDiagonal;
	  if udStyle2.position=3 then shStyleDomaine2.Brush.Style:=bsVertical;
	  if udStyle2.position=4 then shStyleDomaine2.Brush.Style:=bsHorizontal;
	  if udStyle2.position=5 then shStyleDomaine2.Brush.Style:=bsCross;
	  if udStyle2.position=6 then shStyleDomaine2.Brush.Style:=bsDiagCross;}
   end;
if ZoneHachC>-1
	then begin
   cbCDh.Checked:=True;
   edCh.Text:=FloatToStrF(ZoneHachC,ffgeneral,3,0);
   edDh.Text:=FloatToStrF(ZoneHachD,ffgeneral,3,0);
   udStyle3.Position:=StyleHachures3;
   shStyleDomaine3.Brush.Style:=TBrushStyle(udStyle3.position);
{   if udStyle3.position=3 then shStyleDomaine3.Brush.Style:=bsBDiagonal;
  	if udStyle3.position=2 then shStyleDomaine3.Brush.Style:=bsFDiagonal;
	  if udStyle3.position=3 then shStyleDomaine3.Brush.Style:=bsVertical;
	  if udStyle3.position=4 then shStyleDomaine3.Brush.Style:=bsHorizontal;
	  if udStyle3.position=5 then shStyleDomaine3.Brush.Style:=bsCross;
	  if udStyle3.position=6 then shStyleDomaine3.Brush.Style:=bsDiagCross;}
   end;
udEpaisseurCourbe.Position:=Epaisseur;
edEpaisseurCourbe.Text:=inttostr(udEpaisseurCourbe.position div 10)+','+inttostr(udEpaisseurCourbe.position mod 10)+' mm';
Apercu.Picture.Assign(fmDessin.ApercuLigne(udEpaisseurCourbe.position,CouleurCourbe));
pnCourbe.Color:=CouleurCourbe;
edTitre.Text:=Titre;
cbAfficher.Checked:=AfficherResultats;
end;

procedure TfmLoiExponentielle.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
   MajParametres;
end;

procedure TfmLoiExponentielle.udStyle1Click(Sender: TObject;
  Button: TUDBtnType);
begin
   shStyleDomaine1.Brush.Style:=TBrushStyle(udStyle1.position);
{if udStyle1.position=1 then shStyleDomaine1.Brush.Style:=bsBDiagonal;
if udStyle1.position=2 then shStyleDomaine1.Brush.Style:=bsFDiagonal;
if udStyle1.position=3 then shStyleDomaine1.Brush.Style:=bsVertical;
if udStyle1.position=4 then shStyleDomaine1.Brush.Style:=bsHorizontal;
if udStyle1.position=5 then shStyleDomaine1.Brush.Style:=bsCross;
if udStyle1.position=6 then shStyleDomaine1.Brush.Style:=bsDiagCross;}
   StyleHachures1:=udStyle1.position;
end;

procedure TfmLoiExponentielle.udStyle2Click(Sender: TObject;
  Button: TUDBtnType);
begin
   shStyleDomaine2.Brush.Style:=TBrushStyle(udStyle2.position);
{if udStyle2.position=1 then shStyleDomaine2.Brush.Style:=bsBDiagonal;
if udStyle2.position=2 then shStyleDomaine2.Brush.Style:=bsFDiagonal;
if udStyle2.position=3 then shStyleDomaine2.Brush.Style:=bsVertical;
if udStyle2.position=4 then shStyleDomaine2.Brush.Style:=bsHorizontal;
if udStyle2.position=5 then shStyleDomaine2.Brush.Style:=bsCross;
if udStyle2.position=6 then shStyleDomaine2.Brush.Style:=bsDiagCross;}
   StyleHachures2:=udStyle2.position;
end;

procedure TfmLoiExponentielle.udStyle3Click(Sender: TObject;
  Button: TUDBtnType);
begin
   shStyleDomaine3.Brush.Style:=TBrushStyle(udStyle3.position);
{if udStyle3.position=1 then shStyleDomaine3.Brush.Style:=bsBDiagonal;
if udStyle3.position=2 then shStyleDomaine3.Brush.Style:=bsFDiagonal;
if udStyle3.position=3 then shStyleDomaine3.Brush.Style:=bsVertical;
if udStyle3.position=4 then shStyleDomaine3.Brush.Style:=bsHorizontal;
if udStyle3.position=5 then shStyleDomaine3.Brush.Style:=bsCross;
if udStyle3.position=6 then shStyleDomaine3.Brush.Style:=bsDiagCross;}
   StyleHachures3:=udStyle3.position;
end;

procedure TfmLoiExponentielle.FormShow(Sender: TObject);
begin
 if rbLambda.Checked then rbLambda.OnClick(Sender);
 if rbMoy.Checked then rbMoy.OnClick(Sender);
 if rbDemi.Checked then rbDemi.OnClick(Sender);
 if rbTinf.Checked then rbTinf.OnClick(sender);
 if rbTsup.Checked then rbTsup.OnClick(sender);
end;

procedure TfmLoiExponentielle.edLambdaKeyPress(Sender: TObject;
  var Key: Char);
begin
   if (key='.')or(key=',') then key:=DecimalSeparator;
end;

procedure TfmLoiExponentielle.edLambdaChange(Sender: TObject);
begin
   if edLambda.Focused then
   begin
      try
         lambda:=StrToFloat(edLambda.Text);
      except
      end;
      if lambda>0 then
      begin
         edMoyenne.Text:=FloatToStrF(1.0/lambda,ffgeneral,3,0);
         edDemi.Text:=FloatToStrF(Ln(2)/lambda,ffgeneral,3,0);
      end;
   end;
end;

procedure TfmLoiExponentielle.rbLambdaClick(Sender: TObject);
begin
   lblAdef.Enabled:=False;  edAdef.Color:=clBtnFace;
   lblBdef.Enabled:=False;  edBdef.Color:=clBtnFace;
   edLambda.Enabled:=true; edLambda.Color:=clWhite;
   edAdef.Enabled:=False;   edMoyenne.Color:=clBtnFace;
   edBdef.Enabled:=False;   edDemi.Color:=clBtnFace;
   edMoyenne.Enabled:=false;edDemi.Enabled:=false;
   edLambda.SetFocus;
end;

procedure TfmLoiExponentielle.btnAideClick(Sender: TObject);
begin
   Aide(60);
end;

end.
