unit uPolygone;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ColorGrd, ComCtrls, shellAPI;

type
  TfmPolygone = class(TForm)
    rgDefinition: TRadioGroup;
    rgEpaisseur: TRadioGroup;
    rgStyle: TRadioGroup;
    GroupBox3: TGroupBox;
    Label9: TLabel;
    Label10: TLabel;
    ColorGrid1: TColorGrid;
    ColorGrid2: TColorGrid;
    Panel6: TPanel;
    Panel7: TPanel;
    Panel8: TPanel;
    btAnnuler: TButton;
    btOK: TButton;
    Label1: TLabel;
    edSommets1: TEdit;
    Label2: TLabel;
    edSommets4: TEdit;
    Label4: TLabel;
    edSommets3: TEdit;
    Label5: TLabel;
    edSommets2: TEdit;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label11: TLabel;
    Label3: TLabel;
    udStyle: TUpDown;
    Label12: TLabel;
    Panel1: TPanel;
    shStyleDomaine: TShape;
    btnAide: TButton;
    procedure rgDefinitionClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure udStyleClick(Sender: TObject; Button: TUDBtnType);
    procedure ColorGrid2Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnAideClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  fmPolygone: TfmPolygone;

implementation

uses uDessin;

{$R *.DFM}

procedure TfmPolygone.rgDefinitionClick(Sender: TObject);
begin
   Label1.Enabled:=false;
   Label2.Enabled:=false;
   Label3.Enabled:=false;
   Label4.Enabled:=false;
   Label5.Enabled:=false;
   Label6.Enabled:=false;
   Label7.Enabled:=false;
   Label8.Enabled:=false;
   edSommets1.Color:=clBtnFace;
   edSommets1.Enabled:=false;
   edSommets2.Color:=clBtnFace;
   edSommets2.Enabled:=false;
   edSommets3.Color:=clBtnFace;
   edSommets3.Enabled:=false;
   edSommets4.Color:=clBtnFace;
   edSommets4.Enabled:=false;
   case rgDefinition.ItemIndex of
      0 : begin
             Label1.Enabled:=true;
             Label6.Enabled:=true;
             edSommets1.Enabled:=true;
             edSommets1.Color:=clWindow;
          end;
      1 : begin
             Label5.Enabled:=true;
             Label7.Enabled:=true;
             edSommets2.Enabled:=true;
             edSommets2.Color:=clWindow;
          end;
      2 : begin
             Label3.Enabled:=true;
             Label4.Enabled:=true;
             Label8.Enabled:=true;
             edSommets3.Enabled:=true;
             edSommets3.Color:=clWindow;
          end;
      3 : begin
             Label2.Enabled:=true;
             edSommets4.Enabled:=true;
             edSommets4.Color:=clWindow;
          end;
      end;
end;

procedure TfmPolygone.FormActivate(Sender: TObject);
var k : integer;
begin
   for k:=0 to ComponentCount-1 do
      if Components[k] is TEdit then (Components[k] as TEdit).Text:='';
   rgDefinitionClick(sender);
end;

procedure TfmPolygone.udStyleClick(Sender: TObject; Button: TUDBtnType);
begin
    shStyleDomaine.Brush.Color:=ColorGrid2.ForegroundColor;
    shStyleDomaine.Brush.Style:=TBrushStyle(udStyle.position);
end;

procedure TfmPolygone.ColorGrid2Click(Sender: TObject);
begin
   shStyleDomaine.Brush.Color:=ColorGrid2.ForegroundColor;
end;

procedure TfmPolygone.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    if key=vk_Escape then close;
end;

procedure TfmPolygone.btnAideClick(Sender: TObject);
begin
   Aide(35);
end;

end.
