unit uPreferences;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ColorGrd, StdCtrls, ComCtrls, ExtCtrls, Buttons, shlObj, shellAPI;

type
  TfmPreferences = class(TForm)
    pcPreferences: TPageControl;
    tsRepere: TTabSheet;
    tsMiseEnPage: TTabSheet;
    rgOrientation: TRadioGroup;
    gbMarges: TGroupBox;
    Label3: TLabel;
    Label4: TLabel;
    labelMargeGaucheMinimale: TLabel;
    LabelMargeHauteMinimale: TLabel;
    edMargeGauche: TEdit;
    edMargeHaute: TEdit;
    udMargeGauche: TUpDown;
    edmg: TEdit;
    edmh: TEdit;
    udMargeHaute: TUpDown;
    GroupBox1: TGroupBox;
    LabelLargeurMax: TLabel;
    LabelHauteurMax: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    edLargeur: TEdit;
    edHauteur: TEdit;
    edLarg: TEdit;
    udLargeur: TUpDown;
    edHaut: TEdit;
    udHauteur: TUpDown;
    cbCadre: TCheckBox;
    cgCadre: TColorGrid;
    cbCentrerHorizontalement: TCheckBox;
    cbCentrerVerticalement: TCheckBox;
    Memo1: TMemo;
    gbAxeX: TGroupBox;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    edOrigineAxeX: TEdit;
    edUniteX: TEdit;
    edLongueurUx: TEdit;
    edLongueurUx_mm: TEdit;
    udUx: TUpDown;
    edPosAxeX: TEdit;
    edPosAxeX_mm: TEdit;
    udPosAxeX: TUpDown;
    gbInfoAxeX: TGroupBox;
    LabelXMin: TLabel;
    LabelXMax: TLabel;
    gbAxeY: TGroupBox;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    edOrigineAxeY: TEdit;
    edUniteY: TEdit;
    edLongueurUy: TEdit;
    edLongueurUy_mm: TEdit;
    udUy: TUpDown;
    edPosAxeY: TEdit;
    edPosAxeY_mm: TEdit;
    udPosAxeY: TUpDown;
    gbInfoAxeY: TGroupBox;
    LabelYMin: TLabel;
    LabelYMax: TLabel;
    gbParametreT: TGroupBox;
    rbAucune: TRadioButton;
    rbCroix: TRadioButton;
    rbPetitsCarreaux: TRadioButton;
    rbPointillesFins: TRadioButton;
    rbPointillesMoyens: TRadioButton;
    rbTirets: TRadioButton;
    gbOptions: TGroupBox;
    Label17: TLabel;
    Label18: TLabel;
    cbRepereVisible: TCheckBox;
    cbGraduationsPar5mm: TCheckBox;
    cgAxes: TColorGrid;
    cbGraduationsCompletes: TCheckBox;
    btOK: TButton;
    btAnnuler: TButton;
    btPoliceGraduations: TButton;
    Label19: TLabel;
    Label20: TLabel;
    FontDialog1: TFontDialog;
    lblPoliceTextes: TLabel;
    tsAutresParametres: TTabSheet;
    rgPointsD_arret: TRadioGroup;
    rgEpaisseurLignesCote: TRadioGroup;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    Panel7: TPanel;
    Panel8: TPanel;
    Panel9: TPanel;
    Panel10: TPanel;
    Panel11: TPanel;
    Panel12: TPanel;
    Panel13: TPanel;
    Panel14: TPanel;
    Panel15: TPanel;
    Label21: TLabel;
    Label22: TLabel;
    edNomAxeOx: TEdit;
    edNomAxeOy: TEdit;
    Label23: TLabel;
    pnCouleurFond: TPanel;
    cdCouleurFond: TColorDialog;
    Image1: TImage;
    btCouleurGrille: TButton;
    btCouleurFond: TButton;
    cdCouleurGrille: TColorDialog;
    rbPapierMillimetre: TRadioButton;
    Label15: TLabel;
    Label16: TLabel;
    edChiffresSignificatifsX: TEdit;
    udChiffresSignificatifsX: TUpDown;
    edChiffresSignificatifsY: TEdit;
    Label24: TLabel;
    Label25: TLabel;
    udChiffresSignificatifsY: TUpDown;
    Label26: TLabel;
    edDiametre: TEdit;
    edDiametrePoints: TEdit;
    udDiametrePoints: TUpDown;
    tsFormatCourbes: TTabSheet;
    gbFormatFonctions: TGroupBox;
    rgStyleFonctions: TRadioGroup;
    Panel31: TPanel;
    Label27: TLabel;
    cgCouleurFonctions: TColorGrid;
    gbFormatCourbesParametrees: TGroupBox;
    rgStyleCourbesParametrees: TRadioGroup;
    Panel35: TPanel;
    Label28: TLabel;
    cgCouleurCourbesParametrees: TColorGrid;
    gbFormatDroites: TGroupBox;
    rgStyleDroites: TRadioGroup;
    Panel39: TPanel;
    Label29: TLabel;
    cgCouleurDroites: TColorGrid;
    GroupBox2: TGroupBox;
    Label30: TLabel;
    Label31: TLabel;
    Label32: TLabel;
    edTMin: TEdit;
    edTMax: TEdit;
    edNBT: TEdit;
    btPoliceTextes: TButton;
    FontDialog2: TFontDialog;
    Label33: TLabel;
    edLongueurTirets: TEdit;
    udLongueurTirets: TUpDown;
    edTirets: TEdit;
    edTaillePetitsCarreaux: TEdit;
    udTaillePetitsCarreaux: TUpDown;
    Label34: TLabel;
    btParDefaut: TButton;
    rbPapierPointe: TRadioButton;
    edEpaisseurFonctions: TEdit;
    Edit1: TEdit;
    udEpaisseurFonctions: TUpDown;
    Label35: TLabel;
    Label36: TLabel;
    udEpaisseurCourbesParametrees: TUpDown;
    Edit2: TEdit;
    EdEpaisseurCourbesParametrees: TEdit;
    Label37: TLabel;
    UdEpaisseurDroites: TUpDown;
    Edit3: TEdit;
    edEpaisseurDroites: TEdit;
    Label38: TLabel;
    udEpaisseurTangentes: TUpDown;
    Edit4: TEdit;
    EdEpaisseurTangentes: TEdit;
    Label39: TLabel;
    Label40: TLabel;
    udEpaisseurNormales: TUpDown;
    Edit5: TEdit;
    EdEpaisseurNormales: TEdit;
    Label41: TLabel;
    Label42: TLabel;
    Label43: TLabel;
    udEpaisseurFleches: TUpDown;
    Edit6: TEdit;
    EdEpaisseurFleches: TEdit;
    Label44: TLabel;
    Label45: TLabel;
    udEpaisseurAxes: TUpDown;
    Edit7: TEdit;
    edEpaisseurAxes: TEdit;
    btnAide: TButton;
    ApercuFonctions: TImage;
    ApercuParametrees: TImage;
    ApercuDroites: TImage;
    procedure edmgChange(Sender: TObject);
    procedure edmhChange(Sender: TObject);
    procedure edLargChange(Sender: TObject);
    procedure edHautChange(Sender: TObject);
    procedure edLargeurExit(Sender: TObject);
    procedure edHauteurExit(Sender: TObject);
    procedure edMargeGaucheExit(Sender: TObject);
    procedure edMargeHauteExit(Sender: TObject);
    procedure rgOrientationClick(Sender: TObject);
    procedure cbCentrerHorizontalementClick(Sender: TObject);
    procedure cbCentrerVerticalementClick(Sender: TObject);
    procedure cbCadreClick(Sender: TObject);
    procedure cgCadreClick(Sender: TObject);
    procedure edLongueurUx_mmChange(Sender: TObject);
    procedure edLongueurUy_mmChange(Sender: TObject);
    procedure edPosAxeX_mmChange(Sender: TObject);
    procedure edPosAxeY_mmChange(Sender: TObject);
    procedure edOrigineAxeXExit(Sender: TObject);
    procedure edUniteXExit(Sender: TObject);
    procedure edOrigineAxeYExit(Sender: TObject);
    procedure edUniteYExit(Sender: TObject);
    procedure edLongueurUxExit(Sender: TObject);
    procedure edPosAxeXExit(Sender: TObject);
    procedure edLongueurUyExit(Sender: TObject);
    procedure edPosAxeYExit(Sender: TObject);
    procedure cbGraduationsPar5mmClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btOKClick(Sender: TObject);
    procedure rbAucuneClick(Sender: TObject);
    procedure rbCroixClick(Sender: TObject);
    procedure rbPointillesFinsClick(Sender: TObject);
    procedure rbPointillesMoyensClick(Sender: TObject);
    procedure rbTiretsClick(Sender: TObject);
    procedure rbPetitsCarreauxClick(Sender: TObject);
    procedure btPoliceGraduationsClick(Sender: TObject);
    procedure pnCouleurFondClick(Sender: TObject);
    procedure btCouleurGrilleClick(Sender: TObject);
    procedure btCouleurFondClick(Sender: TObject);
    procedure cdCouleurGrilleShow(Sender: TObject);
    procedure cdCouleurFondShow(Sender: TObject);
    procedure rbPapierMillimetreClick(Sender: TObject);
    procedure rbPapierPointeClick(Sender: TObject);
    procedure cgAxesChange(Sender: TObject);
    procedure edLargeurKeyPress(Sender: TObject; var Key: Char);
    procedure edHauteurKeyPress(Sender: TObject; var Key: Char);
    procedure edDiametrePointsChange(Sender: TObject);
    procedure btPoliceTextesClick(Sender: TObject);
    procedure edTiretsChange(Sender: TObject);
    procedure edTaillePetitsCarreauxChange(Sender: TObject);
    procedure btParDefautClick(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure Edit3Change(Sender: TObject);
    procedure Edit4Change(Sender: TObject);
    procedure Edit5Change(Sender: TObject);
    procedure Edit6Change(Sender: TObject);
    procedure Edit7Change(Sender: TObject);
    procedure btnAideClick(Sender: TObject);
  private
    { Dclarations prives }
    procedure InformationMinMax;
    procedure ChargerPreferences;
  public
    { Dclarations publiques }
  end;

var
  fmPreferences: TfmPreferences;

implementation
uses Printers,uFonctions,uDessin, uStatistiques1Var, uStatistiques2Var,
  uSuite;
{$R *.DFM}
//variables locales  l'unit
var blCadre,blRepereVisible,blGraduationsCompletes,blPortrait,
    blGraduationsPar5mm,blImpressionInterrompue,
    blCentrerHorizontalement,blCentrerVerticalement      : boolean;
    LargeurDessin_mm,HauteurDessin_mm,
    MargeGauche_mm,MargeHaute_mm,
    PosAxeX_mm,PosAxeY_mm,
    UniteX_mm,UniteY_mm,
    LargeurImprimable,HauteurImprimable,
    LargeurTotale, HauteurTotale,
    MargeGaucheMin,MargeDroiteMin,
    MargeHauteMin,MargeBasseMin                      : LongInt;
    Ux,Uy,XMin,YMin,XMax,YMax,TMin,TMax,
    OrdonneeAxeX,AbscisseAxeY                        : real;
    clAxes,clGrille,clCadre,clFond                   : TColor;
    FormatUx,FormatUy,zoom                           : byte;
    StyleGrille                                      : TStyleGrille;
    NomAxeOx,NomAxeOy                                : String;       //modif du 19/05/2003



procedure TfmPreferences.edmgChange(Sender: TObject);
var ch,chLargeurMax : string;
begin
   ch:=FloatToStrF(udMargeGauche.position/10,ffFixed,4,1);
   if cbCentrerHorizontalement.checked
   then chLargeurMax:=FloatToStrF(LargeurImprimable*2.54/ResX,ffFixed,3,1)
   else chLargeurMax:=FloatToStrF(LargeurImprimable*2.54/ResX-udMargeGauche.position/10,ffFixed,3,1);
   labelLargeurMax.Caption:='( Largeur maximale : '+chLargeurMax+' cm )';
   edMargeGauche.Text:=ch+' cm';
   if cbCentrerHorizontalement.checked then udLargeur.Max:=Trunc(LargeurImprimable*25.4/ResX)
   else udLargeur.Max:=Trunc(LargeurImprimable*25.4/ResX-udMargeGauche.position);
   MargeGauche_mm:=udMargeGauche.position;
end;

procedure TfmPreferences.edmhChange(Sender: TObject);
var ch,chHauteurMax : string;
begin
   ch:=FloatToStrF(udMargeHaute.position/10,ffFixed,4,1);
   if cbCentrerVerticalement.Checked
   then chHauteurMax:=FloatToStrF(HauteurImprimable*2.54/ResY,ffFixed,3,1)
   else chHauteurMax:=FloatToStrF(HauteurImprimable*2.54/ResY-udMargeHaute.position/10,ffFixed,3,1);
   labelHauteurMax.Caption:='( Hauteur maximale : '+chHauteurMax+' cm )';
   edMargeHaute.Text:=ch+' cm';
   if cbCentrerVerticalement.Checked then udHauteur.Max:=Trunc(HauteurImprimable*25.4/ResY)
   else udHauteur.Max:=Trunc(HauteurImprimable*25.4/ResY-udMargeHaute.position);
   MargeHaute_mm:=udMargeHaute.position;
end;

procedure TfmPreferences.edLargChange(Sender: TObject);
var ch : string;
begin
   ch:=FloatToStrF(udLargeur.position/10,ffFixed,4,1);
   edLargeur.Text:=ch+' cm';
   LargeurDessin_mm:=udLargeur.Position;
   if cbCentrerHorizontalement.checked then
      udMargeGauche.Position:=round((LargeurTotale/ResX*25.4-LargeurDessin_mm)/2);
   udMargeGauche.Max:=round(LargeurImprimable/ResX*25.4-udLargeur.position);
end;

procedure TfmPreferences.edHautChange(Sender: TObject);
var ch : string;
begin
   ch:=FloatToStrF(udHauteur.position/10,ffFixed,4,1);
   edHauteur.Text:=ch+' cm';
   HauteurDessin_mm:=udHauteur.Position;
   if cbCentrerVerticalement.Checked then
      udMargeHaute.Position:=round((HauteurTotale/ResY*25.4-HauteurDessin_mm)/2);
   udMargeHaute.Max:=round(HauteurImprimable*25.4/ResY-udHauteur.position);
end;

procedure TfmPreferences.edLargeurExit(Sender: TObject);
var ch : string;
    k  : integer;
    r  : real;
begin
   ch:=edLargeur.text;
   k:=Pos('.',ch);if k>0 then ch:=Copy(ch,1,k-1)+','+copy(ch,k+1,length(ch)-k);
   k:=1;
   while (k<length(ch))and(ch[k] in ['0'..'9',',']) do inc(k);
   ch:=copy(ch,1,k);
   r:=StrToFloat(ch)*10;
   udLargeur.Position:=round(r);
end;


procedure TfmPreferences.edHauteurExit(Sender: TObject);
var ch : string;
    k  : integer;
    r  : real;
begin
   ch:=edHauteur.text;
   k:=Pos('.',ch);if k>0 then ch:=Copy(ch,1,k-1)+','+copy(ch,k+1,length(ch)-k);
   k:=1;
   while (k<length(ch))and(ch[k] in ['0'..'9',',']) do inc(k);
   ch:=copy(ch,1,k);
   r:=StrToFloat(ch)*10;
   udHauteur.Position:=round(r);
end;

procedure TfmPreferences.edMargeGaucheExit(Sender: TObject);
var ch : string;
    k  : integer;
    r  : real;
begin
   ch:=edMargeGauche.text;
   k:=Pos('.',ch);if k>0 then ch:=Copy(ch,1,k-1)+','+copy(ch,k+1,length(ch)-k);
   k:=1;
   while (k<length(ch))and(ch[k] in ['0'..'9',',']) do inc(k);
   ch:=copy(ch,1,k);
   r:=StrToFloat(ch)*10;
   udMargeGauche.Position:=round(r);
end;

procedure TfmPreferences.edMargeHauteExit(Sender: TObject);
var ch : string;
    k  : integer;
    r  : real;
begin
   ch:=edMargeHaute.text;
   k:=Pos('.',ch);if k>0 then ch:=Copy(ch,1,k-1)+','+copy(ch,k+1,length(ch)-k);
   k:=1;
   while (k<length(ch))and(ch[k] in ['0'..'9',',']) do inc(k);
   ch:=copy(ch,1,k);
   r:=StrToFloat(ch)*10;
   udMargeHaute.Position:=round(r);
end;

Procedure InitialiserCanvasSortie;
{initialisation de l'imprimante et de l'image cran}
var DC : HDC;
begin
   if blImpressionInterrompue then exit;
//   if Printer.Printers.Count>=1 then //cas o il y a au moins une imprimante installe
   Try
      if blPortrait then Printer.Orientation:=poPortrait
                    else Printer.Orientation:=poLandscape;
      LargeurImprimable:=Printer.PageWidth;   {largeur de la zone imprimable en pixels}
      HauteurImprimable:=Printer.PageHeight;  {hauteur de la zone imprimable en pixels}
      ResX:=GetDeviceCaps(Printer.Handle,LOGPIXELSX);  {rs. horizontale en points par pouce}
      ResY:=GetDeviceCaps(Printer.Handle,LOGPIXELSY);  {rs. verticale en points par pouce}
      LargeurTotale:=GetDeviceCaps(Printer.Handle,PHYSICALWIDTH);//largeur de la feuille en pixels
      HauteurTotale:=GetDeviceCaps(Printer.Handle,PHYSICALHEIGHT);//hauteur de la feuille en pixels
      MargeGaucheMin:=GetDeviceCaps(Printer.Handle,PHYSICALOFFSETX);//marge gauche non imprimable en pixels
      MargeDroiteMin:=LargeurTotale-MargeGaucheMin-LargeurImprimable; //marge droite non imprimable
      MargeHauteMin:=GetDeviceCaps(Printer.Handle,PHYSICALOFFSETY); //marge haute non imprimable
      MargeBasseMin:=HauteurTotale-MargeHauteMin-HauteurImprimable;   //marge basse non imprimable
      fmDessin.sbImprimer.Enabled:=true;
      fmDessin.mnImprimer.Enabled:=true;
      fmStatistiques1Var.mnImprimerBoitesMultiples.Enabled:=true;
      fmStatistiques1Var.mnImprimerClasses.Enabled:=true;
      fmStatistiques1Var.mnImprimerCalculsClasses.Enabled:=true;
      fmStatistiques1Var.mnImprimerCalculsValeursIsolees.Enabled:=true;
      fmStatistiques2Var.mnImprimerDonnees.Enabled:=true;
      fmStatistiques2var.mnImprimerCalculs.Enabled:=true;
      fmSuites.mnImprimerSuites.Enabled:=true;      
   Except
          //sinon on inintialise quand mme les valeurs utiles
          //cas o aucune imprimante n'est installe
      LargeurImprimable:=2880; //valeur par dfaut de Canon BJC 4100
      HauteurImprimable:=4067; //valeur par dfaut de Canon BJC 4100
      ResX:=360;               //valeur par dfaut de Canon BJC 4100
      ResY:=360;               //valeur par dfaut de Canon BJC 4100
      LargeurTotale:=2976;     //valeur par dfaut de Canon BJC 4100
      HauteurTotale:=4209;     //valeur par dfaut de Canon BJC 4100
      MargeGaucheMin:=48;      //valeur par dfaut de Canon BJC 4100
      MargeDroiteMin:=48;      //valeur par dfaut de Canon BJC 4100
      MargeHauteMin:=42;       //valeur par dfaut de Canon BJC 4100
      MargeBasseMin:=100;      //valeur par dfaut de Canon BJC 4100
      fmDessin.sbImprimer.Enabled:=false;
      fmDessin.mnImprimer.Enabled:=false;
      fmStatistiques1Var.mnImprimerBoitesMultiples.Enabled:=false;
      fmStatistiques1Var.mnImprimerClasses.Enabled:=false;
      fmStatistiques1Var.mnImprimerCalculsClasses.Enabled:=false;
      fmStatistiques1Var.mnImprimerCalculsValeursIsolees.Enabled:=false;
      fmStatistiques2Var.mnImprimerDonnees.Enabled:=false;
      fmStatistiques2var.mnImprimerCalculs.Enabled:=false;
      fmSuites.mnImprimerSuites.Enabled:=false;
   end;
   //variables calcules  partir des variables prcdentes


   XMax:=(LargeurDessin_mm-PosAxeY_mm)/UniteX_mm*Ux+AbscisseAxeY; //abscisse maximale
   YMax:=(PosAxeX_mm)/UniteY_mm*Uy+OrdonneeAxeX;                  //ordonne maximale
   XMin:=XMax-LargeurDessin_mm/UniteX_mm*Ux;                      //abscisse minimale
   YMin:=YMax-HauteurDessin_mm/UniteY_mm*Uy;                      //ordonne minimale

   DC:=GetDC(0);
   ResEX:=GetDeviceCaps(DC,LOGPIXELSX);   {rsolution horizontale cran en ppp}
   ResEY:=GetDeviceCaps(DC,LOGPIXELSY);   {rsolution verticale cran en ppp}
   ReleaseDC(0,DC);
end;


procedure TfmPreferences.rgOrientationClick(Sender: TObject);
var chMargeGaucheMin,chMargeHauteMin : string;
    mgMin_mm,mhMin_mm : integer; //marges gauche et haute minimales en millimtres
begin
   blPortrait:=rgOrientation.ItemIndex=0;
   InitialiserCanvasSortie;
   mgMin_mm:=trunc(MargeGaucheMin*25.4/resX)+1;
   mhMin_mm:=trunc(MargeHauteMin*25.4/ResY)+1;
   chMargeGaucheMin:=FloatToStrF(mgMin_mm/10,ffFixed,2,1);
   chMargeHauteMin:=FloatToStrF(mhMin_mm/10,ffFixed,2,1);
   labelMargeGaucheMinimale.Caption:='( Minimum : '+chMargeGaucheMin+' cm )';
   labelMargeHauteMinimale.Caption:='( Minimum : '+chMargeHauteMin+' cm )';
   edmgChange(sender);
   edmhChange(sender);
end;

procedure TfmPreferences.cbCentrerHorizontalementClick(Sender: TObject);
begin
   if cbCentrerHorizontalement.Checked then
   begin
      udMargeGauche.position:=round((LargeurTotale/ResX*25.4-LargeurDessin_mm)/2);
      udMargeGauche.Enabled:=false;
      edMargeGauche.Enabled:=false;
   end
   else
   begin
      udMargeGauche.enabled:=true;
      edMargeGauche.Enabled:=true;
   end;
end;

procedure TfmPreferences.cbCentrerVerticalementClick(Sender: TObject);
begin
   if cbCentrerVerticalement.checked then
   begin
      udMargeHaute.Position:=round((HauteurTotale/ResY*25.4-HauteurDessin_mm)/2);
      udMargeHaute.Enabled:=false;
      edMargeHaute.Enabled:=false;
   end
   else
   begin
      udMargeHaute.Enabled:=true;
      edMargeHaute.Enabled:=true;
   end;
end;

procedure TfmPreferences.cbCadreClick(Sender: TObject);
begin
   blCadre:=cbCadre.checked;
end;

procedure TfmPreferences.cgCadreClick(Sender: TObject);
begin
   clCadre:=cgCadre.ForegroundColor;
end;

procedure TfmPreferences.InformationMinMax;
var r : real;
begin
   r:=(LargeurDessin_mm-udPosAxeY.Position)/udUx.Position*ValConstante(edUniteX.Text)+
      valConstante(edOrigineAxeX.Text); //XMax
   LabelXMax.Caption:='X maximum : '+FloatToStrF(r,ffGeneral,4,4);
   r:=r-LargeurDessin_mm/udUx.Position*ValConstante(edUniteX.Text);
   LabelXMin.Caption:='X minimum : '+FloatToStrF(r,ffGeneral,4,4);
   r:=udPosAxeX.Position/udUy.Position*ValConstante(edUniteY.Text)+
      valConstante(edOrigineAxeY.Text);
   LabelYMax.Caption:='Y maximum : '+FloatToStrF(r,ffGeneral,4,4);
   r:=r-HauteurDessin_mm/udUy.Position*ValConstante(edUniteY.Text);
   LabelYMin.Caption:='Y minimum : '+FloatToStrF(r,ffGeneral,4,4);
end;

procedure TfmPreferences.edLongueurUx_mmChange(Sender: TObject);
var ch : string;
begin
   ch:=FloatToStrF(udUx.position/10,ffFixed,4,1);
   edLongueurUx.Text:=ch+' cm';
   InformationMinMax;
end;

procedure TfmPreferences.edLongueurUy_mmChange(Sender: TObject);
var ch : string;
begin
   ch:=FloatToStrF(udUy.position/10,ffFixed,4,1);
   edLongueurUy.Text:=ch+' cm';
   InformationMinMax;
end;

procedure TfmPreferences.edPosAxeX_mmChange(Sender: TObject);
var ch : string;
begin
   ch:=FloatToStrF(udPosAxeX.position/10,ffFixed,4,1);
   edPosAxeX.Text:=ch+' cm';
   PosAxeX_mm:=udPosAxeX.Position;
   InformationMinMax;
end;

procedure TfmPreferences.edPosAxeY_mmChange(Sender: TObject);
var ch : string;
begin
   ch:=FloatToStrF(udPosAxeY.position/10,ffFixed,4,1);
   edPosAxeY.Text:=ch+' cm';
   PosAxeY_mm:=udPosAxeY.Position;
   InformationMinMax;
end;

procedure TfmPreferences.edOrigineAxeXExit(Sender: TObject);
var ch : string;
    err : byte;
begin
   NomVar:='X';
   ch:=Traduction(edOrigineAxeX.text,err);
   if err>0 then
   begin
      ShowMessage('La constante '+edOrigineAxeX.Text+' n''est pas correcte');
      edOrigineAxeX.Text:=FloatToStrF(AbscisseAxeY,ffGeneral,4,4);
   end;
   InformationMinMax;
end;

procedure TfmPreferences.edUniteXExit(Sender: TObject);
var ch : string;
    err,k : byte;
begin
   NomVar:='X';
   ch:=edUniteX.Text;
   k:=Pos('.',ch);if k>0 then ch:=Copy(ch,1,k-1)+','+copy(ch,k+1,length(ch)-k);
   edUniteX.Text:=ch;
   ch:=Traduction(edUniteX.text,err);
   if Pos('',ch)>0 then FormatUx:=2 else FormatUx:=1;
   if err>0 then
   begin
      ShowMessage('La constante '+edUniteX.Text+' n''est pas correcte');
      edUniteX.Text:=FloatToStrF(Ux,ffGeneral,4,4);
   end;
   InformationMinMax;
end;

procedure TfmPreferences.edOrigineAxeYExit(Sender: TObject);
var ch : string;
    err : byte;
begin
   NomVar:='X';
   ch:=Traduction(edOrigineAxeY.text,err);
   if err>0 then
   begin
      ShowMessage('La constante '+edOrigineAxeY.Text+' n''est pas correcte');
      edOrigineAxeY.Text:=FloatToStrF(OrdonneeAxeX,ffGeneral,4,4);
   end;
   InformationMinMax;
end;

procedure TfmPreferences.edUniteYExit(Sender: TObject);
var ch : string;
    err,k : byte;
begin
   NomVar:='X';
   ch:=edUniteY.Text;
   k:=Pos('.',ch);if k>0 then ch:=Copy(ch,1,k-1)+','+copy(ch,k+1,length(ch)-k);
   edUniteY.Text:=ch;
   ch:=Traduction(edUniteY.text,err);
   if Pos('',ch)>0 then FormatUy:=2 else FormatUy:=1;
   if err>0 then
   begin
      ShowMessage('La constante '+edUniteY.Text+' n''est pas correcte');
      edUniteY.Text:=FloatToStrF(Uy,ffGeneral,4,4);
   end;
   InformationMinMax;
end;

procedure TfmPreferences.edLongueurUxExit(Sender: TObject);
var ch : string;
    k  : integer;
    r  : real;
begin
   ch:=edLongueurUx.text;
   k:=Pos('.',ch);if k>0 then ch:=Copy(ch,1,k-1)+','+copy(ch,k+1,length(ch)-k);
   k:=1;
   while (k<length(ch))and(ch[k] in ['0'..'9',',']) do inc(k);
   ch:=copy(ch,1,k);
   r:=StrToFloat(ch)*10;
   udUx.Position:=round(r);
   InformationMinMax;
end;

procedure TfmPreferences.edPosAxeXExit(Sender: TObject);
var ch : string;
    k  : integer;
    r  : real;
begin
   ch:=edPosAxeX.text;
   k:=Pos('.',ch);if k>0 then ch:=Copy(ch,1,k-1)+','+copy(ch,k+1,length(ch)-k);
   k:=1;
   while (k<length(ch))and(ch[k] in ['0'..'9',',']) do inc(k);
   ch:=copy(ch,1,k);
   r:=StrToFloat(ch)*10;
   udPosAxeX.Position:=round(r);
   InformationMinMax;
end;

procedure TfmPreferences.edLongueurUyExit(Sender: TObject);
var ch : string;
    k  : integer;
    r  : real;
begin
   ch:=edLongueurUy.text;
   k:=Pos('.',ch);if k>0 then ch:=Copy(ch,1,k-1)+','+copy(ch,k+1,length(ch)-k);
   k:=1;
   while (k<length(ch))and(ch[k] in ['0'..'9',',']) do inc(k);
   ch:=copy(ch,1,k);
   r:=StrToFloat(ch)*10;
   udUy.Position:=round(r);
   InformationMinMax;
end;

procedure TfmPreferences.edPosAxeYExit(Sender: TObject);
var ch : string;
    k  : integer;
    r  : real;
begin
   ch:=edPosAxeY.text;
   k:=Pos('.',ch);if k>0 then ch:=Copy(ch,1,k-1)+','+copy(ch,k+1,length(ch)-k);
   k:=1;
   while (k<length(ch))and(ch[k] in ['0'..'9',',']) do inc(k);
   ch:=copy(ch,1,k);
   r:=StrToFloat(ch)*10;
   udPosAxeY.Position:=round(r);
   InformationMinMax;
end;

procedure TfmPreferences.cbGraduationsPar5mmClick(Sender: TObject);
begin
   if cbGraduationsPar5mm.Checked then
   begin
      UdUx.Increment:=5;
      UdUy.Increment:=5;
   end
   else
   begin
      UdUx.Increment:=1;
      UdUy.Increment:=1;
   end;
end;

Procedure DessinerGrille;
var
   i,j,k,a,b : integer;
   r:real;
begin
   with fmPreferences.Image1.Canvas do
   begin
      brush.color:=fmPreferences.cdCouleurFond.color;
      brush.Style:=bsSolid;
      rectangle(0,0,105,105);
      brush.style:=bsClear;
      pen.color:=fmPreferences.cdCouleurGrille.Color;
      if fmPreferences.rbCroix.Checked then for i:=0 to round(105*25.4/ResEX/tpc) do for j:=0 to round(105*25.4/ResEY/tpc) do
      begin
         MoveTo(round((tpc*i-0.5)*ResEX/25.4),round(tpc*j*ResEY/25.4));
         LineTo(round((tpc*i+0.5)*ResEX/25.4),round(tpc*j*ResEY/25.4));
         MoveTo(round(tpc*i*ResEX/25.4),round((tpc*j-0.5)*ResEY/25.4));
         LineTo(round(tpc*i*ResEX/25.4),round((tpc*j+0.5)*ResEY/25.4));
      end;
      if fmPreferences.rbPointillesFins.checked then
      begin
         for i:=0 to round(105*25.4/ResEX/tpc) do for k:=0 to round(105*25.4/ResEY) do
            pixels[round(tpc*i*ResEX/25.4),round(k*ResEY/25.4)]:=fmPreferences.cdCouleurGrille.Color;
         for j:=0 to round(105*25.4/ResEY/tpc) do for k:=0 to round(105*25.4/ResEX) do
            pixels[round(k*ResEX/25.4),round(tpc*j*ResEY/25.4)]:=fmPreferences.cdCouleurGrille.Color;
      end;
      if fmPreferences.rbPointillesMoyens.checked then
      begin
         for i:=0 to round(105*25.4/ResEX/tpc) do for k:=0 to round(105*25.4/ResEY) do
         begin
            a:=round(tpc*i*ResEX/25.4);b:=round(k*ResEY/25.4);
            pixels[a-1,b-1]:=fmPreferences.cdCouleurGrille.Color;pixels[a,b-1]:=fmPreferences.cdCouleurGrille.Color;
            pixels[a-1,b]:=fmPreferences.cdCouleurGrille.Color;pixels[a,b]:=fmPreferences.cdCouleurGrille.Color;
         end;
         for j:=0 to round(105*25.4/ResEY/tpc) do for k:=0 to round(105*25.4/ResEX) do
         begin
            a:=round(k*ResEX/25.4);b:=round(tpc*j*ResEY/25.4);
            pixels[a-1,b-1]:=fmPreferences.cdCouleurGrille.Color;pixels[a,b-1]:=fmPreferences.cdCouleurGrille.Color;
            pixels[a-1,b]:=fmPreferences.cdCouleurGrille.Color;pixels[a,b]:=fmPreferences.cdCouleurGrille.Color;
         end;
      end;
      if fmPreferences.rbTirets.checked then
      begin
         {for i:=0 to round(105*25.4/ResEX/tpc) do for k:=0 to round(105*25.4/ResEY/1.25) do
         begin
            MoveTo(round(5*i*ResEX/25.4),round((1.25*k-0.625)*ResEY/25.4));
            if odd(k+1) then LineTo(round(5*i*ResEX/25.4),round((1.25*k+0.625)*ResEY/25.4));
         end;
         for j:=0 to round(105*25.4/ResEY/5) do for k:=0 to round(105*25.4/ResEX/1.25) do
         begin
            MoveTo(round((1.25*k-0.625)*ResEX/25.4),round(5*j*ResEY/25.4));
            if odd(k+1) then LineTo(round((1.25*k+0.625)*ResEX/25.4),round(5*j*ResEY/25.4));
         end;   }
         for i:=0 to round(105*25.4/ResEX/tpc) do  //i=abscisse
            for j:=0 to Round(105*254/LongueurTirets/ResEY/2) do
            begin
               MoveTo(round(i*10*tpc*ResEX/254),Round(2*j*LongueurTirets*ResEY/254));
               LineTo(round(i*10*tpc*ResEX/254),Round((2*j+1)*LongueurTirets*ResEY/254));
            end;
         for j:=0 to round(105*25.4/ResEY/tpc) do  //j=ordonne
            for i:=0 to Round(105*254/LongueurTirets/ResEX/2) do
            begin
               MoveTo(Round(2*i*LongueurTirets*ResEX/254),round(j*10*tpc*ResEY/254));
               LineTo(Round((2*i+1)*LongueurTirets*ResEX/254),round(j*10*tpc*ResEY/254));
            end;
      end;
      if fmPreferences.rbPetitsCarreaux.checked then for i:=0 to round(105*25.4/ResEX/tpc) do
      begin
         MoveTo(0,round(tpc*i*ResEY/25.4));LineTo(115,round(tpc*i*ResEY/25.4));
         MoveTo(round(tpc*i*ResEX/25.4),0);LineTo(round(tpc*i*ResEX/25.4),115);
      end;
      if fmPreferences.rbPapierMillimetre.Checked then
      begin
         for i:=0 to round(105*25.4/ResEX) do
         begin
            if i mod 5 = 0 then pen.Width:=2 else pen.Width:=1;
            MoveTo(round(i*ResEX/25.4),0);LineTo(round(i*ResEX/25.4),115);
         end;
         for i:=0 to round(105*25.4/ResEY) do
         begin
            if i mod 5 = 0 then pen.Width:=2 else pen.Width:=1;
            MoveTo(0,round(i*ResEY/25.4));LineTo(115,round(i*ResEY/25.4));
         end;
      end;
      if fmPreferences.rbPapierPointe.Checked
         then begin
         r:=DiametrePoints/20.0;       //rayon des points en mm
         brush.color:=fmPreferences.cdCouleurGrille.Color;
         for i:=0 to round(105*25.4/ResEX/tpc) do for j:=0 to round(105*25.4/ResEY/tpc) do
            begin
            Ellipse(round((tpc*i-r)*ResEX/25.4) ,round((tpc*j-r)*ResEY/25.4) ,round((tpc*i+r)*ResEX/25.4) ,round((tpc*j+r)*ResEY/25.4) );
            end;
         end;
   end;
end;


procedure TfmPreferences.FormCreate(Sender: TObject);
begin
   {sbAucune.Glyph.LoadFromResourceName(HInstance,'AUCUNEGRILLE');
   sbCroix.Glyph.LoadFromResourceName(HInstance,'PETITESCROIX');
   sbPetitsCarreaux.Glyph.LoadFromResourceName(HInstance,'PETITSCARREAUX');
   sbPointillesFins.Glyph.LoadFromResourceName(HInstance,'POINTILLES');
   sbPointillesMoyens.Glyph.LoadFromResourceName(HInstance,'POINTILLESMOYENS');
   sbTirets.Glyph.LoadFromResourceName(HInstance,'TIRETS');}
//   ChargerPreferences;
end;

procedure TfmPreferences.FormShow(Sender: TObject);
var chLargeurMax,chHauteurMax,
    chMargeGaucheMin,chMargeHauteMin,ch : string;
    mgMin_mm,mhMin_mm : integer; //marges gauche et haute minimales en millimtres
    num,den : integer;           //fraction de pi pour TMin et TMax ...
begin
   ChargerPreferences;
   //mise en place des paramtres de la page 'Mise en page'
   if blPortrait then rgOrientation.ItemIndex:=0
                 else rgOrientation.ItemIndex:=1;
   InitialiserCanvasSortie;//permet de calculer les variables MargeGaucheMin ...
   cbCentrerHorizontalement.checked:=blCentrerHorizontalement;
   cbCentrerVerticalement.checked:=blCentrerVerticalement;

   mgMin_mm:=trunc(MargeGaucheMin*25.4/resX)+1;
   mhMin_mm:=trunc(MargeHauteMin*25.4/ResY)+1;
   if cbCentrerHorizontalement.checked
   then chLargeurMax:=FloatToStrF(LargeurImprimable*2.54/ResX,ffFixed,3,1)
   else chLargeurMax:=FloatToStrF(LargeurImprimable*2.54/ResX-MargeGauche_mm/10,ffFixed,3,1);
   if cbCentrerVerticalement.checked
   then chHauteurMax:=FloatToStrF(HauteurImprimable*2.54/ResY,ffFixed,3,1)
   else chHauteurMax:=FloatToStrF(HauteurImprimable*2.54/ResY-MargeHaute_mm/10,ffFixed,3,1);
   chMargeGaucheMin:=FloatToStrF(mgMin_mm/10,ffFixed,2,1);
   chMargeHauteMin:=FloatToStrF(mhMin_mm/10,ffFixed,2,1);
   labelLargeurMax.Caption:='( Largeur maximale : '+chLargeurMax+' cm )';
   labelHauteurMax.Caption:='( Hauteur maximale : '+chHauteurMax+' cm )';
   labelMargeGaucheMinimale.Caption:='( Minimum : '+chMargeGaucheMin+' cm )';
   labelMargeHauteMinimale.Caption:='( Minimum : '+chMargeHauteMin+' cm )';
   udMargeGauche.Min:=mgMin_mm;
   udMargeGauche.Max:=trunc(LargeurImprimable*25.4/ResX-LargeurDessin_mm);
   udMargeGauche.Position:=MargeGauche_mm;
   udMargeHaute.Min:=mhMin_mm;
   udMargeHaute.Max:=trunc(HauteurImprimable*25.4/ResY-HauteurDessin_mm);
   udMargeHaute.Position:=MargeHaute_mm;
   if cbCentrerHorizontalement.checked
      then udLargeur.Max:=trunc(LargeurImprimable*25.4/ResX)
      else udLargeur.Max:=trunc(LargeurImprimable*25.4/ResX-MargeGauche_mm);
   udLargeur.Position:=LargeurDessin_mm;
   if cbCentrerVerticalement.checked
      then udHauteur.Max:=trunc(HauteurImprimable*25.4/ResX)
      else udHauteur.Max:=trunc(HauteurImprimable*25.4/ResX-MargeHaute_mm);
   udHauteur.Position:=HauteurDessin_mm;
   cbCadre.Checked:=blCadre;
   cgCadre.ForegroundIndex:=cgCadre.ColorToIndex(clCadre);
   pnCouleurFond.Color:=clFond;

   //mise en place des paramtres de la page 'repre'
   udUx.Position:=UniteX_mm;
   udUy.Position:=UniteY_mm;
   udPosAxeX.Position:=PosAxeX_mm;
   udPosAxeY.Position:=PosAxeY_mm;
   edNomAxeOx.Text:=NomAxeOx;
   edNomAxeOy.Text:=NomAxeOy;

   if (edOrigineAxeX.text='')or(ValConstante(edOrigineAxeX.text)<>AbscisseAxeY)
         then edOrigineAxeX.text:=FloatToStrF(AbscisseAxeY,ffGeneral,4,4);
   if (edOrigineAxeY.text='')or(ValConstante(edOrigineAxeY.text)<>OrdonneeAxeX)
         then edOrigineAxeY.Text:=FloatToStrF(OrdonneeAxeX,ffGeneral,4,4);
   if (edUniteX.Text='')or(ValConstante(edUniteX.Text)<>Ux)
         then edUniteX.Text:=FloatToStrF(Ux,ffGeneral,4,4);
   if (edUniteY.Text='')or(ValConstante(edUniteY.Text)<>Uy)
         then edUniteY.Text:=FloatToStrF(Uy,ffGeneral,4,4);


   if blGraduationsPar5mm then
   begin
      udUx.Increment:=tpc;
      udUy.Increment:=tpc;
   end
   else
   begin
      udUx.Increment:=1;
      udUy.Increment:=1;
   end;
   cbRepereVisible.Checked:=blRepereVisible;
   cbGraduationsPar5mm.Checked:=blGraduationsPar5mm;
   cbGraduationsCompletes.Checked:=blGraduationsCompletes;
   case StyleGrille of
         sgAucune : rbAucune.Checked:=true;
         sgCroix : rbCroix.Checked:=true;
         sgPointillesFins : rbPointillesFins.checked:=true;
         sgPointillesMoyens : rbPointillesMoyens.checked:=true;
         sgTirets : rbTirets.checked:=true;
         sgPetitsCarreaux : rbPetitsCarreaux.Checked:=true;
         sgPapierMillimetre : rbPapierMillimetre.Checked:=true;
         sgPapierPointe : rbPapierPointe.Checked:=true;
   end;
   cdCouleurGrille.Color:=clGrille;
   cdCouleurFond.Color:=clFond;
   cgAxes.ForegroundIndex:=cgAxes.ColorToIndex(clAxes);
   udTaillePetitsCarreaux.Position:=tpc;
   pcPreferences.ActivePage:=tsRepere;
   DessinerGrille;

   //mise en place des paramtres de la page 'autres parametres'
   rgPointsD_arret.ItemIndex:=round((RayonPointD_arret)/0.3);
   rgEpaisseurLignesCote.ItemIndex:=EpaisseurLignesCote-1;
   udEpaisseurTangentes.Position:=EpaisseurTangentes;   //Oct 2012
   udEpaisseurNormales.Position:=EpaisseurNormales;     //Oct 2012
   udEpaisseurFleches.Position:=EpaisseurFleches;       //Oct 2012
   udEpaisseurAxes.Position:=EpaisseurAxes;             //Mars2013
   udDiametrePoints.Position:=DiametrePoints;
   udLongueurTirets.Position:=LongueurTirets;
   edLongueurTirets.text:=inttostr(LongueurTirets div 10)+','+inttostr(LongueurTirets mod 10)+' mm';

   //mise en place des paramtres de la page 'format des courbes'
   cgCouleurFonctions.ForegroundIndex:=cgCouleurFonctions.ColorToIndex(clFonctions);
   udEpaisseurFonctions.Position:=EpaisseurFonctions;     //Oct 2012
   rgStyleFonctions.ItemIndex:=ord(StyleFonctions);
   cgCouleurCourbesParametrees.ForegroundIndex:=cgCouleurCourbesParametrees.ColorToIndex(clCourbesParametrees);
   udEpaisseurCourbesParametrees.Position:=EpaisseurCourbesParametrees; //Oct 2012
   rgStyleCourbesParametrees.ItemIndex:=ord(StyleCourbesParametrees);
   cgCouleurDroites.ForegroundIndex:=cgCouleurDroites.ColorToIndex(clDroites);
   udEpaisseurDroites.Position:=EpaisseurDroites;   //Oct 2012
   rgStyleDroites.ItemIndex:=ord(StyleDroites);
   if DecomposeFraction(abs(TMin)/pi,num,den)or(den=1) then
   begin
      ch:=inttostr(num)+'pi/'+inttostr(den);
      if num=0 then ch:='0';
      if num=1 then delete(ch,1,1);
      if den=1 then delete(ch,length(ch)-1,2);
      if TMin<0 then ch:='-'+ch;
      edTMin.Text:=ch;
   end
   else edTMin.Text:=FloatToStr(TMin);
   if DecomposeFraction(abs(TMax)/pi,num,den)or(den=1) then
   begin
      ch:=inttostr(num)+'pi/'+inttostr(den);
      if num=0 then ch:='0';
      if num=1 then delete(ch,1,1);
      if den=1 then delete(ch,length(ch)-1,2);
      if TMax<0 then ch:='-'+ch;
      edTMax.Text:=ch;
   end
   else edTMax.Text:=FloatToStr(TMax);
   edNBT.Text:=IntToStr(nbT);
end;

procedure TfmPreferences.ChargerPreferences;
var FichierPref : textFile;
    ch,CheminMesDocuments : string;
    err                   : byte;
begin
   CheminMesDocuments:=GetSpecialFolder(CSIDL_PERSONAL);
   if CheminMesDocuments[length(CheminMesDocuments)]='\' then Delete(CheminMesDocuments,length(CheminMesDocuments),1);
   if FileExists(CheminMesDocuments+'\Preferences_sqn.txt') then
   begin     //valeurs charges depuis le fichier des prfrences
      assignFile(FichierPref,CheminMesDocuments+'\Preferences_sqn.txt');
      reset(FichierPref);
         Readln(FichierPref,ch);delete(ch,1,pos(':',ch));blPortrait:=ch='Portrait';
         Readln(FichierPref,ch);delete(ch,1,pos(':',ch));blCadre:=ch='Oui';
         Readln(FichierPref,ch);delete(ch,1,pos(':',ch));blRepereVisible:=ch='Oui';
         Readln(FichierPref,ch);delete(ch,1,pos(':',ch));blGraduationsCompletes:=ch='Oui';
         Readln(FichierPref,ch);delete(ch,1,pos(':',ch));blGraduationsPar5mm:=ch='Oui';
         Readln(FichierPref,ch);delete(ch,1,pos(':',ch));blCentrerHorizontalement:=ch='Oui';
         Readln(FichierPref,ch);delete(ch,1,pos(':',ch));blCentrerVerticalement:=ch='Oui';
         Readln(FichierPref,ch);delete(ch,1,pos(':',ch));zoom:=StrToInt(ch);
         Readln(FichierPref,ch);delete(ch,1,pos(':',ch));
            if ch='Aucune' then StyleGrille:=sgAucune;
            if ch='Petites croix' then StyleGrille:=sgCroix;
            if ch='Pointills fins' then StyleGrille:=sgPointillesFins;
            if ch='Pointills moyens' then StyleGrille:=sgPointillesMoyens;
            if ch='Tirets' then StyleGrille:=sgTirets;
            if ch='Petits carreaux' then StyleGrille:=sgPetitsCarreaux;
            if ch='Papier millimtr' then StyleGrille:=sgPapierMillimetre;
            if ch='Papier point' then StyleGrille:=sgPapierPointe;
         Readln(FichierPref,ch);delete(ch,1,pos(':',ch));LargeurDessin_mm:=StrToInt(ch);
         Readln(FichierPref,ch);delete(ch,1,pos(':',ch));HauteurDessin_mm:=StrToInt(ch);
         Readln(FichierPref,ch);delete(ch,1,pos(':',ch));MargeGauche_mm:=StrToInt(ch);
         Readln(FichierPref,ch);delete(ch,1,pos(':',ch));MargeHaute_mm:=StrToInt(ch);
         Readln(FichierPref,ch);delete(ch,1,pos(':',ch));PosAxeX_mm:=StrToInt(ch);
         Readln(FichierPref,ch);delete(ch,1,pos(':',ch));PosAxeY_mm:=StrToInt(ch);
         Readln(FichierPref,ch);delete(ch,1,pos(':',ch));UniteX_mm:=StrToInt(ch);
         Readln(FichierPref,ch);delete(ch,1,pos(':',ch));UniteY_mm:=StrToInt(ch);
         Readln(FichierPref,ch);delete(ch,1,pos(':',ch));Ux:=StrToFloat(ch);
         Readln(FichierPref,ch);delete(ch,1,pos(':',ch));Uy:=StrToFloat(ch);
         Readln(FichierPref,ch);delete(ch,1,pos(':',ch));FormatUx:=StrToInt(ch);
         Readln(FichierPref,ch);delete(ch,1,pos(':',ch));FormatUy:=StrToInt(ch);
         Readln(FichierPref,ch);delete(ch,1,pos(':',ch));ch:=Traduction(ch,err);TMin:=f(ch,1);
         Readln(FichierPref,ch);delete(ch,1,pos(':',ch));ch:=Traduction(ch,err);TMax:=f(ch,1);
         Readln(FichierPref,ch);delete(ch,1,pos(':',ch));nbT:=StrToInt(ch);
         Readln(FichierPref,ch);delete(ch,1,pos(':',ch));AbscisseAxeY:=StrToFloat(ch);
         Readln(FichierPref,ch);delete(ch,1,pos(':',ch));OrdonneeAxeX:=StrToFloat(ch);
         Readln(FichierPref,ch);delete(ch,1,pos(':',ch));
         if Pos(chr(9),ch)=0 then begin clCadre:=StrToInt(ch);clFond:=clWhite;end
         else begin
              clCadre:=StrToInt(copy(ch,1,pos(chr(9),ch)-1));
              delete(ch,1,pos(chr(9),ch));
              clFond:=StrToInt(ch);
           end;
         Readln(FichierPref,ch);delete(ch,1,pos(':',ch));clAxes:=StrToInt(ch);
         Readln(FichierPref,ch);delete(ch,1,pos(':',ch));clGrille:=StrToInt(ch);
         Readln(FichierPref,ch);delete(ch,1,pos(':',ch));btPoliceTextes.Font.Name:=ch;
         Readln(FichierPref,ch);delete(ch,1,pos(':',ch));btPoliceTextes.Font.Size:=StrToInt(ch);
         btPoliceTextes.Caption:=btPoliceTextes.Font.Name+' - '+ch;
         Readln(FichierPref,ch);delete(ch,1,pos(':',ch));
            if ch='Normal' then btPoliceTextes.Font.Style:=[];
            if ch='Gras' then btPoliceTextes.Font.Style:=[fsBold];
            if ch='Italique' then btPoliceTextes.Font.Style:=[fsItalic];
            if ch='Gras, Italique' then btPoliceTextes.Font.Style:=[fsBold,fsItalic];
         Readln(FichierPref,ch);delete(ch,1,pos(':',ch));btPoliceTextes.Font.Color:=StrToInt(ch);
         if not(eof(FichierPref)) then
         begin
         Readln(FichierPref,ch);delete(ch,1,pos(':',ch));btPoliceGraduations.Font.Name:=ch;
         Readln(FichierPref,ch);delete(ch,1,pos(':',ch));btPoliceGraduations.Font.Size:=StrToInt(ch);
         Readln(FichierPref,ch);delete(ch,1,pos(':',ch));
            if ch='Normal' then btPoliceGraduations.Font.Style:=[];
            if ch='Gras' then btPoliceGraduations.Font.Style:=[fsBold];
            if ch='Italique' then btPoliceGraduations.Font.Style:=[fsItalic];
            if ch='Gras, Italique' then btPoliceGraduations.Font.Style:=[fsBold,fsItalic];
         Readln(FichierPref,ch);delete(ch,1,pos(':',ch));btPoliceGraduations.Font.Color:=StrToInt(ch);
         btPoliceGraduations.caption:=btPoliceGraduations.Font.name+' - '+
                                     IntToStr(btPoliceGraduations.font.size);
         end;
         if not(eof(FichierPref)) then
         begin
            readln(FichierPref,ch);delete(ch,1,pos(':',ch));
            RayonPointD_arret:=StrToFloat(ch);
            readln(FichierPref,ch);delete(ch,1,pos(':',ch));
            EpaisseurLignesCote:=StrToInt(ch);
            readln(FichierPref,ch);delete(ch,1,pos(':',ch));
            EpaisseurTangentes:=StrToInt(ch);
            readln(FichierPref,ch);delete(ch,1,pos(':',ch));
            EpaisseurNormales:=StrToInt(ch);
            readln(FichierPref,ch);delete(ch,1,pos(':',ch));
            EpaisseurFleches:=StrToInt(ch);
            readln(FichierPref,ch);delete(ch,1,pos(':',ch));
            EpaisseurAxes:=StrToInt(ch);
         end
         else
         begin //valeurs standard
            RayonPointD_arret:=0.3;
            EpaisseurLignesCote:=2;
            EpaisseurTangentes:=2;
            EpaisseurNormales:=2;
            EpaisseurFleches:=2;
            EpaisseurAxes:=2;
         end;
         rgPointsD_arret.ItemIndex:=round((RayonPointD_arret)/0.3);
         rgEpaisseurLignesCote.ItemIndex:=EpaisseurLignesCote-1;
         udEpaisseurTangentes.Position:=EpaisseurTangentes;
         udEpaisseurNormales.Position:=EpaisseurNormales;
         udEpaisseurFleches.Position:=EpaisseurFleches;
         udEpaisseurAxes.Position:=EpaisseurAxes;
         if not(eof(FichierPref)) then
         begin
            readln(FichierPref,NomAxeOx);delete(NomAxeOx,1,pos(':',NomAxeOx));
            readln(FichierPref,NomAxeOy);delete(NomAxeOy,1,pos(':',NomAxeOy));
         end
         else
         begin
            NomAxeOx:='x';
            NomAxeOy:='y';
         end;
         if not(eof(FichierPref)) then
         begin
            readln(FichierPref,ch);delete(ch,1,pos(':',ch));nbChiffresSignificatifsX:=StrToInt(ch);
            readln(FichierPref,ch);delete(ch,1,pos(':',ch));nbChiffresSignificatifsY:=StrToInt(ch);
            readln(FichierPref,ch);delete(ch,1,pos(':',ch));DiametrePoints:=StrToInt(ch);
         end
         else
         begin
            nbChiffresSignificatifsX:=4;
            nbChiffresSignificatifsY:=4;
            DiametrePoints:=10;
         end;
         if not(eof(FichierPref)) then
         begin
            readln(FichierPref,ch);delete(ch,1,pos(':',ch));clFonctions:=StrToInt(ch);
            readln(FichierPref,ch);delete(ch,1,pos(':',ch));clCourbesParametrees:=StrToInt(ch);
            readln(FichierPref,ch);delete(ch,1,pos(':',ch));clDroites:=StrToInt(ch);
            readln(FichierPref,ch);delete(ch,1,pos(':',ch));EpaisseurFonctions:=StrToInt(ch);
            readln(FichierPref,ch);delete(ch,1,pos(':',ch));EpaisseurCourbesParametrees:=StrToInt(ch);
            readln(FichierPref,ch);delete(ch,1,pos(':',ch));EpaisseurDroites:=StrToInt(ch);
            readln(FichierPref,ch);delete(ch,1,pos(':',ch));StyleFonctions:=TStyleCourbe(StrToInt(ch));
            readln(FichierPref,ch);delete(ch,1,pos(':',ch));StyleCourbesParametrees:=TStyleCourbe(StrToInt(ch));
            readln(FichierPref,ch);delete(ch,1,pos(':',ch));StyleDroites:=TStyleCourbe(StrToInt(ch));
         end
         else
         begin
            clFonctions:=clBlack;
            clCourbesParametrees:=clBlack;
            clDroites:=clBlack;
            EpaisseurFonctions:=2;
            EpaisseurCourbesParametrees:=2;
            EpaisseurDroites:=2;
            StyleFonctions:=scContinu;
            StyleCourbesParametrees:=scContinu;
            StyleDroites:=scContinu;
         end;
         if not eof(FichierPref) then
         begin
            readln(FichierPref,ch);delete(ch,1,pos(':',ch));LongueurTirets:=StrToInt(ch);
         end;
         if not eof(FichierPref) then
         begin
            readln(FichierPref,ch);delete(ch,1,pos(':',ch));tpc:=StrToInt(ch);   //taille des petits carreaux
         end;
      closeFile(FichierPref);
      blLogX:=False;blLogY:=False; //ces valeurs ne sont pas enregistres dans le fichier mais sont toujours celles par dfaut
   end
   else
   begin     //valeurs prises par dfaut
      blPortrait:=true;
      blCadre:=true;           //prsence du cadre autour du dessin
      blRepereVisible:=true;   //repre (et graduations) visible
      blGraduationsCompletes:=true; //graduations compltes
      blGraduationsPar5mm:=true;    //units de graduation multiples de 5 mm
      blCentrerHorizontalement:=false;
      blCentrerVerticalement:=false;
      zoom:=100;               //agit sur l'cran seulement, pas sur l'imprimante
      styleGrille:=sgPointillesFins;          //grille  petits carreaux pointills fins


      LargeurDessin_mm:=180;    //18 cm
      HauteurDessin_mm:=130;    //13 cm
      MargeGauche_mm:=15;       //1,5 cm y compris la marge gauche non imprimable
      MargeHaute_mm:=15;        //1,5 cm y compris la marge haute non imprimable
      PosAxeX_mm:=65;           //6,5 cm depuis le bord haut du dessin
      PosAxeY_mm:=90;           //9 cm depuis le bord gauche du dessin
      UniteX_mm:=10;            //longueur de l'unit de graduation en X
      UniteY_mm:=10;            //longueur de l'unit de graduation en Y
      Ux:=1;                    //unit de graduation en X
      Uy:=1;                    //unit de graduation en Y
      FormatUx:=1;              //graduations entires en X
      FormatUy:=1;              //graduations entires en Y
      TMin:=-pi;
      TMax:=pi;
      NbT:=400;
      OrdonneeAxeX:=0;          //l'quation de l'axe des X est y=0
      AbscisseAxeY:=0;          //l'quation de l'axe des Y est x=0

      clCadre:=clSilver;//$00DDDDDD;       //gris trs clair
      clFond:=clWhite;
      clAxes:=clBlack;
      clGrille:=8388736;    //mauve fonc
      with btPoliceTextes.font do
      begin
         name:='Times New Roman';
         size:=10;
         style:=[fsItalic];
         color:=clBlack;
         btPoliceTextes.Caption:='Times New Roman';
      end;
      with btPoliceGraduations.font do
      begin
         name:='Courier New';
         size:=10;
         style:=[];
         color:=clBlack;
         btPoliceGraduations.caption:='Courier New - 10';
      end;
      RayonPointD_arret:=0.3;
      EpaisseurLignesCote:=2;
      EpaisseurTangentes:=2;
      EpaisseurNormales:=2;
      EpaisseurFleches:=2;
      EpaisseurAxes:=2;
      NomAxeOx:='x';
      NomAxeOy:='y';
      nbChiffresSignificatifsX:=4;
      nbChiffresSignificatifsY:=4;
      DiametrePoints:=10;
      clFonctions:=clBlack;
      clCourbesParametrees:=clBlack;
      clDroites:=clBlack;
      EpaisseurFonctions:=2;
      EpaisseurCourbesParametrees:=2;
      EpaisseurDroites:=2;
      StyleFonctions:=scContinu;
      StyleCourbesParametrees:=scContinu;
      StyleDroites:=scContinu;
      tpc:=5;   //taille des petits carreaux
      blLogX:=False;blLogY:=False;
   end;
end;

procedure TfmPreferences.btOKClick(Sender: TObject);
var FichierPref : TextFile;
    CheminMesDocuments : string;
begin
   //enregistrement du fichier des prfrences
   CheminMesDocuments:=GetSpecialFolder(CSIDL_PERSONAL);
   if CheminMesDocuments[length(CheminMesDocuments)]='\' then Delete(CheminMesDocuments,length(CheminMesDocuments),1);
   AssignFile(FichierPref,CheminMesDocuments+'\Preferences_sqn.txt');
   rewrite(FichierPref);
      if blPortrait then writeln(FichierPref,'Orientation :Portrait')
                    else writeln(FichierPref,'Orientation :Paysage');
      if blCadre then writeln(FichierPref,'Cadre autour du dessin :Oui')
                 else writeln(FichierPref,'Cadre autour du dessin :Non');
      if cbRepereVisible.Checked then writeln(FichierPref,'Axes visibles :Oui')
                         else writeln(FichierPref,'Axes visibles :Non');
      if cbGraduationsCompletes.Checked then writeln(FichierPref,'Graduations compltes :Oui')
                                else writeln(FichierPref,'Graduations compltes :Non');
      if cbGraduationsPar5mm.Checked then writeln(FichierPref,'Graduations bases sur la grille :Oui')
                             else writeln(FichierPref,'Graduations bases sur la grille :Non');
      if cbCentrerHorizontalement.Checked then writeln(FichierPref,'Centrer horizontalement :Oui')
                                  else writeln(FichierPref,'Centrer horizontalement :Non');
      if cbCentrerVerticalement.Checked then writeln(FichierPref,'Centrer verticalement :Oui')
                                else writeln(FichierPref,'Centrer verticalement :Non');
      writeln(FichierPref,'Zoom :'+inttostr(zoom));
      case StyleGrille of
         sgAucune            : writeln(FichierPref,'Style grille :Aucune');
         sgCroix             : writeln(FichierPref,'Style grille :Petites croix');
         sgPointillesFins    : writeln(FichierPref,'Style grille :Pointills fins');
         sgPointillesMoyens  : writeln(FichierPref,'Style grille :Pointills moyens');
         sgTirets            : writeln(FichierPref,'Style grille :Tirets');
         sgPetitsCarreaux    : writeln(FichierPref,'Style grille :Petits carreaux');
         sgPapierMillimetre  : writeln(FichierPref,'Style grille :Papier millimtr');
         sgPapierPointe      : writeln(FichierPref,'Style grille :Papier point');
      end;
      writeln(FichierPref,'Largeur du dessin en mm :'+IntToStr(LargeurDessin_mm));
      writeln(FichierPref,'Hauteur du dessin en mm :'+IntToStr(HauteurDessin_mm));
      writeln(FichierPref,'Marge gauche en mm :'+IntToStr(MargeGauche_mm));
      writeln(FichierPref,'Marge haute en mm :'+IntToStr(MargeHaute_mm));
      writeln(FichierPref,'Distance de l''axe Ox en mm :'+IntToStr(PosAxeX_mm));
      writeln(FichierPref,'Distance de l''axe Oy en mm :'+IntToStr(PosAxeY_mm));
      writeln(FichierPref,'Longueur de l''unit sur Ox en mm :'+IntToStr(UniteX_mm));
      writeln(FichierPref,'Longueur de l''unit sur Oy en mm :'+IntToStr(UniteY_mm));
      writeln(FichierPref,'Unit de graduation sur Ox :'+FloatToStr(Ux));
      writeln(FichierPref,'Unit de graduation sur Oy :'+FloatToStr(Uy));
      writeln(FichierPref,'Format des units sur Ox :'+inttostr(FormatUx));
      writeln(FichierPref,'Format des units sur Oy :'+IntToStr(FormatUy));
      writeln(FichierPref,'T minimum :'+edTMin.text);
      writeln(FichierPref,'T maximum :'+edTMax.text);
      writeln(FichierPref,'Nombre de valeurs de T :'+ednbt.text);
      writeln(FichierPref,'Origine de l''axe Ox :'+FloatToStr(AbscisseAxeY));
      writeln(FichierPref,'Origine de l''axe Oy :'+FloatToStr(OrdonneeAxeX));
      writeln(FichierPref,'Couleur du cadre :'+IntToStr(clCadre)+chr(9)+IntToStr(clFond));
      writeln(FichierPref,'Couleur des axes :'+IntToStr(clAxes));
      writeln(FichierPref,'Couleur de la grille :'+IntToStr(clGrille));
      writeln(FichierPref,'Police pour les textes :'+btPoliceTextes.Font.Name);
      writeln(FichierPref,'Taille :'+IntToStr(btPoliceTextes.Font.size));
      if btPoliceTextes.Font.Style=[] then writeln(FichierPref,'Style :Normal');
      if btPoliceTextes.Font.Style=[fsBold] then writeln(FichierPref,'Style :Gras');
      if btPoliceTextes.Font.Style=[fsItalic] then writeln(FichierPref,'Style :Italique');
      if btPoliceTextes.Font.Style=[fsBold,fsItalic] then writeln(FichierPref,'Style :Gras, Italique');
      writeln(FichierPref,'Couleur :'+IntToStr(PoliceTextes.Color));
      writeln(FichierPref,'Police pour les graduations :'+btPoliceGraduations.Font.name);
      writeln(FichierPref,'Taille :'+IntToStr(btPoliceGraduations.Font.size));
      if btPoliceGraduations.Font.Style=[] then writeln(FichierPref,'Style :Normal');
      if btPoliceGraduations.Font.Style=[fsBold] then writeln(FichierPref,'Style :Gras');
      if btPoliceGraduations.Font.Style=[fsItalic] then writeln(FichierPref,'Style :Italique');
      if btPoliceGraduations.Font.Style=[fsBold,fsItalic] then writeln(FichierPref,'Style :Gras, Italique');
      writeln(FichierPref,'Couleur :'+IntToStr(btPoliceGraduations.Font.Color));
      writeln(FichierPref,'Taille des points d''arrt :'
           +FloatToStr((rgPointsD_arret.itemindex)*0.3));
      writeln(FichierPref,'Epaisseur des lignes de cote :'+inttostr(rgEpaisseurLignesCote.itemindex+1));
      writeln(FichierPref,'Epaisseur des tangentes :'+inttostr(udEpaisseurTangentes.Position));  //Oct 2012
      writeln(FichierPref,'Epaisseur des normales :'+inttostr(udEpaisseurNormales.Position));    //Oct 2012
      writeln(FichierPref,'Epaisseur des flches tangentes :'+inttostr(udEpaisseurFleches.Position));
      writeln(FichierPref,'Epaisseur des axes du repre :'+inttostr(udEpaisseurAxes.Position));  //Mars 2013
      writeln(FichierPref,'Nom de l''axe des abscisses :'+edNomAxeOx.Text);
      writeln(FichierPref,'Nom de l''axe des ordonnes :'+edNomAxeOy.Text);
      writeln(FichierPref,'Nombre de chiffres significatifs des graduations Ox :'+IntToStr(udChiffresSignificatifsX.position));
      writeln(FichierPref,'Nombre de chiffres significatifs des graduations Oy :'+IntToStr(udChiffresSignificatifsY.position));
      writeln(FichierPref,'Diamtres des points (courbes pointilles) en 10e de mm :'+IntToStr(udDiametrePoints.position));
      writeln(FichierPref,'Couleur des fonctions :'+inttostr(cgCouleurFonctions.foregroundColor));
      writeln(FichierPref,'Couleur des courbes paramtres :'+inttostr(cgCouleurCourbesParametrees.foregroundColor));
      writeln(FichierPref,'Couleur des droites :'+inttostr(cgCouleurDroites.foregroundColor));
      writeln(FichierPref,'Epaisseur des fonctions :'+inttostr(udEpaisseurFonctions.position));                     //oct 2012
      writeln(FichierPref,'Epaisseur des courbes paramtres :'+inttostr(udEpaisseurCourbesParametrees.position));  //oct 2012
      writeln(FichierPref,'Epaisseur des droites :'+inttostr(udEpaisseurDroites.Position));                         //oct 2012
      writeln(FichierPref,'Style des fonctions :'+inttostr(rgStyleFonctions.itemIndex));
      writeln(FichierPref,'Style des courbes paramtres :'+inttostr(rgStyleCourbesParametrees.itemindex));
      writeln(FichierPref,'Style des droites :'+inttostr(rgStyleDroites.itemindex));
      writeln(FichierPref,'Longueur des tirets :'+inttostr(udLongueurTirets.position));
      writeln(FichierPref,'Taille des petits carreaux :'+inttostr(udTaillePetitsCarreaux.position));
      if blAntiCrenelage
      	then writeln(FichierPref,'Anti-Crnelage :oui')
         else writeln(FichierPref,'Anti-Crnelage :non');
   closeFile(FichierPref);
end;

procedure TfmPreferences.rbAucuneClick(Sender: TObject);
begin
   StyleGrille:=sgAucune;
   DessinerGrille;
end;

procedure TfmPreferences.rbCroixClick(Sender: TObject);
begin
   StyleGrille:=sgCroix;
   DessinerGrille;
end;

procedure TfmPreferences.rbPointillesFinsClick(Sender: TObject);
begin
   StyleGrille:=sgPointillesFins;
   DessinerGrille;
end;

procedure TfmPreferences.rbPointillesMoyensClick(Sender: TObject);
begin
   StyleGrille:=sgPointillesMoyens;
   DessinerGrille;
end;

procedure TfmPreferences.rbTiretsClick(Sender: TObject);
begin
   StyleGrille:=sgTirets;
   DessinerGrille;
end;

procedure TfmPreferences.rbPetitsCarreauxClick(Sender: TObject);
begin
   StyleGrille:=sgPetitsCarreaux;
   DessinerGrille;
end;

procedure TfmPreferences.rbPapierPointeClick(Sender: TObject);
begin
   StyleGrille:=sgPapierPointe;
   DessinerGrille;
end;


procedure TfmPreferences.btPoliceGraduationsClick(Sender: TObject);
begin
   FontDialog1.Font.name:=btPoliceGraduations.Font.name;
   FontDialog1.Font.size:=btPoliceGraduations.Font.size;
   FontDialog1.Font.style:=btPoliceGraduations.Font.style;
   FontDialog1.Font.color:=btPoliceGraduations.Font.color;
   if FontDialog1.execute then
   begin
      btPoliceGraduations.Font.name:=FontDialog1.Font.name;
      btPoliceGraduations.Font.size:=FontDialog1.Font.size;
      btPoliceGraduations.Font.style:=FontDialog1.Font.style;
      btPoliceGraduations.Font.color:=FontDialog1.Font.color;
      btPoliceGraduations.caption:=btPoliceGraduations.Font.name+' - '+
                                  inttostr(btPoliceGraduations.Font.size);
   end;
end;

procedure TfmPreferences.pnCouleurFondClick(Sender: TObject);
begin
   cdCouleurFond.Color:=clFond;
   if cdCouleurFond.Execute then
   begin
      clFond:=cdCouleurFond.Color;
      pnCouleurFond.Color:=cdCouleurFond.Color;
   end;
end;

procedure TfmPreferences.btCouleurGrilleClick(Sender: TObject);
var CouleurAvant : TColor;
begin
   CouleurAvant:=cdCouleurGrille.Color;
   if not cdCouleurGrille.Execute then cdCouleurGrille.Color:=CouleurAvant;
   clGrille:=cdCouleurGrille.Color;
   DessinerGrille;
end;

procedure TfmPreferences.btCouleurFondClick(Sender: TObject);
var CouleurAvant : TColor;
begin
   CouleurAvant:=cdCouleurFond.Color;
   if not cdCouleurFond.Execute then cdCouleurFond.Color:=CouleurAvant;
   pnCouleurFond.Color:=cdCouleurFond.Color;
   clFond:=cdCouleurFond.Color;
   DessinerGrille;
end;

procedure TfmPreferences.cdCouleurGrilleShow(Sender: TObject);
var titleColorDlg : Pchar;
begin
   titleColorDlg := Pchar('Slection d''une couleur pour la grille');
   SendMessage(cdCouleurGrille.Handle, WM_SetText, 0, Integer(titleColorDlg));
end;

procedure TfmPreferences.cdCouleurFondShow(Sender: TObject);
var titleColorDlg : Pchar;
begin
   titleColorDlg := Pchar('Slection d''une couleur pour le fond');
   SendMessage(cdCouleurFond.Handle, WM_SetText, 0, Integer(titleColorDlg));
end;

procedure TfmPreferences.rbPapierMillimetreClick(Sender: TObject);
begin
   StyleGrille:=sgPapierMillimetre;
   DessinerGrille;
end;

procedure TfmPreferences.cgAxesChange(Sender: TObject);
begin
   clAxes:=cgAxes.ForegroundColor;  //clAxes est une variable locale
end;

procedure TfmPreferences.edLargeurKeyPress(Sender: TObject; var Key: Char);
begin
   if (key='.')or(key=',') then key:=DecimalSeparator;
end;

procedure TfmPreferences.edHauteurKeyPress(Sender: TObject; var Key: Char);
begin
   if (key='.')or(key=',') then key:=DecimalSeparator;
end;

procedure TfmPreferences.edDiametrePointsChange(Sender: TObject);
begin
   edDiametre.Text:=FloatToStrf(udDiametrePoints.position/10,ffGeneral,3,3)+' mm';
end;

procedure TfmPreferences.btPoliceTextesClick(Sender: TObject);
begin
   FontDialog2.Font.name:=btPoliceTextes.Font.name;
   FontDialog2.Font.size:=btPoliceTextes.Font.size;
   FontDialog2.Font.style:=btPoliceTextes.Font.style;
   FontDialog2.Font.color:=btPoliceTextes.Font.color;
   if FontDialog2.execute then
   begin
      btPoliceTextes.Font.name:=FontDialog2.Font.name;
      btPoliceTextes.Font.size:=FontDialog2.Font.size;
      btPoliceTextes.Font.style:=FontDialog2.Font.style;
      btPoliceTextes.Font.color:=FontDialog2.Font.color;
      btPoliceTextes.caption:=btPoliceTextes.Font.name+' - '+
                                  inttostr(btPoliceTextes.Font.size);
   end;
end;

procedure TfmPreferences.edTiretsChange(Sender: TObject);
begin
   edLongueurTirets.Text:=inttostr(udLongueurTirets.position div 10)+','+inttostr(udLongueurTirets.position mod 10)+' mm';
end;

procedure TfmPreferences.edTaillePetitsCarreauxChange(Sender: TObject);
begin
   tpc:=udTaillePetitsCarreaux.Position;
   DessinerGrille;
end;

procedure TfmPreferences.btParDefautClick(Sender: TObject);
begin
//variables globales dfinies par dfaut

   cbCadre.Checked:=true;           //prsence du cadre autour du dessin
   cbRepereVisible.Checked:=true;   //repre (et graduations) visible
   cbGraduationsCompletes.Checked:=true; //graduations compltes
   cbGraduationsPar5mm.Checked:=true;    //units de graduation multiples de 5 mm
   cbCentrerHorizontalement.Checked:=False;
   cbCentrerVerticalement.Checked:=False;
   blLogX:=false;blLogY:=false;   //chelles linaires (non logarithmiques)
   zoom:=100;               //agit sur l'cran seulement, pas sur l'imprimante
   rbPointillesFins.Checked:=true;StyleGrille:=sgPointillesFins;DessinerGrille;

   udLargeur.Position:=180;
   udHauteur.Position:=130;
   udMargeGauche.Position:=15;
   udMargeHaute.Position:=15;
   udPosAxeX.Position:=65;
   udPosAxeY.Position:=90;
   udUx.Position:=10;
   udUy.Position:=10;
   Ux:=1;edUniteX.Text:='1';                    //unit de graduation en X
   Uy:=1;edUniteY.Text:='1';                    //unit de graduation en Y
   FormatUx:=1;              //graduations entires en X
   FormatUy:=1;              //graduations entires en Y
   TMin:=-pi;edTMin.Text:='-pi';
   TMax:=pi;edTMax.Text:='pi';
   NbT:=400;ednbT.Text:='400';
   OrdonneeAxeX:=0;edOrigineAxeX.Text:='0';          //l'quation de l'axe des X est y=0
   AbscisseAxeY:=0;edOrigineAxeY.Text:='0';          //l'quation de l'axe des Y est x=0
   dx:=1;dy:=1;              //demi-longueur des traits de graduation sur les axes en mm
   LMX:=50;LMY:=50;          //Longueur des modules = 50 mm (chelles logarithmiques)

   clCadre:=clSilver;//$00DDDDDD;       //gris trs clair
   clFond:=clWhite;
   clAxes:=clBlack;
   clGrille:=8388736;    //mauve fonc
   nTexte:=0;nPoint:=-1;blDeplacePoint:=false;
   with PoliceTextes do
   begin
      name:='Times New Roman';
      size:=12;
      style:=[fsItalic];
      color:=clBlack;
   end;
   with PoliceGraduations do
   begin
      name:='Courier New';
      size:=10;
      style:=[];
      color:=clBlack;
   end;
   RayonPointD_arret:=0.3;
   NomAxeOx:='x';NomAxeOy:='y';
   nbChiffresSignificatifsX:=4;
   nbChiffresSignificatifsY:=4;
   DiametrePoints:=10;
   LongueurTirets:=20;
   tpc:=5;            //taille des petits carreaux
end;

procedure TfmPreferences.Edit1Change(Sender: TObject);
begin
   edEpaisseurFonctions.Text:=inttostr(udEpaisseurFonctions.position div 10)+','+inttostr(udEpaisseurFonctions.position mod 10)+' mm';
   ApercuFonctions.Picture.Assign(fmDessin.ApercuLigne(udEpaisseurFonctions.position,clblack));
end;

procedure TfmPreferences.Edit2Change(Sender: TObject);
begin
   edEpaisseurCourbesParametrees.Text:=inttostr(udEpaisseurCourbesParametrees.position div 10)+','
                                      +inttostr(udEpaisseurCourbesParametrees.position mod 10)+' mm';
   ApercuParametrees.Picture.Assign(fmDessin.ApercuLigne(udEpaisseurCourbesParametrees.position,clblack));
end;

procedure TfmPreferences.Edit3Change(Sender: TObject);
begin
   edEpaisseurDroites.Text:=inttostr(udEpaisseurDroites.position div 10)+','+inttostr(udEpaisseurDroites.position mod 10)+' mm';
	ApercuDroites.Picture.Assign(fmDessin.ApercuLigne(udEpaisseurDroites.position,clblack));


end;

procedure TfmPreferences.Edit4Change(Sender: TObject);
begin
   edEpaisseurTangentes.Text:=inttostr(udEpaisseurTangentes.position div 10)+','+inttostr(udEpaisseurTangentes.position mod 10)+' mm';

end;

procedure TfmPreferences.Edit5Change(Sender: TObject);
begin
   edEpaisseurNormales.Text:=inttostr(udEpaisseurNormales.position div 10)+','+inttostr(udEpaisseurNormales.position mod 10)+' mm';

end;

procedure TfmPreferences.Edit6Change(Sender: TObject);
begin
   edEpaisseurFleches.Text:=inttostr(udEpaisseurFleches.position div 10)+','+inttostr(udEpaisseurFleches.position mod 10)+' mm';
end;

procedure TfmPreferences.Edit7Change(Sender: TObject);
begin
   edEpaisseurAxes.Text:=inttostr(udEpaisseurAxes.position div 10)+','+inttostr(udEpaisseurAxes.position mod 10)+' mm';
end;

procedure TfmPreferences.btnAideClick(Sender: TObject);
begin
   Aide(87);
end;

end.
