unit uRapporteur;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls;

type
  TfmRapporteur = class(TForm)
    Label1: TLabel;
    edRayon: TEdit;
    udRayon: TUpDown;
    btOK: TButton;
    btAnnuler: TButton;
    cbDessiner: TCheckBox;
    ColorDialog1: TColorDialog;
    GroupBox1: TGroupBox;
    Label2: TLabel;
    Label3: TLabel;
    Label5: TLabel;
    pnCouleurGraduations: TPanel;
    pnCouleurQuadrillage: TPanel;
    pnCouleurAnglesRemarquables: TPanel;
    GroupBox2: TGroupBox;
    cbDegres: TCheckBox;
    cbRadians: TCheckBox;
    cbQuadrillage: TCheckBox;
    cbValeursRemarquables: TCheckBox;
    cbRepere: TCheckBox;
    btAide: TButton;
    procedure pnCouleurGraduationsClick(Sender: TObject);
    procedure pnCouleurQuadrillageClick(Sender: TObject);
    procedure pnCouleurAnglesRemarquablesClick(Sender: TObject);
    procedure ColorDialog1Show(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btAideClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  fmRapporteur: TfmRapporteur;

implementation

uses uDessin;

{$R *.dfm}

procedure TfmRapporteur.pnCouleurGraduationsClick(Sender: TObject);
begin
   ColorDialog1.Color:=pnCouleurGraduations.Color;
   ColorDialog1.Tag:=1;
   if ColorDialog1.Execute then pnCouleurGraduations.Color:=ColorDialog1.Color;
end;

procedure TfmRapporteur.pnCouleurQuadrillageClick(Sender: TObject);
begin
   ColorDialog1.Color:=pnCouleurQuadrillage.Color;
   ColorDialog1.Tag:=2;
   if ColorDialog1.Execute then pnCouleurQuadrillage.Color:=ColorDialog1.Color;
end;

procedure TfmRapporteur.pnCouleurAnglesRemarquablesClick(Sender: TObject);
begin
   ColorDialog1.Color:=pnCouleurAnglesRemarquables.Color;
   ColorDialog1.Tag:=3;
   if ColorDialog1.Execute then pnCouleurAnglesRemarquables.Color:=ColorDialog1.Color;
end;

procedure TfmRapporteur.ColorDialog1Show(Sender: TObject);
var titleColorDlg : PChar;
begin
   case ColorDialog1.Tag of
     1 : titleColorDlg := Pchar('Couleur des graduations');
     2 : titleColorDlg := Pchar('Couleur du quadrillage');
     3 : titleColorDlg := Pchar('Couleur des angles remarquables');
    end;
   SendMessage(ColorDialog1.Handle, WM_SetText, 0, Integer(titleColorDlg));
end;

procedure TfmRapporteur.FormShow(Sender: TObject);
begin
   cbDessiner.Checked:=true;
end;

procedure TfmRapporteur.btAideClick(Sender: TObject);
begin
   Aide(86);
end;

end.
