unit uSuite;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, Grids, ExtCtrls, ColorGrd, Menus, printers, shellAPI;

type
  TfmSuites = class(TForm)
    rgTypeSuite: TGroupBox;
    rbF: TRadioButton;
    lblFn: TLabel;
    Label2: TLabel;
    lblFun: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    rbFun: TRadioButton;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    edNom: TEdit;
    Label5: TLabel;
    edIndiceDepart: TEdit;
    udIndiceDepart: TUpDown;
    Label6: TLabel;
    edF: TEdit;
    lblPremierTerme: TLabel;
    edPremierTerme: TEdit;
    GroupBox2: TGroupBox;
    rgEpaisseurCourbe: TRadioGroup;
    rgStyleCourbe: TRadioGroup;
    cgCouleurCourbe: TColorGrid;
    Label7: TLabel;
    GroupBox3: TGroupBox;
    rgEpaisseurSuite: TRadioGroup;
    cgCouleurSuite: TColorGrid;
    Label8: TLabel;
    rgStyleSuite: TRadioGroup;
    cbDessinerSuite: TCheckBox;
    cbAfficherTermes: TCheckBox;
    cbDessinerCourbe: TCheckBox;
    btEffacerTout: TButton;
    btOK: TButton;
    pmSuites: TPopupMenu;
    mnCouperSuites: TMenuItem;
    mnCopierSuites: TMenuItem;
    mnCollerSuites: TMenuItem;
    N1: TMenuItem;
    mnImprimerSuites: TMenuItem;
    gbStylePoints: TGroupBox;
    cbAfficherPointsSur2Axes: TCheckBox;
    edVitesse: TEdit;
    udVitesse: TUpDown;
    Label15: TLabel;
    asgSuite: TStringGrid;
    udNbTermes: TUpDown;
    edNbTermes: TEdit;
    Label16: TLabel;
    btnAide: TButton;
    Image1: TImage;
    Image2: TImage;
    rbPoint: TRadioButton;
    rbPlus: TRadioButton;
    rbCroix: TRadioButton;
    rbEtoile: TRadioButton;
    rbCarre: TRadioButton;
    rbLosange: TRadioButton;
    rbAucuneMarque: TRadioButton;
    rbRond: TRadioButton;
    rbCarre2: TRadioButton;
    rbLosange2: TRadioButton;
    procedure rbFClick(Sender: TObject);
    procedure rbFunClick(Sender: TObject);
    procedure lblFnClick(Sender: TObject);
    procedure lblFunClick(Sender: TObject);
    procedure Label4Click(Sender: TObject);
    procedure Label3Click(Sender: TObject);
    procedure Label2Click(Sender: TObject);
    procedure edIndiceDepartChange(Sender: TObject);
    procedure edNomChange(Sender: TObject);
    procedure edPremierTermeChange(Sender: TObject);
    procedure btEffacerToutClick(Sender: TObject);
    procedure edPremierTermeKeyPress(Sender: TObject; var Key: Char);
    procedure edFKeyPress(Sender: TObject; var Key: Char);
    procedure edFExit(Sender: TObject);
    procedure mnCouperSuitesClick(Sender: TObject);
    procedure mnCopierSuitesClick(Sender: TObject);
    procedure mnCollerSuitesClick(Sender: TObject);
    procedure mnImprimerSuitesClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
    procedure asgSuiteDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure btnAideClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    Procedure Calculs;
  end;



var
  fmSuites: TfmSuites;
  SelectionComplete : boolean;

implementation
uses uFonctions, uDessin;
{$R *.DFM}

Procedure TfmSuites.Calculs;
var chF : string;
    erreur,i,i0 : byte;
    u : real;
    Stop : boolean;
begin
   fmSuites.asgSuite.cells[1,0]:=fmSuites.edNom.text;
   if fmSuites.edF.Text='' then exit;
   chF:=Traduction(fmSuites.edF.text,erreur);
   if erreur>0 then exit;
   Stop:=false;
   u:=0; //initialisation bidon
   i0:=fmSuites.udIndiceDepart.Position;
   if fmSuites.rbFun.Checked then               //suite rcurrente de type u_n = f(u_n-1)
   begin
      try
         u:=StrToFloat(fmSuites.edPremierTerme.text);
      except
         u:=0;
      end;
      fmSuites.asgSuite.cells[1,1]:=FloatToStrF(u,ffGeneral,6,6);
   end;
   for i:=i0 to i0+fmSuites.asgSuite.rowcount-2 do
   begin
      fmSuites.asgSuite.cells[0,i-i0+1]:=IntToStr(i);
      if fmSuites.rbF.Checked then
      begin
         ok:=true;
         u:=f(chF,i);
         if not ok then stop:=true;
         if ok and not Stop then fmSuites.asgSuite.cells[1,i-i0+1]:=FloatToStrF(u,ffGeneral,6,6)
                            else fmSuites.asgSuite.cells[1,i-i0+1]:='';
      end
      else if i>i0 then
      begin
         try
         ok:=true;
         u:=f(chF,u);
         if not ok then stop:=true;
         if ok and not stop then fmSuites.asgSuite.cells[1,i-i0+1]:=FloatToStrF(u,ffGeneral,6,6)
                            else fmSuites.asgSuite.cells[1,i-i0+1]:='';
         except
            fmSuites.asgSuite.cells[1,i-i0+1]:='';
         end;
      end;
   end;
end;

procedure TfmSuites.rbFClick(Sender: TObject);
begin
   lblPremierTerme.Enabled:=false;
   edPremierTerme.Color:=clBtnFace;
   cbAfficherPointsSur2Axes.Caption:='Afficher les points sur l''axe Oy';
   Calculs;
end;

procedure TfmSuites.rbFunClick(Sender: TObject);
begin
   lblPremierTerme.Enabled:=true;
   edPremierTerme.Color:=clWindow;
   edPremierTerme.Enabled:=true;
   cbAfficherPointsSur2Axes.Caption:='Afficher les points sur les 2 axes';
   Calculs;
end;

procedure TfmSuites.lblFnClick(Sender: TObject);
begin
   rbF.Checked:=true;
end;

procedure TfmSuites.lblFunClick(Sender: TObject);
begin
   rbFun.Checked:=true;
end;

procedure TfmSuites.Label4Click(Sender: TObject);
begin
   rbFun.Checked:=true;
end;

procedure TfmSuites.Label3Click(Sender: TObject);
begin
   rbFun.Checked:=true;
end;

procedure TfmSuites.Label2Click(Sender: TObject);
begin
   rbF.Checked:=true;
end;

procedure TfmSuites.edIndiceDepartChange(Sender: TObject);
begin
   calculs;
end;

procedure TfmSuites.edNomChange(Sender: TObject);
begin
   Calculs;
end;

procedure TfmSuites.edPremierTermeChange(Sender: TObject);
begin
   Calculs;
end;

procedure TfmSuites.btEffacerToutClick(Sender: TObject);
begin
   edF.Text:='';
   ClearNormalCells(asgSuite);
   udIndiceDepart.Position:=0;
   edPremierTerme.Text:='';
end;

procedure TfmSuites.edPremierTermeKeyPress(Sender: TObject; var Key: Char);
begin
   if (key='.')or(key=',')then key:=DecimalSeparator;
end;

procedure TfmSuites.edFKeyPress(Sender: TObject; var Key: Char);
begin
   if key=chr(13) then Calculs;
end;

procedure TfmSuites.edFExit(Sender: TObject);
begin
   Calculs;
end;

procedure TfmSuites.mnCouperSuitesClick(Sender: TObject);
var i : integer;
begin
   StringGridCopyToClipBoard(asgSuite,0,200,0,1);
   for i:=1 to 199 do asgSuite.Cells[1,i]:='';
end;

procedure TfmSuites.mnCopierSuitesClick(Sender: TObject);
//copier toute la grille (y compris la premire ligne et la premire colonne) dans le presse-papier
begin
   StringGridCopyToClipBoard(asgSuite,0,200,0,1);
end;

procedure TfmSuites.mnCollerSuitesClick(Sender: TObject);
//pour coller, en provenance d'un tableur, dans la colonne u (col=1) les termes d'une suite
begin
   StringGridPasteFromClipBoard(asgSuite,1,1);
end;

function px(mm:real):longint; //fonction locale qui retourne la position horizontale sur l'imprimante
  begin
     px:=round(resX/25.4*mm);
  end;
function py(mm:real):longint; //fonction locale qui retourne la position verticale sur l'imprimante
  begin
     py:=round(resY/25.4*mm);
  end;

procedure TfmSuites.mnImprimerSuitesClick(Sender: TObject);
var i,j,n : integer;
begin
   CanvasSortie:=Printer.canvas;blEcran:=false;
   Printer.BeginDoc;
   with canvasSortie do
   begin
      n:=15;
      while (asgSuite.Cells[1,n]='') do dec(n);
      Font.name:='Courier New';Font.size:=10;
      for i:=0 to n do for j:=0 to asgSuite.ColCount-1 do
      begin
         if i*j=0 then
         begin
            Brush.Style:=bsSolid;
            Brush.Color:=clSilver;
            Font.Style:=[fsBold];
         end
         else
         begin
            brush.Style:=bsClear;
            Font.Style:=[];
         end;
         Rectangle(px(j*20+5),py(i*6+15),px(j*20+25),py(i*6+21));
         TextOut(px(j*20+15)-TextWidth(asgSuite.cells[j,i])div 2,
                 py(i*6+18)-TextHeight(asgSuite.cells[j,i])div 2,
                 asgSuite.cells[j,i]);
      end;
   end;
   printer.EndDoc;
   CanvasSortie:=fmDessin.Image.Canvas;blEcran:=true;
end;

procedure TfmSuites.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   if key=vk_Escape then close;
end;

procedure TfmSuites.FormCreate(Sender: TObject);
var i : integer;
begin
   with asgSuite do
   begin
      for i:=0 to RowCount-1 do if i>0 then cells[0,i]:=inttostr(i);
      ColWidths[0]:=30;
      ColWidths[1]:=70;
      cells[0,0]:='n';
      calculs;
   end;
   if rbFun.Checked then cbAfficherPointsSur2Axes.Caption:='Afficher les points sur les 2 axes'
                    else cbAfficherPointsSur2Axes.Caption:='Afficher les points sur l''axe Oy';
end;

procedure TfmSuites.asgSuiteDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
var Texte : string;
begin
   Texte:=asgSuite.Cells[ACol,ARow];
   if ACol*ARow=0 then GrilleCouleur(asgSuite,Rect,Texte,taCenter,clBtnFace,clBlack,[])
                  else GrilleCouleur(asgSuite,Rect,Texte,taCenter,clWindow,clBlack,[]);
end;

procedure TfmSuites.btnAideClick(Sender: TObject);
begin
   Aide(74);
end;

end.
