unit uTableauVarSgn;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ToolWin, ComCtrls, ExtCtrls, ImgList,Contnrs,
  GifImg, StrUtils, OleCtrls, shellAPI;

type
  TfmTableauVarSgn = class(TForm)
    btEffacerTout: TButton;
    btAnnuler: TButton;
    btOK: TButton;
    ControlBar1: TControlBar;
    ToolBar1: TToolBar;                      
    tbPinf: TToolButton;
    tbMinf: TToolButton;
    tbFormule: TToolButton;
    tbFiletVertical: TToolButton;
    tbDoubleFilet: TToolButton;
    tbFiletZero: TToolButton;
    tbFlecheAsc: TToolButton;
    tbFlecheDesc: TToolButton;
    tbFlecheHorz: TToolButton;
    tbNouvelleLigne: TToolButton;
    tbSupprimerLigne: TToolButton;
    tbNouvelleColonne: TToolButton;
    tbSupprimerColonne: TToolButton;
    ImageTableau: TImage;
    Label1: TLabel;
    ImageList1: TImageList;
    Memo1: TMemo;
    tbHachures: TToolButton;
    Label2: TLabel;
    ButtonApercu: TButton;
    ButtonExVar3: TButton;
    ButtonExVar4: TButton;
    ButtonExVar7: TButton;
    ButtonExVar8: TButton;
    ButtonExSgn1: TButton;
    ButtonExAbs1: TButton;
    GroupBox1: TGroupBox;
    CheckBox1: TCheckBox;
    ButtonExVar1: TButton;
    CheckBox2: TCheckBox;
    Memo2: TMemo;
    ButtonExVar2: TButton;
    ButtonExVar5: TButton;
    ButtonExVar6: TButton;
    Label3: TLabel;
    Label4: TLabel;
    bbCouleurTraits: TBitBtn;
    cdCouleurTraits: TColorDialog;
    bbCouleurTextes: TBitBtn;
    bbAide: TBitBtn;
    procedure FormShow(Sender: TObject);  // insre espaces et retours  a ligne pour amliorer lisibilit
    procedure EffacerDessin;
    procedure Apercu;
    procedure ImageTableauVarSgn(ChaineTableau:string;resolution:integer;DessinTableau:TBitMap);
    procedure AfficheCode(ChaineTableau:string);
    procedure SupprimeFormattage(LignesTableau:TStringList;var ChaineTableau:string);
    procedure Formatte(ChaineTableau:string;LignesTableau:TStringList);
    procedure DecodeItemsTableau(ChaineTableau:string;ItemsTableau:TObjectList);
    procedure ButtonApercuClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ButtonExVar4Click(Sender: TObject);
    procedure ButtonExVar3Click(Sender: TObject);
    procedure ButtonExVar7Click(Sender: TObject);
    procedure ButtonExVar8Click(Sender: TObject);
    procedure ButtonExSgn1Click(Sender: TObject);
    procedure ButtonExAbs1Click(Sender: TObject);
    procedure btEffacerToutClick(Sender: TObject);
    procedure tbPinfClick(Sender: TObject);
    procedure tbMinfClick(Sender: TObject);
    procedure tbFormuleClick(Sender: TObject);
    procedure tbHachuresClick(Sender: TObject);
    procedure tbFiletVerticalClick(Sender: TObject);
    procedure tbDoubleFiletClick(Sender: TObject);
    procedure tbFiletZeroClick(Sender: TObject);
    procedure tbFlecheAscClick(Sender: TObject);
    procedure tbFlecheDescClick(Sender: TObject);
    procedure tbFlecheHorzClick(Sender: TObject);
    procedure tbNouvelleLigneClick(Sender: TObject);
    procedure tbSupprimerLigneClick(Sender: TObject);
    procedure tbNouvelleColonneClick(Sender: TObject);
    procedure tbSupprimerColonneClick(Sender: TObject);
    function DenombreColonnes(chaine:string):integer;
    procedure ButtonExVar1Click(Sender: TObject);
    procedure Memo1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ButtonExVar2Click(Sender: TObject);
    procedure ButtonExVar5Click(Sender: TObject);
    procedure ButtonExVar6Click(Sender: TObject);
    procedure Label4Click(Sender: TObject);
    procedure bbCouleurTraitsClick(Sender: TObject);
    procedure bbCouleurTextesClick(Sender: TObject);
    procedure bbAideClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  	fmTableauVarSgn       : TfmTableauVarSgn;
  	NbLignes,NbColonnes   : integer;
	CodeTableau           : string;

implementation

uses uDessin, uCouleurs;

{$R *.dfm}


Procedure TfmTableauVarSgn.EffacerDessin;
begin
   with fmTableauVarSgn.ImageTableau.Canvas do
   begin
      brush.style:=bsSolid;
      brush.Color:=clWhite;
      Rectangle(0,0,fmTableauVarSgn.ImageTableau.width,fmTableauVarSgn.ImageTableau.height);
      brush.style:=bsClear;
   end;
end;

procedure TfmTableauVarSgn.Apercu;
var
   ChaineTableau: string;
   LignesTableau:TStringList;
   GrosBMP,PetitBMP: TBitmap;
   x,y:integer;
begin
LignesTableau:=TStringList.Create;
LignesTableau.Assign(memo1.lines);
if LignesTableau.count>0
	then begin
	GrosBMP:= TBitmap.create;
	GrosBMP.PixelFormat:=pf24bit;
	PetitBMP:= TBitmap.create;
	PetitBMP.PixelFormat:=pf24bit;
	SupprimeFormattage(LignesTableau,ChaineTableau);

   if blAntiCrenelage
   	then begin
      ImageTableauVarSgn(ChaineTableau,ResEX*4,GrosBMP);
      PetitBMP.Width:=GrosBMP.Width div 4;
      PetitBMP.Height:=GrosBMP.Height div 4;
      fmdessin.FastAntiAliasPicture(GrosBMP,PetitBMP)
      end else begin
      ImageTableauVarSgn(ChaineTableau,ResEX,GrosBMP);
      PetitBMP.Assign(GrosBMP);
      end;
	x:=(ImageTableau.width-PetitBMP.width)div 2;
	y:=(ImageTableau.height-PetitBMP.Height)div 2;
	ImageTableau.Canvas.Draw(x,y,PetitBMP);
	PetitBMP.Free;
	GrosBMP.Free;
   end;
LignesTableau.Free;
end;

function TfmTableauVarSgn.DenombreColonnes(chaine:string):integer;
var
	i,c,n:integer;
begin
c:=0;
n:=length(chaine);
for i:=1 to n
	do begin
   if chaine[i]=']' then inc(c);
   end;
   Result:=c;
end;

procedure TfmTableauVarSgn.DecodeItemsTableau(ChaineTableau:string;ItemsTableau:TObjectList);
var
	car1,car2,i,j,l,n   :integer;
   Ligne               :TStringList;
   chaine              :String;
begin
ItemsTableau.Clear;
Ligne:=TStringlist.Create;
ChaineTableau:=ChaineTableau+'\\';
l:=length(ChaineTableau);
car1:=1;
Repeat  //dcompose en lignes
	car2:=posEx(']\\',ChaineTableau,car1);
	Ligne.Add(copy(ChaineTableau,car1,car2-car1+1));
   car1:=car2+3;
	until car1>l;
if Ligne.count<2 then exit;
n:=0;
for i:=0 to Ligne.Count-1//extraction de tous les items
	do begin
   Chaine:=Ligne[i];
   l:=length(Chaine);
   if Chaine[l]<>']' then exit;
   ItemsTableau.add(TStringList.Create); //ajoute une ligne
   car1:=2;car2:=2;
   while car2<=l
		do	begin
 		while not(Chaine[car2] in ['[',':',']']) do inc(car2) ;
      TStringList(ItemsTableau[i]).add(copy(Chaine,car1,car2-car1));
      j:=length(chaine)+i;
      car1:=car2+1;
      car2:=car1;
  		end;
   car1:=TStringList(ItemsTableau[i]).count;
   if n>0  //vrifie que toutes les lignes ont le mme nombre d'items
   	then begin
      if TStringList(ItemsTableau[i]).count<>TStringList(ItemsTableau[i-1]).count then exit;
      end else n:=1;
   end;
Ligne.Free;
end;

procedure TfmTableauVarSgn.AfficheCode(ChaineTableau:string);
var
	LignesTableau:TStringList;
begin
LignesTableau:=TStringList.Create;
Formatte(ChaineTableau,LignesTableau);
Memo1.Lines.Assign(LignesTableau);
LignesTableau.Free;
end;

procedure TfmTableauVarSgn.ImageTableauVarSgn(ChaineTableau:string;resolution:integer;DessinTableau:TBitMap);

var
	Argument                                    : TObjectList;
   Formule                                     : Array of Array of TBitmap;
   ChaineLaTex,Raz,FichierGif                  : string;
   i,j,jj,jj1,jj2,k,l,m,c,cc,d,w,w1,w2,h,h1,h2,wTot,hTot,x,y,x1,y1,x2,y2,xf1,xf2,yf1,yf2,xc1,xc2,yc1,yc2,
   PetiteMarge, GrandeMarge,LargeurFleche,Res,wTrait,wTraitFin,
   SensVar,hLignes,hLigneVar,wCols,wColTitres  : integer;
   PenteFleche                                 : Real;
   GIF                                         : TGifImage;
   BMP,BMP_HR                                  : TBitMap;
   LignesVar                                   : TStringList;
   Coul                                        : TColor;

	 FFrequency    : Int64    ;    // Frquence du compteur hautes performances.
    FStart, FStop: Int64    ;    // Valeurs du compteur au dbut et  la fin du chrono.
    FElapsed      : Extended ;    // Dure finale, en secondes.
    tps,mn,s,ds,n  : integer;

   function IsLatex(chaine:string):boolean;
   begin // si la chaine n'est pas l'un des symboles rservs et n'est pas vide elle est rpute tre Latex
   Result:=True;
   if chaine='' then Result:=False;
   if chaine='//' then Result:=False;
   if chaine='/>' then Result:=False;
   if chaine='\>' then Result:=False;
   if chaine='_>' then Result:=False;
   if chaine='|' then Result:=False;
   if chaine='||' then Result:=False;
   if chaine='[' then Result:=False;
   if chaine=']' then Result:=False;
   if chaine=':' then Result:=False;
   if chaine='\\' then Result:=False;
   end;
   procedure CaractereDevantMoins(var chaine:string);
   var i,n  : integer;
   begin  // pour corriger ce qui semble tre un bug de mimetex: une expression ne doit pas commencer par un -
   n:=length(chaine);
   if n=0 then exit;
   if chaine[1]='-'
      then begin
      insert('\hspace{0}',chaine,1);
      end;
   end;
   procedure JolieFleche(x1,y1,x2,y2:integer); //flche de (x1,y1) vers (x2,y2)
   var
   	a,b,x3,y3,x4,y4,x5,y5,x6,y6: integer;
      k:real;
   begin
   k:=1.3;     //taille de l'extrmit de la flche en mm1.36
   a:=x2-x1;
   b:=y2-y1;
   x3:=x2+Round(k*res*(a*(-1.36)-b*(0.47))/(sqrt(a*a+b*b)*25.4));
   y3:=y2+Round(k*res*(b*(-1.36)+a*(0.47))/(sqrt(a*a+b*b)*25.4));
   x4:=x2+Round(k*res*(a*(-1.05)-b*(0.26))/(sqrt(a*a+b*b)*25.4));
   y4:=y2+Round(k*res*(b*(-1.05)+a*(0.26))/(sqrt(a*a+b*b)*25.4));
   x5:=x2+Round(k*res*(a*(-1.05)-b*(-0.26))/(sqrt(a*a+b*b)*25.4));
   y5:=y2+Round(k*res*(b*(-1.05)+a*(-0.26))/(sqrt(a*a+b*b)*25.4));
   x6:=x2+Round(k*res*(a*(-1.36)-b*(-0.47))/(sqrt(a*a+b*b)*25.4));
   y6:=y2+Round(k*res*(b*(-1.36)+a*(-0.47))/(sqrt(a*a+b*b)*25.4));
   With DessinTableau.Canvas
   	do begin
      Pen.width:=wTrait;
      Moveto(x1,y1);
      Lineto(x2,y2);
      Moveto(x3,y3);
      Lineto(x4,y4);
      lineto(x2,y2);
      Lineto(x5,y5);
      Lineto(x6,y6);
      Lineto(x5,y5);
      end;
   end;
   procedure Hachures(x1,y1,x2,y2:integer); //hachures dans le rectangle dfini par (x1,y1) et (x2,y2)
   var a,b,x3,y3,x4,y4,xx1,yy1,xx2,yy2: integer;
   begin
   a:=Round(res*(0.7)/25.4);    //dcalage de 0,7 mm avant la premire hachure
   b:=Round(res*(2.0)/25.4);    //espacement de 2 mm en abscisse
   x3:=x1+a;
   With DessinTableau.Canvas
   	do begin
      Pen.width:=wTrait;
   	While x3< x2+y2-y1
   		do begin
      	y3:=y1+x3-x1; //hachures inclines  +Pi/4
      	x4:=x3-y2+y1;
      	y4:=y1-x2+x3;
      	if y3<y2
      		then begin
         	xx1:=x1;
         	yy1:=y3;
         	end else begin
         	xx1:=x4;
         	yy1:=y2;
         	end;
      	if x3<x2
      		then begin
         	xx2:=x3;
         	yy2:=y1;
         	end else begin
         	xx2:=x2;
         	yy2:=y4;
         	end;
      	Moveto(xx1,yy1);
      	Lineto(xx2,yy2);
         x3:=x3+b;
      	end;
      end;
   end;
   Function ZoneHachuree(i,jj:integer):boolean;
   begin
   Result:=False;
   if (TStringList(Argument[i])[4*jj]='//') or (TStringList(Argument[i])[4*jj+1]='//') or(TStringList(Argument[i])[4*jj+2]='//')
      then Result:=True;
   end;
   Function FinHachures(i,jj:integer):boolean;
   begin
   Result:=False;
   if (Zonehachuree(i,jj)) and (i=l-1)
   	then begin
      Result:= True;
      Exit;
      end;
   if (Zonehachuree(i,jj))	and not (Zonehachuree(i+1,jj))
      then Result:=True;
   end;
   function EstUneFleche(chaine:string):boolean;
   begin
   if (chaine='\>') or (chaine='_>') or (chaine='/>')
   	then Result:= True else Result:=False;
   end;
   function SensFleche(fleche:string):integer;// donne 1 pour croissant, -1 pour dcroissant, 0 pour constant
   begin
   if fleche='/>' then Result:=1;
   if fleche='\>' then Result:=-1;
   if  fleche='_>' then Result:=0;
   end;
   function Definie(i,jj:integer):boolean;  //dit si la case ne contient pas le symbole "//"
   begin
   If (TStringList(Argument[i])[4*jj]='//')
   	or (TStringList(Argument[i])[4*jj+1]='//')
      or (TStringList(Argument[i])[4*jj+2]='//')
      then Result:=False else Result:=True;
   end;
   function DebutFleche(i,jj:integer):boolean;//dit si case contient le dbut d'une fleche
   var
   	s1,s2: string;
   begin
   Result:=False;
   If (jj<2) and definie(i,jj)       //si dbut ligne et fonction dfinie dans cette case
   	then begin
      Result:=True;
      exit;
      end;
   if Not Definie(i,jj-1) //si fonction non dfinie dans case prcdente
   	then begin
      Result:=True;
      exit;
      end;
   if (TStringList(Argument[i])[4*jj-1]='||') and definie(i,jj) //si non dfinie juste avant
   	then begin
      Result:=True;
      exit;
      end;
   s1:=TStringList(Argument[i])[4*jj-3];     //flche de la case prcdente
   s2:=TStringList(Argument[i])[4*jj+1];     //flche de la case prsente
   if EstUneFleche(s1) and EstUneFleche(s2) and (s1<> s2)
   	 then Result:=True;
   end;
   function FinFleche(i,jj:integer):boolean;  //dit si case contient l'extrmit d'une fleche
   var
   	s1,s2: string;
   begin
   Result:=False;
   If jj=cc-1                                  //si fin ligne
   	then begin
      Result:=True;
      exit;
      end;
   if not definie(i,jj+1)  //si fonction non dfinie dans case suivante
   	then begin
      Result:=True;
      Exit;
      end;
   if (TStringList(Argument[i])[4*jj+3]='||') and definie(i,jj) //si dfinie dans cette case et non dfinie juste aprs
   	then begin
      Result:=True;
      exit;
      end;
   s1:=TStringList(Argument[i])[4*jj+1];     //flche de la case prsente
   s2:=TStringList(Argument[i])[4*jj+5];     //flche de la case suivante
   if EstUneFleche(s1) and EstUneFleche(s2) and (s1<> s2)
   	then Result:=True;
   end;
   function PositionPlateau(i,jj:integer):integer;//dit si le plateau de la case (i,jj) est haut (+1) bas (-1) ou mdian (0)
   var
   	s: string;
   begin
   Result:=0;  //mdian par dfaut
   If jj<2	then  exit;  //si dbut ligne
   if TStringList(Argument[i])[4*jj-3]='//' then exit;//si fonction non dfinie dans case prcdente
   if TStringList(Argument[i])[4*jj-1]='||' then exit; //si non dfinie juste avant
   s:=TStringList(Argument[i])[4*jj-3];     //flche de la case prcdente
   Result:=SensFleche(s);
   end;

begin
Res:=resolution;
BMP:=TBitmap.create;
BMP_HR:=TBitmap.create;
GIF:=TGifImage.Create;
Argument:=TObjectList.Create;
LignesVar:=TStringList.Create;
LignesVar.Duplicates:=DupIgnore;
LignesVar.Sorted:=True;
SetLength(Formule, 0, 0);
Raz:='2$ \black \normalsize 1';
FichierGif:='EquationLaTeX.gif';
//wTrait:=Round(0.14*Res/25.4);
//wTraitFin:=Round(0.07*Res/25.4);
if checkbox2.Checked                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            
	then wtrait:=Round(0.33*Res/25.4)
	else wtrait:=Round(0.22*Res/25.4);
If wTrait=0 then wTrait:=1;
if checkbox2.Checked
	then wTraitFin:=Round(0.17*Res/25.4)
	else wTraitFin:=Round(0.11*Res/25.4);
If wTraitFin=0 then wTraitFin:=1;
PetiteMarge:=Round(0.7*Res/25.4);
If PetiteMarge=0 then PetiteMarge:=1;
GrandeMarge:=Round(1.4*Res/25.4);
If GrandeMarge<2 then GrandeMarge:=2;
LargeurFleche:=Round(10.0*Res/25.4);
hLignes:=Round(5.0*Res/25.4);  //hauteur minimale des lignes 5 mm
hLigneVar:=Round(5.0*Res/25.4);
wCols:=Round(7.0*Res/25.4);    //largeur minimale des colonnes 7 mm
wColTitres:=Round(7.0*Res/25.4);
// fin initialisation
DecodeItemsTableau(ChaineTableau, Argument);
l:=Argument.Count;                 //nombre de lignes
c:=TStringList(Argument[0]).Count; //nombre de colonnes
cc:=(c+1) div 4;                   //nombre de cases par ligne
SetLength(Formule, l, c);
screen.cursor:=crHourGlass;
// Initialisation du compteur hautes performances, et dbut du chronomtrage.
   If Not QueryPerformanceFrequency(FFrequency) Then
   Raise Exception.Create('Pas de compteur hautes performances.');
   QueryPerformanceCounter(FStart) ;
// Insrer ici l'opration  chronomtrer, ou un appel de fonction.
For i:=0 to l-1    //cre images formules
	do begin
   For j:=0 to c-1
   	do begin
      ChaineLaTex:=TStringList(Argument[i])[j];
      if (ChaineLatex='/>') or(ChaineLatex='\>') or(ChaineLatex='_>')
      	then  LignesVar.Add(inttostr(i));
      CaractereDevantMoins(ChaineLatex);
      if Length(ChaineLatex)>2
      	then begin
      	if (copy(ChaineLatex,1,2)='||') and(Islatex(copy(ChaineLatex,3,length(ChaineLatex)-2)))
      		then Delete(ChaineLatex,1,2);//double filet vertical au dbut
      	if (copy(ChaineLatex,length(ChaineLatex)-1,2)='||') and(Islatex(copy(ChaineLatex,1,length(ChaineLatex)-2)))
      		then Delete(ChaineLatex,length(ChaineLatex)-1,2); //double filet vertical  la fin
         end;
      if Length(ChaineLatex)>1
      	then begin
      	if (ChaineLatex[1]='|') and(Islatex(copy(ChaineLatex,2,length(ChaineLatex)-1)))
      		then Delete(ChaineLatex,1,1);//filet vertical au dbut
      	if (ChaineLatex[length(ChaineLatex)]='|')and(ChaineLatex[length(ChaineLatex)-1]<>'t') and(Islatex(copy(ChaineLatex,1,length(ChaineLatex)-1)))
      		then Delete(ChaineLatex,length(ChaineLatex),1); //filet vertical a la fin
         end;
      If IsLatex(ChaineLaTex)
      	then begin
         if ChaineLaTex[2]<>'$' then Insert('2$ ',ChaineLaTex,1);
         if (couleurs.numCouleur>1)and
            (pos('\black',ChaineLatex)=0)and
            (pos('\blue',ChaineLatex)=0)and
            (pos('\red',ChaineLatex)=0)and
            (pos('\green',ChaineLatex)=0)and
            (pos('\yellow',ChaineLatex)=0)and
            (pos('\cyan',ChaineLatex)=0)and
            (pos('\magenta',ChaineLatex)=0)and
            (pos('\white',ChaineLatex)=0)
            then Insert(Couleurs.CouleurLaTeX,ChaineLaTex,pos('$',ChaineLatex)+1);
         if blEcran and not blAntiCrenelage
            then begin
            CreateGifFromEq(pAnsiChar(AnsiString(Raz)), pAnsiChar(AnsiString(FichierGif)));
            CreateGifFromEq(pAnsiChar(AnsiString(ChaineLaTex)), pAnsiChar(AnsiString(FichierGif)))
            end else begin
            CreateGifFromEq_HR(pAnsiChar(AnsiString(Raz)), pAnsiChar(AnsiString(FichierGif)));
            CreateGifFromEq_HR(pAnsiChar(AnsiString(ChaineLaTex)), pAnsiChar(AnsiString(FichierGif)));
            end;
      	GIF.LoadFromFile(FichierGif);
      	BMP.Assign(GIF);
         Formule[i,j] := TBitmap.Create;
         If blEcran
            then Formule[i,j].Assign(BMP)
            Else begin
//            BMP_HR.Width:=(BMP.Width*ResX) div (4*ResEX); //car les polices de Mimetex_HR ont une rsolution 4
//            BMP_HR.Height:=(BMP.Height*ResX) div (4*ResEX);
            BMP_HR.Width:=(BMP.Width*ResX) div ResEX; //car les polices de Mimetex_HR ont une rsolution 4
            BMP_HR.Height:=(BMP.Height*ResX) div ResEX;
            BMP_HR.Canvas.StretchDraw(classes.Rect(0,0,BMP_HR.Width,BMP_HR.Height),BMP);
            Formule[i,j].Assign(BMP_HR)
            end;
         end;
      end;
   end;
   QueryPerformanceCounter(FStop) ;
   FElapsed :=(FStop-FStart)/FFrequency ; //Fin de chronomtrage, conversion du temps coul en secondes.
	tps:=round(FElapsed*1000);
// fin chrono
screen.cursor:=crDefault;
label1.Caption:=inttostr(tps)+' ms';
For i:=0 to l-1    // dtermination de la hauteur de toutes les lignes autres que celles de variations
	do begin        // et de la largeur des colonnes autres que celle des titres
   if LignesVar.IndexOf(inttostr(i))=-1 //si ce n'est pas une ligne de variations
   	then begin
      For jj:=0 to cc-1
      	do begin
         w:=0;
         For k:=0 to 3
         	do begin
            j:=4*jj+k;
            if j<c
            	then begin
   				if (Formule[i,j]<>Nil)
      				then begin
   					BMP.Assign(Formule[i,j]);
   					h:=BMP.Height+2*GrandeMarge;
   					if h>hLignes then hLignes :=h;
                  if k<3
                  	then w:=w+BMP.Width+2*GrandeMarge
                     else w:=w+BMP.Width div 2+GrandeMarge;
                  if w>wCols then wCols:=w;
               	end;
            	end;
   			end;
         end;
   	end;
   end;
For i:=0 to l-1    //dtermination de la largeur de la colonne des titres
	do begin
   for k:=0 to 2
   	do begin
   	if (Formule[i,k]<>Nil)
   		then begin
   		BMP.Assign(Formule[i,k]);
   		w:=BMP.Width+2*GrandeMarge;
   		if w>wColTitres then wColTitres :=w;
   		end;
      end;
   end;
For k:=0 to LignesVar.Count-1 // dtermination de la hauteur des lignes de variation
	do begin                   // et de la largeur des colonnes autres que celle des titres
   i:=strtoint(LignesVar[k]);
   For jj:=1 to cc-1
   	do begin
      w1:=GrandeMarge;
      w2:=GrandeMarge;
      h1:=PetiteMarge;
      h2:=PetiteMarge;
      d:=0;//total espacements centre formule-bordure
      if (Formule[i,4*jj-1]<>Nil)
   		then begin
   		BMP.Assign(Formule[i,4*jj-1]);
   		w1:=BMP.Width div 2;
         h1:=BMP.Height div 2;
         if DebutFleche(i,jj)
         	then h:=PetiteMarge+h1;
   		end;
      if (Formule[i,4*jj]<>Nil)
   		then begin
   		BMP.Assign(Formule[i,4*jj]);
   		w1:=BMP.Width div 2;
         h1:=BMP.Height div 2;
         d:= BMP.Width div 2+GrandeMarge;
         if DebutFleche(i,jj)
         	then h:=PetiteMarge+h1;
   		end;
      if (Formule[i,4*jj+2]<>Nil)
   		then begin
   		BMP.Assign(Formule[i,4*jj+2]);
   		w2:=BMP.Width div 2;
         h2:=BMP.Height div 2;
         d:= d+BMP.Width div 2+GrandeMarge;
         if FinFleche(i,jj)
         	then h:=h+PetiteMarge+h2;
   		end;
      if (jj<cc-1) and (Formule[i,4*jj+3]<>Nil)
   		then begin
   		BMP.Assign(Formule[i,4*jj+3]);
   		w2:=BMP.Width div 2;
         h2:=BMP.Height div 2;
         if FinFleche(i,jj)
         	then h:=h+PetiteMarge+h2;
   		end;
      w:=w1+Round(10.0*Res/25.4)+w2+d;
      if w>wCols then wCols:=w;
      h:=h+Round((w1+w2+10.0*Res/25.4)*0.5);
      if (FinFleche(i,jj))
      	then begin
         if (h>hLigneVar) then hLigneVar:=h;
         h:=0;
         end;

      end;
   end;
Htot:=(l-LignesVar.Count)*hLignes+hLigneVar*LignesVar.Count;
Wtot:=(cc-1)*wCols+wColTitres;
DessinTableau.Width:=wTot+Round(2*Res/25.4);//1 mm de marge tout autour du tableau
DessinTableau.Height:=hTot+Round(2*Res/25.4);
LargeurDessin_mm:=Round(DessinTableau.Width*25.4/Res)+4;
HauteurDessin_mm:=Round(DessinTableau.Height*25.4/Res)+6;
blCadre:=False;
y:=0;
With DessinTableau.Canvas
	do begin
	Brush.Color:=cdCouleurTraits.Color;
	Pen.Color:=Brush.Color;
   Pen.width:=wTrait;
	y:=hlignes;
	For i:=1 to l-1    // traits de sparation des lignes
		do begin
   	Moveto(0,y);
   	Lineto(wTot,y);
      if LignesVar.IndexOf(Inttostr(i))=-1 // si ce n'est pas une ligne de variations
      	then y:=y+hlignes
         else y:=y+hLigneVar;
   	end;
   Moveto(0,wTrait div 2);     //Cadre
   LineTo(wTot,wTrait div 2);
   LineTo(wTot,hTot);
   LineTo(0,hTot);
   LineTo(wTrait div 2,hTot);
   LineTo(wTrait div 2,0);     //fin du cadre
//   FrameRect(Classes.Rect(wTraitFin,wTraitFin,wTot,hTot));
      For jj:=1 to cc-1   //hachures
   	do begin
      x1:=wColTitres+(jj-1)*wCols;
      x2:=x1+wCols;
      y1:=hlignes;
      y2:=y1;
      For i:=1 to l-1
      	do begin
         if LignesVar.IndexOf(Inttostr(i))=-1 // si ce n'est pas une ligne de variations
      		then y2:=y2+hlignes
         	else y2:=y2+hLigneVar;
         if FinHachures(i,jj)
         	then  begin
            Hachures(x1,y1,x2,y2);
            y1:=y2;
            end;
         if not ZoneHachuree(i,jj) then y1:=y2;
         end;
      end;             //fin hachures

   y1:=0;
	For i:=0 to l-1
		do begin
      if LignesVar.IndexOf(Inttostr(i))=-1 // si ce n'est pas une ligne de variations
      	then y2:=y1+hlignes
         else y2:=y1+hLigneVar;
      jj:=0;           //colonne des titres
   	x1:=0;
      x2:=wColTitres;
      for k:=0 to 2
      	do begin
      	if Formule[i,k]<>Nil
      		then begin
         	BMP.Assign(Formule[i,k]);
            w:=BMP.Width;
            h:=BMP.Height;
            y:=(y1+y2-h) div 2;
            if k=0 then x:=x1+GrandeMarge;
            If k=1 then x:=(x1+x2-w) div 2;
            If k=2 then x:=(x2-GrandeMarge-w);
         	Draw(x,y,BMP);
         	end;
         end;         //fin colonne titres
      x1:=x2;
   	For jj:=1 to cc-1
   		do begin
         x2:=x1+wCols;
         ChaineLaTex:=TStringList(Argument[i])[4*jj-1];
         if (pos('|',ChaineLatex)>0) and (ChaineLatex<>'||')
         	then begin
            moveto(x1,y1);
            LineTo(x1,y2);
            end;
//         if ChaineLatex='||'
         if pos('||',ChaineLatex)>0
         	then begin
            coul:=Brush.Color;
            Brush.Color:=clWhite;
            FillRect(Classes.Rect(x1-PetiteMarge div 2,y1+1,x1+PetiteMarge div 2,y2-1));
            Brush.Color:=coul;
            moveto(x1-PetiteMarge div 2,y1);
            LineTo(x1-PetiteMarge div 2,y2);
            moveto(x1+PetiteMarge div 2,y1);
            LineTo(x1+PetiteMarge div 2,y2);
            end;
         ChaineLaTex:=TStringList(Argument[i])[4*jj];
//         if ChaineLatex='||'
         if pos('||',ChaineLatex)>0
         	then begin
            coul:=Brush.Color;
            Brush.Color:=clWhite;
            FillRect(Classes.Rect(x1,y1+1,x1+PetiteMarge,y2-1));
            Brush.Color:=coul;
            moveto(x1,y1);
            LineTo(x1,y2);
            moveto(x1+PetiteMarge,y1);
            LineTo(x1+PetiteMarge,y2);
            end;
         ChaineLaTex:=TStringList(Argument[i])[4*jj+2];
         if pos('||',ChaineLatex)>0
         	then begin
            coul:=Brush.Color;
            Brush.Color:=clWhite;
            FillRect(Classes.Rect(x2-PetiteMarge,y1+1,x2,y2-1));
            Brush.Color:=coul;
            moveto(x2-PetiteMarge,y1);
            LineTo(x2-PetiteMarge,y2);
            moveto(x2-1,y1);
            LineTo(x2-1,y2);
            end;
      	if LignesVar.IndexOf(Inttostr(i))=-1 // si ce n'est pas une ligne de variations
         	then begin
         	for k:=-1 to 2
         		do begin
      			if Formule[i,4*jj+k]<>Nil
      				then begin
         			BMP.Assign(Formule[i,4*jj+k]);
            		w:=BMP.Width;
            		h:=BMP.Height;
                  y:=(y1+y2-h) div 2;
            		If k=-1 then x:=x1+1-w div 2;
            		If k=0 then x:=x1+GrandeMarge;
            		If k=1 then x:=(x1+x2-w+1) div 2;
            		If k=2 then x:=(x2-GrandeMarge-w);
         			Draw(x,y,BMP);
         			end;
            	end;
            end;
         x1:=x2;
      	end;
      if LignesVar.IndexOf(Inttostr(i))>-1 // si c'est une ligne de variations
         then begin
         jj1:=1;
         repeat
            while (not DebutFleche(i,jj1)) and (jj1<cc-1) do inc(jj1);
            jj2:=jj1;
            while (not FinFleche(i,jj2)) and (jj2<cc) do inc(jj2);
            x1:=wColTitres+(jj1-1)*wCols;
            x2:=x1+(jj2-jj1+1)*wCols;
            ChaineLaTex:=TStringList(Argument[i])[4*jj1+1];
            if ChaineLatex='/>'  //si croissante
               then begin
               SensVar:=1;
               xf1:=x1+GrandeMarge;
               yf1:=y2-PetiteMarge;
               xf2:=x2-GrandeMarge;
               yf2:=y1+PetiteMarge;
               end;
            if ChaineLatex='\>'  //si dcroissante
               then begin
               SensVar:=-1;
               xf1:=x1+GrandeMarge;
               yf1:=y1+PetiteMarge;
               xf2:=x2-GrandeMarge;
               yf2:=y2-PetiteMarge;
               end;
            if ChaineLatex='_>'  //si constante
               then begin
               SensVar:=0;
               xf1:=x1+GrandeMarge;
               xf2:=x2-GrandeMarge;
               case PositionPlateau(i,jj1) of
               	-1:yf1:=y2-PetiteMarge;
                  0 :yf1:=(y1+y2) div 2;
                  1 :yf1:=y1+PetiteMarge;
                  end;
               yf2:=xf1;
               end;
      		if (Formule[i,4*jj1-1]<>Nil)
   				then begin
   				BMP.Assign(Formule[i,4*jj1-1]);
   				w1:=BMP.Width;
         		h1:=BMP.Height;
         		if SensVar=1
         			then begin
                  xc1:=x1;
                  yc1:=y2-PetiteMarge-h1 div 2;
                  Draw(xc1-w1 div 2,yc1-h1 div 2,BMP);
                  end;
         		if SensVar=-1
         			then begin
                  xc1:=x1;
                  yc1:=y1+PetiteMarge+h1 div 2;
                  Draw(xc1-w1 div 2,yc1-h1 div 2,BMP);
                  end;
         		if SensVar=0
         			then begin
                  xc1:=x1;
               	case PositionPlateau(i,jj1) of
               		-1:yc1:=y2-PetiteMarge-h1 div 2;
                  	0 :yc1:=(y1+y2) div 2;
                  	1 :yc1:=y1+PetiteMarge+h1 div 2;
                     end;
                  Draw(xc1-w1 div 2,yc1-h1 div 2,BMP);
                  end;
   				end;
            if (Formule[i,4*jj1]<>Nil)
   		      then begin
   		      BMP.Assign(Formule[i,4*jj1]);
   		      w1:=BMP.Width;
               h1:=BMP.Height;
         		if SensVar=1
         			then begin
                  xc1:=x1+GrandeMarge+w1 div 2;
                  yc1:=y2-PetiteMarge-h1 div 2;
                  Draw(xc1-w1 div 2,yc1-h1 div 2,BMP);
                  end;
         		if SensVar=-1
         			then begin
                  xc1:=x1+GrandeMarge+w1 div 2;
                  yc1:=y1+PetiteMarge+h1 div 2;
                  Draw(xc1-w1 div 2,yc1-h1 div 2,BMP);
                  end;
         		if SensVar=0
         			then begin
                  xc1:=x1+GrandeMarge+w1 div 2;
               	case PositionPlateau(i,jj1) of
               		-1:yc1:=y2-PetiteMarge-h1 div 2;
                  	0 :yc1:=(y1+y2) div 2;
                  	1 :yc1:=y1+PetiteMarge+h1 div 2;
                     end;
                 Draw(xc1-w1 div 2,yc1-h1 div 2,BMP);
                  end;
   		      end;
            if (Formule[i,4*jj1-1]=Nil) and (Formule[i,4*jj1]=Nil)//si pas de formule
   		      then begin
   		      w1:=2*GrandeMarge;
               h1:=2*PetiteMarge;
         		if SensVar=1
         			then begin
                  xc1:=x1+GrandeMarge+w1 div 2;
                  yc1:=y2-PetiteMarge-h1 div 2;
                  end;
         		if SensVar=-1
         			then begin
                  xc1:=x1+GrandeMarge+w1 div 2;
                  yc1:=y1+PetiteMarge+h1 div 2;
                  end;
         		if SensVar=0
         			then begin
                  xc1:=x1+GrandeMarge+w1 div 2;
               	case PositionPlateau(i,jj1) of
               		-1:yc1:=y2-PetiteMarge-h1 div 2;
                  	0 :yc1:=(y1+y2) div 2;
                  	1 :yc1:=y1+PetiteMarge+h1 div 2;
                     end;
                  end;
   		      end;
            if (Formule[i,4*jj2+2]<>Nil)
   		      then begin
   		      BMP.Assign(Formule[i,4*jj2+2]);
   		      w2:=BMP.Width;
               h2:=BMP.Height;
         		if SensVar=1
         			then begin
                  xc2:=x2-GrandeMarge-w2 div 2;
                  yc2:=y1+PetiteMarge+h2 div 2;
                  Draw(xc2-w2 div 2,yc2-h2 div 2,BMP);
                  end;
         		if SensVar=-1
         			then begin
                  xc2:=x2-GrandeMarge-w2 div 2;
                  yc2:=y2-PetiteMarge-h2 div 2;
                  Draw(xc2-w2 div 2,yc2-h2 div 2,BMP);
                  end;
         		if SensVar=0
         			then begin
                  xc2:=x2-GrandeMarge-w2 div 2;
                  yc2:=yc1;
                  Draw(xc2-w2 div 2,yc2-h2 div 2,BMP);
                  end;
   		      end;
      		if (jj2<cc-1)  //si nous ne sommes pas en fin de ligne
            	then begin
               If (Formule[i,4*jj2+3]<>Nil)
   					then begin
   					BMP.Assign(Formule[i,4*jj2+3]);
   					w2:=BMP.Width;
         			h2:=BMP.Height;
         			if SensVar=1
         				then begin
                  	xc2:=x2;
                  	yc2:=y1+PetiteMarge+h2 div 2;
                  	end;
         			if SensVar=-1
         				then begin
                  	xc2:=x2;
                  	yc2:=y2-PetiteMarge-h2 div 2;
                  	end;
         			if SensVar=0
         				then begin
                  	xc2:=x2;
                     yc2:=yc1;
                     end;
   					end;
					If (Formule[i,4*jj2+3]=Nil) and (Formule[i,4*jj2+2]=Nil)//pas de formule
               	then begin
   					w2:=2*GrandeMarge;
         			h2:=2*PetiteMarge;
         			if SensVar=1
         				then begin
                  	xc2:=x2;
                  	yc2:=y1+PetiteMarge+h2 div 2;
                  	end;
         			if SensVar=-1
         				then begin
                  	xc2:=x2;
                  	yc2:=y2-PetiteMarge-h2 div 2;
                  	end;
         			if SensVar=0
         				then begin
                  	xc2:=x2;
                  	yc2:=yc1;
                  	end;
                  end;
               end else begin //si fin de ligne, Formule[i,4*jj2+3] n'existe pas
					If Formule[i,4*jj2+2]=Nil
               	then begin
   					w2:=2*GrandeMarge;
         			h2:=2*PetiteMarge;
         			if SensVar=1
         				then begin
                     xc2:=x2-GrandeMarge-w2 div 2;
                  	yc2:=y1+PetiteMarge+h2 div 2;
                  	end;
         			if SensVar=-1
         				then begin
                  	xc2:=x2-GrandeMarge-w2 div 2;
                  	yc2:=y2-PetiteMarge-h2 div 2;
                  	end;
         			if SensVar=0
         				then begin
                  	xc2:=x2-GrandeMarge-w2 div 2;
                  	yc2:=yc1;
                  	end;
                  end;
               end;
            if xc2<>xc1 then PenteFleche:=(1.0*(yc2-yc1))/(1.0*(xc2-xc1)) else PenteFleche:=0;
            xf1:=xc1+w1 div 2+PetiteMarge;
            yf1:=yc1+Round(PenteFleche*(xf1-xc1));
            xf2:=xc2-w2 div 2-PetiteMarge;
            yf2:=yc2+Round(PenteFleche*(xf2-xc2));
            JolieFleche(xf1,yf1,xf2,yf2);
            m:=jj2-jj1+1;//nombre de sous-intervalles de l'intervalle de monotonie
            for k:=1 to m-1
            	do begin
               x:=((m-k)*x1+k*x2) div m;
               y:=yc1+Round(PenteFleche*(x-xc1));
            	if (Formule[i,4*(jj1+k)-1]<>Nil)
   		      	then begin
   		      	BMP.Assign(Formule[i,4*(jj1+k)-1]);
   					w:=BMP.Width;
         			h:=BMP.Height;
                  Draw(x-w div 2,y-h div 2,BMP);
                  end;
               end;
         	if jj1<cc-1
            	then repeat inc(jj1) until (DebutFleche(i,jj1))or (jj1=cc-1)
               else jj1:=cc;
            if (jj1=cc-1) and not(DebutFleche(i,jj1))  then jj1:=cc;
            jj2:=jj1;
            until jj1=cc;
         end;     //fin ligne variations
      y1:=y2;
   	end;
   end;  //fin dessin tableau
Formule:=nil;
GIF.Free;
BMP.Free;
BMP_HR.Free;
LignesVar.Free;
Argument.Free;
end;

procedure TfmTableauVarSgn.SupprimeFormattage(LignesTableau:TStringList;var ChaineTableau:string);
var                      //fusionne toutes les lignes et supprime les espaces non ncessaires
   i,n:integer;
   Function DansBoiteTexte(Chaine:string;i:integer):boolean;
   var j,profondeur:integer;
   begin
   Result:=False;
   if i<7 then exit;
   profondeur:=0;
   j:=i;
   repeat
      j:=j-1;
      if chaine[j]='{' then profondeur:=profondeur+1;
      if chaine[j]='}' then profondeur:=profondeur-1;
      if (copy(chaine,j-5,6)='\text{') and (profondeur=1) then Result:=True;
      until (Result=True)or (j<7);
   end;
begin
n:=LignesTableau.Count;
if n=0 then exit;
ChaineTableau:=LignesTableau[0];
for i:=1 to n-1
	do begin
   ChaineTableau:=ChaineTableau+'\\'+LignesTableau[i];
   end;
n:=length(ChaineTableau);
if n=0 then exit;
for i:=n downto 1
	do begin
   if (ChaineTableau[i]=' ')and not(DansBoiteTexte(ChaineTableau,i)) then delete(ChaineTableau,i,1);
   end;
CodeTableau:=ChaineTableau;
end;

procedure TfmTableauVarSgn.Formatte(ChaineTableau:string;LignesTableau:TStringList);
var                    //dcompose en lignes et insre espaces pour une meilleure lisibilit
   i,j,l,c,n,max,q:integer;
   chaine:string;
   Argument:TObjectList;
begin
Argument:=TObjectList.Create;
LignesTableau.Clear;
DecodeItemsTableau(ChaineTableau,Argument);
l:=Argument.Count;
c:=TStringList(Argument[0]).count;
for j:=0 to c-1
	do begin
   max:=0;
   for i:=0 to l-1
   	do begin
      n:=length(TStringList(Argument[i])[j]);
      if n>max then max:=n;
      end;
   if max>0
   	then begin
   	for i:=0 to l-1
   		do begin
      	chaine:=TStringList(Argument[i])[j];
      	n:=length(chaine);
         chaine:=chaine+StringOfChar(' ',max-n);
      	TStringList(Argument[i])[j]:=Chaine;
      	end;
      end;
   end;
for i:=0 to l-1
	do begin
   chaine:='[';
   for j:=0 to c-1
   	do begin
      q:=j mod 4;
      if q=0 then chaine:=chaine+TStringList(Argument[i])[j]+':';
      if q=1 then chaine:=chaine+TStringList(Argument[i])[j]+':';
      if q=2 then chaine:=chaine+TStringList(Argument[i])[j]+']';
      if q=3 then chaine:=chaine+TStringList(Argument[i])[j]+'[';
      end;
   LignesTableau.add(chaine);
   end;
Argument.Free;
end;

procedure TfmTableauVarSgn.FormShow(Sender: TObject);
var
	chaine,chaineDefaut:String;
   listechaines:TStringList;
begin
listechaines:=TStringList.create;
chaineDefaut:='[:x:]|[-\infty::]-3[::+\infty]\\[:f''(x):]|[:-:]|0[:+:]\\[:f(x):]|[+\infty:\>:]2[:/>:+\infty]';
NbLignes:=3;
NbColonnes:=3;
listechaines.Assign(memo1.lines);
SupprimeFormattage(listechaines,Chaine);
if Chaine=chaineDefaut then Apercu;
listechaines.Free;
end;

procedure TfmTableauVarSgn.ButtonApercuClick(Sender: TObject);
begin
EffacerDessin;
Apercu;
end;

procedure TfmTableauVarSgn.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
//Argument.Free;
end;

procedure TfmTableauVarSgn.btEffacerToutClick(Sender: TObject);
begin
EffacerDessin;
end;

procedure TfmTableauVarSgn.tbPinfClick(Sender: TObject);
begin
if Memo1.SelStart=0 then Memo1.SelStart:=1;
Memo1.SelText := '+\infty';
end;

procedure TfmTableauVarSgn.tbMinfClick(Sender: TObject);
begin
if Memo1.SelStart=0 then Memo1.SelStart:=1;
Memo1.SelText := '-\infty';
end;

procedure TfmTableauVarSgn.tbFormuleClick(Sender: TObject);
begin
if Memo1.SelStart=0 then Memo1.SelStart:=1;
Memo1.SelText := '\frac{3}{4}';
end;

procedure TfmTableauVarSgn.tbHachuresClick(Sender: TObject);
begin
if Memo1.SelStart=0 then Memo1.SelStart:=1;
Memo1.SelText := '//';
end;

procedure TfmTableauVarSgn.tbFiletVerticalClick(Sender: TObject);
begin
if Memo1.SelStart=0 then Memo1.SelStart:=1;
Memo1.SelText := '|';
end;

procedure TfmTableauVarSgn.tbDoubleFiletClick(Sender: TObject);
begin
if Memo1.SelStart=0 then Memo1.SelStart:=1;
Memo1.SelText := '||';
end;

procedure TfmTableauVarSgn.tbFiletZeroClick(Sender: TObject);
begin
if Memo1.SelStart=0 then Memo1.SelStart:=1;
Memo1.SelText := '|0';
end;

procedure TfmTableauVarSgn.tbFlecheAscClick(Sender: TObject);
begin
if Memo1.SelStart=0 then Memo1.SelStart:=1;
Memo1.SelText := '/>';
end;

procedure TfmTableauVarSgn.tbFlecheDescClick(Sender: TObject);
begin
if Memo1.SelStart=0 then Memo1.SelStart:=1;
Memo1.SelText := '\>';
end;

procedure TfmTableauVarSgn.tbFlecheHorzClick(Sender: TObject);
begin
if Memo1.SelStart=0 then Memo1.SelStart:=1;
Memo1.SelText := '_>';
end;

procedure TfmTableauVarSgn.tbNouvelleLigneClick(Sender: TObject);
var
	i:integer;
	LigneVide,chaine:string;
   listechaines:TStringList;
begin
listechaines:=TStringList.Create;
LigneVide:='';
For i:=1 to NbColonnes
	do begin
   LigneVide:=LigneVide+'[::]';
   end;
Memo1.Lines.Insert(memo1.Caretpos.y+1,LigneVide);
listechaines.Assign(memo1.lines);
SupprimeFormattage(listechaines,Chaine);
Formatte(Chaine,listechaines);
memo1.Lines.Assign(listechaines);
NbLignes:=listechaines.count;
Label2.Caption:='Tableau '+inttostr(NbLignes)+''+inttostr(NbColonnes);
listechaines.Free;
end;

procedure TfmTableauVarSgn.tbSupprimerLigneClick(Sender: TObject);
var
	i:integer;
   listechaines:TStringList;
begin
If NbLignes<3 then Exit;
listechaines:=TStringList.Create;
listechaines.Assign(memo1.lines);
if memo1.caretpos.y<listechaines.Count
	then i:=memo1.caretpos.y
   else i:=listechaines.Count-1;
listechaines.Delete(i);
memo1.Lines.Assign(listechaines);
NbLignes:=listechaines.count;
Label2.Caption:='Tableau '+inttostr(NbLignes)+''+inttostr(NbColonnes);
listechaines.Free;
end;

procedure TfmTableauVarSgn.tbNouvelleColonneClick(Sender: TObject);
var
	i,j,kol:integer;
	Ligne,Chaine:string;
   listechaines:TStringList;
   function Pos2Col(chaine:String;i:integer):integer;//numro de la "grande colonne"  l'emplacement du curseur
   var cc,j:integer;                               // la premire tant 0
   begin
   if length(chaine)<2
   	then begin
      Result:=0;
      Exit;
      end;
   cc:=0;
   For j:=i downto 1
   	do begin
      if chaine[j]=']' then inc(cc);
      end;
   Result:=cc;
   end;
   function Col2Pos(chaine:String;cc:integer):integer;//position d'insertion de la nouvelle colonne
   var c,i:integer;                                   // la premire tant 0
   begin
   if cc=0
   	then begin
      Result:=1;
      Exit;
      end;
   c:=0;
   i:=0;
   while c<cc
   	do begin
      inc(i);
      if chaine[i]=']' then inc(c);
      end;
   Result:=i+1;
   end;
begin
listechaines:=TStringList.Create;
listechaines.Assign(memo1.lines);
i:=Memo1.CaretPos.Y;
if i>listechaines.Count-1 then i:=listechaines.Count-1;
Ligne:=listechaines[i];
j:=memo1.Caretpos.x;
kol:=Pos2Col(Ligne,j);
For i:=0 to NbLignes-1
	do begin
   Ligne:=listechaines[i];
   j:=Col2Pos(Ligne,Kol);
   Insert('[::]',Ligne,j);
   ListeChaines[i]:=Ligne;
   end;
SupprimeFormattage(listechaines,Chaine);
Formatte(Chaine,listechaines);
memo1.Lines.Assign(listechaines);
Inc(NbColonnes);
Label2.Caption:='Tableau '+inttostr(NbLignes)+''+inttostr(NbColonnes);
listechaines.Free;
end;

procedure TfmTableauVarSgn.tbSupprimerColonneClick(Sender: TObject);
var
	i,j,k,kol:integer;
	Ligne,Chaine:string;
   listechaines:TStringList;
   function Pos2Col(chaine:String;i:integer):integer;//numro de la colonne  supprimer  l'emplacement du curseur
   var cc,j:integer;                               // la premire colonne tant 0
   begin
   if i=0
   	then begin
      Result:=0;
      Exit;
      end;
   cc:=-1;
   For j:=1 to i
   	do begin
      if chaine[j]='[' then inc(cc);
      end;
   Result:=cc;
   end;
   function DebutCol(chaine:String;cc:integer):integer;//position du premier caractre de la colonne cc
   var c,i:integer;                                   // la premire tant 0
   begin                                              // une colonne va de [ inclus  [ exclu
   c:=-1;
   i:=0;
   while c<cc
   	do begin
      inc(i);
      if chaine[i]='[' then inc(c);
      end;
   Result:=i;
   end;
   function FinCol(chaine:String;cc:integer):integer;//position du dernier caractre de la colonne cc
   var                                               // c-a-d celui juste avant [
   	c,i:integer;
      ch:string;                                   
   begin
   ch:=chaine+'[';
   c:=-1;
   i:=0;
   while c<=cc
   	do begin
      inc(i);
      if ch[i]='[' then inc(c);
      end;
   Result:=i-1;
   end;
begin
If Nbcolonnes<3 then Exit;
listechaines:=TStringList.Create;
listechaines.Assign(memo1.lines);
i:=Memo1.CaretPos.Y;
if i>listechaines.Count-1 then i:=listechaines.Count-1;
Ligne:=listechaines[i];
j:=memo1.Caretpos.x;
kol:=Pos2Col(Ligne,j);//numro de la colonne  supprimer
if kol=NbColonnes then Kol:=Kol-1;
For i:=0 to NbLignes-1
	do begin
   Ligne:=listechaines[i];
   j:=DebutCol(Ligne,Kol);
   k:=FinCol(Ligne,Kol);
   Delete(Ligne,j,k-j+1);
   ListeChaines[i]:=Ligne;
   end;
SupprimeFormattage(listechaines,Chaine);
Formatte(Chaine,listechaines);
memo1.Lines.Assign(listechaines);
NbColonnes:=NbColonnes-1;
Label2.Caption:='Tableau '+inttostr(NbLignes)+''+inttostr(NbColonnes);
listechaines.Free;
end;

procedure TfmTableauVarSgn.Memo1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
	chaine: string;
   listechaines: TStringList;
   i,j:integer;
begin
listechaines:= TStringList.Create;
j:=memo1.Caretpos.x;
i:=memo1.Caretpos.y;
listechaines.Assign(memo1.lines);
SupprimeFormattage(listechaines,Chaine);
Formatte(Chaine,listechaines);
memo1.Lines.Assign(listechaines);
NbLignes:=listechaines.Count;
Nbcolonnes:=DenombreColonnes(listeChaines[0]);
Label2.Caption:='Tableau '+inttostr(NbLignes)+''+inttostr(NbColonnes);
memo1.Caretpos:=Point(j,i);
listechaines.Free;
end;

procedure TfmTableauVarSgn.ButtonExVar1Click(Sender: TObject);
var
   chaine:string;
   listechaines:TStringList;
begin
listechaines:=TStringlist.create;
memo1.Lines.Clear;
memo1.Lines.Add('[:x    :]|[-\infty:  :]5[:  :+\infty]');
//memo1.Lines.Add('[:\array{text{variations}\\text{de}f(x)}:]|[:/>:]2[:\>:]');
memo1.Lines.Add('[:f(x):]|[:/>:]2[:\>:]');
listechaines.Assign(memo1.lines);
SupprimeFormattage(listechaines,Chaine);
Formatte(Chaine,listechaines);
memo1.Lines.Assign(listechaines);
NbLignes:=listechaines.Count;
Nbcolonnes:=DenombreColonnes(listeChaines[0]);
Label2.Caption:='Tableau '+inttostr(NbLignes)+''+inttostr(NbColonnes);
listechaines.Free;
EffacerDessin;
Apercu;
end;

procedure TfmTableauVarSgn.ButtonExVar2Click(Sender: TObject);
var
   chaine:string;
   listechaines:TStringList;
begin
listechaines:=TStringlist.create;
memo1.Lines.Clear;
memo1.Lines.Add('[:x:]|[-1::]1[::]2[::4]');
memo1.Lines.Add('[:\array{\text{Variations}\\ \text{de }f(x)}:]|[0:/>:]4[:_>:]4[:\>:-3]');
listechaines.Assign(memo1.lines);
SupprimeFormattage(listechaines,Chaine);
Formatte(Chaine,listechaines);
memo1.Lines.Assign(listechaines);
NbLignes:=listechaines.Count;
Nbcolonnes:=DenombreColonnes(listeChaines[0]);
Label2.Caption:='Tableau '+inttostr(NbLignes)+''+inttostr(NbColonnes);
listechaines.Free;
EffacerDessin;
Apercu;
end;


procedure TfmTableauVarSgn.ButtonExVar3Click(Sender: TObject);
var
   chaine:string;
   listechaines:TStringList;
begin
listechaines:=TStringlist.create;
memo1.Lines.Clear;
memo1.Lines.Add('[:x:]|[-\infty::]-3[::+\infty]');
memo1.Lines.Add('[:f''(x):]|[:-:]|0[:+:]');
memo1.Lines.Add('[:f(x):]|[+\infty:\>:]2[:/>:+\infty]');
listechaines.Assign(memo1.lines);
SupprimeFormattage(listechaines,Chaine);
Formatte(Chaine,listechaines);
memo1.Lines.Assign(listechaines);
NbLignes:=listechaines.Count;
Nbcolonnes:=DenombreColonnes(listeChaines[0]);
Label2.Caption:='Tableau '+inttostr(NbLignes)+''+inttostr(NbColonnes);
listechaines.Free;
EffacerDessin;
Apercu;
end;

procedure TfmTableauVarSgn.ButtonExVar4Click(Sender: TObject);
var
   chaine:string;
   listechaines:TStringList;
begin
listechaines:=TStringlist.create;
memo1.Lines.Clear;
memo1.Lines.Add('[:x    : ]|[-\infty:  :]-1[:  : ]0            [:  :1]');
memo1.Lines.Add('[:f''(x):]|[: - :      ]|0[: + :]|0           [: + :||]');
memo1.Lines.Add('[:f(x):  ]|[ 1:\>     :]0 [:/>:   ] \frac{1}{2}[:/> :  +\infty  ||   ]');
listechaines.Assign(memo1.lines);
SupprimeFormattage(listechaines,Chaine);
Formatte(Chaine,listechaines);
memo1.Lines.Assign(listechaines);
NbLignes:=listechaines.Count;
Nbcolonnes:=DenombreColonnes(listeChaines[0]);
Label2.Caption:='Tableau '+inttostr(NbLignes)+''+inttostr(NbColonnes);
listechaines.Free;
EffacerDessin;
Apercu;
end;

procedure TfmTableauVarSgn.ButtonExVar5Click(Sender: TObject);
var
   chaine:string;
   listechaines:TStringList;
begin
listechaines:=TStringlist.create;
memo1.Lines.Clear;
memo1.Lines.Add('[:x:]|[0::]\frac{\sqrt{2}}{2}[::+\infty]');
memo1.Lines.Add('[:g''(x):]||[:-:]|0[:+:]');
memo1.Lines.Add('[:g(x):]||[ +\infty:\>:]\frac{3+\text{ln2}}{2}[:/>:+\infty]]');
listechaines.Assign(memo1.lines);
SupprimeFormattage(listechaines,Chaine);
Formatte(Chaine,listechaines);
memo1.Lines.Assign(listechaines);
NbLignes:=listechaines.Count;
Nbcolonnes:=DenombreColonnes(listeChaines[0]);
Label2.Caption:='Tableau '+inttostr(NbLignes)+''+inttostr(NbColonnes);
listechaines.Free;
EffacerDessin;
Apercu;
end;

procedure TfmTableauVarSgn.ButtonExVar6Click(Sender: TObject);
var
   chaine:string;
   listechaines:TStringList;
begin
listechaines:=TStringlist.create;
memo1.Lines.Clear;
memo1.Lines.Add('[:x:]|[0::]\frac{\pi}{6}[::]\frac{5\pi}{6}[::]\frac{3\pi}{2}[::2\pi]');
memo1.Lines.Add('[:f''(x):]|[:+:]|0[:-:]|0[:+:]|0[:+:]');
memo1.Lines.Add('[:f(x):]|[2:/>:]\frac{3\sqrt{3}}{2}[:\>:]-\frac{3\sqrt{3}}{2}[:/>:]0[:/>:2]');
listechaines.Assign(memo1.lines);
SupprimeFormattage(listechaines,Chaine);
Formatte(Chaine,listechaines);
memo1.Lines.Assign(listechaines);
NbLignes:=listechaines.Count;
Nbcolonnes:=DenombreColonnes(listeChaines[0]);
Label2.Caption:='Tableau '+inttostr(NbLignes)+''+inttostr(NbColonnes);
listechaines.Free;
EffacerDessin;
Apercu;
end;


procedure TfmTableauVarSgn.ButtonExVar7Click(Sender: TObject);
var
   chaine:string;
   listechaines:TStringList;
begin
listechaines:=TStringlist.create;
memo1.Lines.Clear;
memo1.Lines.Add('[:x    : ]|[-2:  :]-1[:  : ]1            [:  :2]');
memo1.Lines.Add('[:f''(x):]|[: - :      ]||[: // :]||           [: + :]');
memo1.Lines.Add('[:f(x):  ]|[\sqrt{3}:\>     :0]| [://:   ]||[-\infty:/> :  \sqrt{3}  ]');
listechaines.Assign(memo1.lines);
SupprimeFormattage(listechaines,Chaine);
Formatte(Chaine,listechaines);
memo1.Lines.Assign(listechaines);
NbLignes:=listechaines.Count;
Nbcolonnes:=DenombreColonnes(listeChaines[0]);
Label2.Caption:='Tableau '+inttostr(NbLignes)+''+inttostr(NbColonnes);
listechaines.Free;
EffacerDessin;
Apercu;
end;

procedure TfmTableauVarSgn.ButtonExVar8Click(Sender: TObject);
var
   chaine:string;
   listechaines:TStringList;
begin
listechaines:=TStringlist.create;
memo1.Lines.Clear;
memo1.Lines.Add('[:t    : ]|[-\infty:  :]t_2[:  : ]-3[:  :]0[:  :]t_5[:  :]3[:  :]t_7[:  :]t_8[:  :+\infty]');
memo1.Lines.Add('[:x''(t): ]|[: + :]0|[:- : ]||[: - :]0|[: + :]|[: - :]||[: - :]|[: - :]0|[: + :]');
memo1.Lines.Add('[:x(t)    : ]|[-\infty:/> :]x_2[:\> :-\infty ]||[+\infty: \> :]0[: \> :]x_5[: \> :-\infty]||[+\infty: \> :]x_7[: \> :]x_8[:/>  :+\infty]');
memo1.Lines.Add('[:y''(t): ]|[: + :]|[:+ : ]|[: + :]|[: + :]|0[: - :]||[: - :]|0[: + :]|[: + :]');
memo1.Lines.Add('[:y(t)    : ]|[-\infty:/> :]y_2[: /> : ]-\frac{5}{2}[: /> :]0[: /> :]y_5[: \> :-\infty]||[+\infty: \> :]y_7[: /> :]y_8[:/>  :+\infty]');
listechaines.Assign(memo1.lines);
SupprimeFormattage(listechaines,Chaine);
Formatte(Chaine,listechaines);
memo1.Lines.Assign(listechaines);
NbLignes:=listechaines.Count;
Nbcolonnes:=DenombreColonnes(listeChaines[0]);
Label2.Caption:='Tableau '+inttostr(NbLignes)+''+inttostr(NbColonnes);
listechaines.Free;
EffacerDessin;
Apercu;
end;

procedure TfmTableauVarSgn.ButtonExSgn1Click(Sender: TObject);
var
   chaine:string;
   listechaines:TStringList;
begin
listechaines:=TStringlist.create;
memo1.Lines.Clear;
memo1.Lines.Add('[:x    : ]|[-\infty:  :]-2[:  : ]1[:  :+\infty]');
memo1.Lines.Add('[:x-1: ]|[: - :]|[:- : ]0|[: + :]');
memo1.Lines.Add('[:x+2: ]|[:-:]0|[:+ : ]|[: + :]');
memo1.Lines.Add('[:\frac{x-1}{x+2}: ]|[: + :]||[:- : ]0|[: + :]');
listechaines.Assign(memo1.lines);
SupprimeFormattage(listechaines,Chaine);
Formatte(Chaine,listechaines);
memo1.Lines.Assign(listechaines);
NbLignes:=listechaines.Count;
Nbcolonnes:=DenombreColonnes(listeChaines[0]);
Label2.Caption:='Tableau '+inttostr(NbLignes)+''+inttostr(NbColonnes);
listechaines.Free;
EffacerDessin;
Apercu;
end;

procedure TfmTableauVarSgn.ButtonExAbs1Click(Sender: TObject);
var
   chaine:string;
   listechaines:TStringList;
begin
listechaines:=TStringlist.create;
memo1.Lines.Clear;
memo1.Lines.Add('[:x    : ]|[-\infty:  :]-4[:  : ]\frac{5}{2}[:  :+\infty]');
memo1.Lines.Add('[:2x-5: ]|[: - :]|[:- : ]0|[: + :]');
memo1.Lines.Add('[:\left|2x-5\right|: ]|[:5-2x:]|[:5-2x: ]|[:2x-5:]');
memo1.Lines.Add('[:x+4: ]|[: - :]|0[:+ : ]|[: + :]');
memo1.Lines.Add('[:\left|x+4\right|: ]|[:-x-4:]|[:x+4: ]|[:x+4:]');
memo1.Lines.Add('[:\left|2x-5\right|+\left|x+4\right|: ]|[:1-3x:]|[:9-x: ]|[:3x-1:]');
listechaines.Assign(memo1.lines);
SupprimeFormattage(listechaines,Chaine);
Formatte(Chaine,listechaines);
memo1.Lines.Assign(listechaines);
NbLignes:=listechaines.Count;
Nbcolonnes:=DenombreColonnes(listeChaines[0]);
Label2.Caption:='Tableau '+inttostr(NbLignes)+''+inttostr(NbColonnes);
listechaines.Free;
EffacerDessin;
Apercu;
end;

procedure TfmTableauVarSgn.Label4Click(Sender: TObject);
begin
ShellExecute(0, 'OPEN', 'mailto:patrick.pradeau@gmail.com', nil, nil, sw_shownormal);
end;

procedure TfmTableauVarSgn.bbCouleurTraitsClick(Sender: TObject);
var
	CouleurAvant : TColor;
   Glyphe       : TBitmap;
begin
	Glyphe:=TBitmap.Create;
   Glyphe.Assign(bbCouleurTraits.Glyph);
   CouleurAvant:=cdCouleurTraits.Color;
   if not cdCouleurTraits.Execute then cdCouleurTraits.Color:=CouleurAvant;
   With Glyphe.Canvas do
   	begin
      Brush.Color:=cdCouleurTraits.Color;
   	FillRect(Classes.Rect(2,2,18,18));
   	end;
   bbCouleurTraits.Glyph.Assign(Glyphe);
   Glyphe.Free;
end;

procedure TfmTableauVarSgn.bbCouleurTextesClick(Sender: TObject);
begin
Couleurs.Showmodal;
end;

procedure TfmTableauVarSgn.bbAideClick(Sender: TObject);
begin
   Aide(83);
end;

end.
